﻿'From etoys2.2 of 1 October 2007 [latest update: #1675] on 7 December 2007 at 1:11:58 pm'!
"Change Set:		Games-DiceWars
Date:			7 December 2007
Author:			Robert Krahn

Authors: Philipp Dobrigkeit, Peter Faymonville, and Tobias Flach

Hasso-Plattner-Institut
Software Architecture Group
http://www.hpi.uni-potsdam.de/swa/"!

Object subclass: #DWGame
	instanceVariableNames: 'gui sectors currentPlayer players state currentMove unusedColors abort'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-DiceWars'!
BorderedMorph subclass: #DWGUI
	instanceVariableNames: 'game mappanel movepanel playerlistpanel turnbutton gamebutton addbutton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-DiceWars'!

!DWGUI commentStamp: '<historical>' prior: 0!
THIS CLASS HAS NO COMMENT!!!

DWGUI class
	instanceVariableNames: 'color2dice'!
PolygonMorph subclass: #DWHexagon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-DiceWars'!
Morph subclass: #DWLauncherMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-DiceWars'!
Object subclass: #DWMapMaker
	instanceVariableNames: 'size numSectors sectors fieldGrid game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-DiceWars'!
Object subclass: #DWMove
	instanceVariableNames: 'baseSector targetSector baseDices targetDices previousOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-DiceWars'!
Object subclass: #DWPlayer
	instanceVariableNames: 'game sectors color ai buffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-DiceWars'!
Object subclass: #DWPlayerAI
	instanceVariableNames: 'game player depth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-DiceWars'!
PolygonMorph subclass: #DWSector
	instanceVariableNames: 'neighbors currentOwner dices game numDices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-DiceWars'!
Object subclass: #DWSectorMaker
	instanceVariableNames: 'mapMaker canGrow origin fields neighbors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-DiceWars'!

!DWGame methodsFor: 'accessing' stamp: 'DH 1/4/2007 17:16'!
getAbort
	^ abort! !

!DWGame methodsFor: 'accessing' stamp: 'DF 12/21/2006 21:58'!
getCurrentMove
	^ currentMove! !

!DWGame methodsFor: 'accessing' stamp: 'DH 11/28/2006 17:27'!
getCurrentPlayer
	^ currentPlayer! !

!DWGame methodsFor: 'accessing' stamp: 'DF 1/30/2007 16:04'!
getGui
	^ gui! !

!DWGame methodsFor: 'accessing' stamp: 'DH 12/13/2006 17:00'!
getPlayers
	^ players! !

!DWGame methodsFor: 'accessing' stamp: 'DH 12/13/2006 17:00'!
getSectors
	^ sectors! !

!DWGame methodsFor: 'accessing' stamp: 'DH 11/28/2006 17:27'!
getState
	^ state! !

!DWGame methodsFor: 'accessing' stamp: 'DF 1/22/2007 19:13'!
getUnusedColors
	^ unusedColors! !

!DWGame methodsFor: 'accessing' stamp: 'DH 1/4/2007 17:16'!
setAbortFalse
	abort := false! !

!DWGame methodsFor: 'accessing' stamp: 'DH 1/4/2007 17:16'!
setAbortTrue
	abort := true! !

!DWGame methodsFor: 'accessing' stamp: 'DF 12/21/2006 21:58'!
setCurrentMove: aMove
	currentMove := aMove! !

!DWGame methodsFor: 'accessing' stamp: 'DF 12/21/2006 21:58'!
setCurrentPlayer: aPlayer
	currentPlayer := aPlayer! !

!DWGame methodsFor: 'accessing' stamp: 'DF 12/21/2006 21:59'!
setGui: aGui
	gui := aGui! !

!DWGame methodsFor: 'accessing' stamp: 'DF 12/21/2006 21:59'!
setPlayers: aPlayerCollection
	players := aPlayerCollection! !

!DWGame methodsFor: 'accessing' stamp: 'DF 12/21/2006 22:00'!
setSectors: aSectorCollection
	sectors := aSectorCollection! !

!DWGame methodsFor: 'accessing' stamp: 'DF 12/21/2006 22:00'!
setState: aState
	state := aState! !

!DWGame methodsFor: 'accessing' stamp: 'DF 1/3/2007 11:50'!
setUnusedColors: aSet
	unusedColors := aSet! !

!DWGame methodsFor: 'initialization' stamp: 'MP 2/9/2007 16:23'!
initialize

	super initialize.

	"create Gui, initialize PlayerCollection"
	self 
		setGui: (DWGUI new: self);
		setPlayers: OrderedCollection new;
		setUnusedColors: Set new;
		setState: self class gameOverState.

	1 to: self class maxPlayers do: [:index |
		self setUnusedColor: (DWGUI colorPlayer: index)].

	"create Players"
	self addHumanPlayer.
	self class startPlayers - 1
		timesRepeat: [self addComputerPlayer]! !

!DWGame methodsFor: 'initialization' stamp: 'MP 2/9/2007 17:02'!
openInHand

	self getGui openInHand! !

!DWGame methodsFor: 'initialization' stamp: 'MP 2/9/2007 17:02'!
openInWorld

	self getGui openInWorld! !

!DWGame methodsFor: 'private' stamp: 'DH 1/25/2007 17:32'!
abort
	"Aborts the current game."

	"Keep in mind that the game needs to be ended as soon as possible.
	We cannot end it now because there might be a wait active or the
	computer player might be thinking."
	self setAbortTrue.
	
	"Ony in these two situations we can end the game immediately:"
	(self getState = self class waitForMoveState 
		or: [self getState = self class waitForTargetSectorState])
			ifTrue: [self reset]! !

!DWGame methodsFor: 'private' stamp: 'DF 1/30/2007 15:41'!
assignSectors
	"Distributes the sectors coincidentally among all players"	
	| cnt  sector randomPlayers|

	randomPlayers := self getPlayers shuffled.
	
	cnt := self getSectors size.
	[0 < cnt] whileTrue: [
		randomPlayers do: [:player |
			0 < cnt
				ifTrue: [
					"Find a random sector which is not owned by anyone"
					sector := self getSectors atRandom.
					[sector getOwner isNil] whileFalse: [
						sector := self getSectors atRandom].
					
					sector setOwner: player.
					cnt := cnt - 1]]]! !

!DWGame methodsFor: 'private' stamp: 'DH 1/25/2007 15:41'!
assignStartDices
	"Distribute the starting dices coincidentally on the sectors"	

	"Put one dice on each sector"
	self sectorsDo: [:sec | 
		sec addDice].

	"Distribute remaining dices"
	self playersDo: [:player |
		player addDicesToRandomSectors: 
			(self class mapSectors 
				* self class startDicesPerSector 
				// (self getPlayers size))]! !

!DWGame methodsFor: 'private' stamp: 'DH 1/27/2007 19:08'!
currentPlayerHasWon
	"Checks if  the current player ownes all sectors"

	^ self getCurrentPlayer getNumberOfSectors 
		= self class mapSectors! !

!DWGame methodsFor: 'private' stamp: 'DF 1/30/2007 12:34'!
doMoveVisual: aMove
	"Performs the move an displays it on the screen"

	self doMove: aMove perform.

	"Show move "
	self getGui showMoveInPanelWith: aMove.
	aMove getBaseSector redraw.
	aMove getTargetSector redraw.
	self getGui paintPlayerlist.
	self getGui outermostWorldMorph doOneCycle.

	self prepareNextMove! !

!DWGame methodsFor: 'private' stamp: 'DH 1/25/2007 16:02'!
doMove: aMove
	"Updates the internal sectors structure performing the given move without
	showing the results on the screen."
	
	aMove isSuccessful
		ifTrue: [
			aMove
				setTargetSectorOwnerAsBaseSectorOwner;
			 	setTargetSectorNumberOfDices: 
					aMove getBaseSectorNumberOfDices - 1].

	aMove setBaseSectorNumberOfDices: 1! !

!DWGame methodsFor: 'private' stamp: 'DH 1/31/2007 15:09'!
getNumberOfActiveHumanPlayers
	"Returns the number of active human-players"
	
	^ (self getPlayers select: [:player |
		player isHumanPlayer 
			and: [player isActive]]) size! !

!DWGame methodsFor: 'private' stamp: 'DH 1/30/2007 16:50'!
getNumberOfActivePlayers
	"Returns the number of active players"
	
	^ (self getPlayers select: [:player |
		player isActive]) size! !

!DWGame methodsFor: 'private' stamp: 'DF 1/30/2007 12:34'!
nextPlayer
	"Sets the next player as active and begins its turn"

	"Set next player as current player, sort of imitating repeat until"
	[self setCurrentPlayer: 
		(self getPlayers 
			after: (self getCurrentPlayer)
			ifAbsent: [self getPlayers first]).
	 self getCurrentPlayer isActive] whileFalse: [].

	"Update player list"
	self getGui paintPlayerlist.

	"Set state according to player type"
	self getCurrentPlayer isHumanPlayer
		ifTrue: [
			self setState: #waitForMove.
			self getGui enableTurnButton]
		ifFalse: [
			self setState: #computerMove.
			self getGui disableTurnButton.
			"Let the computer player make some moves"
			self getCurrentPlayer doSomething]! !

!DWGame methodsFor: 'private' stamp: 'DH 1/31/2007 15:50'!
prepareNextMove
	"Prepares the next move"

	"Aren't there any human players left? (if there are any at all)
	Or has the abort button been pressed?
	If so, show game over screen."		
	((self getNumberOfActiveHumanPlayers = 0
		and: [self getNumberOfHumanPlayers > 0])
			or: [self getAbort])
				ifTrue: [
					^ self
						abort;
						reset].

	"If the current player has won, show an info screen."
	self currentPlayerHasWon
		ifTrue: [
			^ self
				abort; 
				resetWithWinner: (self getCurrentPlayer)].
	
	"Set the new state according to the current player type."
	self getCurrentPlayer isHumanPlayer
			ifTrue: [self setState: self class waitForMoveState]
			ifFalse: [self setState: self class computerMoveState].

	! !

!DWGame methodsFor: 'private' stamp: 'DH 1/25/2007 17:06'!
reset
	self resetWithWinner: nil! !

!DWGame methodsFor: 'private' stamp: 'MP 2/1/2007 21:43'!
resetWithWinner: aPlayer
	"Reset game and update GUI afterwards"
	
	self playersDo: [:player |
		player reset].
	
	self getGui
		cleanAllButMap;
		disableTurnButton.

	aPlayer
		ifNil: [
			self getGui showLostGameInfo]
		ifNotNil: [
			self getGui showWinnerInfoOf: aPlayer].
	
	self setState: self class gameOverState.

	self getGui 
		changeImageOfGameButton;
		paintPlayerlist.

	self getPlayers size = self class maxPlayers
		ifFalse: [self getGui enableAddButton]! !

!DWGame methodsFor: 'private' stamp: 'MP 2/1/2007 21:44'!
startNewGame
	"game initialisieren"

	self setSectors: 
		(DWMapMaker 
			size: (self class mapSize) 
			sectors: (self class mapSectors) 
			game: self).

	self 
		assignSectors;
		assignStartDices;
		redrawAllSectors;
		setCurrentPlayer: players first;
		setAbortFalse.

	self getGui
		cleanAll;
		paintMap;
		disableAddButton.

	self getCurrentPlayer isHumanPlayer
		ifTrue: [
			self setState: #waitForMove.
			self getGui
				changeImageOfGameButton;
				enableTurnButton;
				paintPlayerlist]
		ifFalse: [
			self setState: #computerMove.
			self getGui
				paintPlayerlist;
				changeImageOfGameButton.
			self getCurrentPlayer doSomething]! !

!DWGame methodsFor: 'private' stamp: 'DH 1/25/2007 17:37'!
undoMove: aMove
	"Opposite of 'doMove'"

	aMove setBaseSectorNumberOfDices: 
		aMove getNumberOfBaseDices.

	aMove isSuccessful
		ifTrue: [
			aMove getTargetSector 
				setNumberOfDices: aMove getNumberOfTargetDices;
			 	setOwner: aMove getPreviousOwner]! !

!DWGame methodsFor: 'testing' stamp: 'DH 1/25/2007 18:14'!
isOver

	^ self getState = self class gameOverState! !

!DWGame methodsFor: 'testing' stamp: 'DH 1/31/2007 17:38'!
playerColorIsChangeable

	^ self isOver and:
			[self getPlayers size < self class maxPlayers]! !

!DWGame methodsFor: 'wrapper' stamp: 'DH 1/25/2007 15:36'!
playersDo: aBlock
	self getPlayers do: [:player |
		aBlock value: player]! !

!DWGame methodsFor: 'wrapper' stamp: 'DH 12/26/2006 21:28'!
sectorsDo: aBlock
	sectors do: [:sector |
		aBlock value: sector]! !

!DWGame methodsFor: 'player handling' stamp: 'DH 1/31/2007 16:47'!
addComputerPlayer

	self addHumanPlayer
		ifNotNilDo: [:player |
			player becomeComputerPlayer]! !

!DWGame methodsFor: 'player handling' stamp: 'DH 1/31/2007 17:21'!
addHumanPlayer
	"create a new Player"
	| player |

	self getPlayers size < self class maxPlayers
		ifTrue: [
			player := DWPlayer game: self color:
				self getUnusedColor.
			self getPlayers add: player.

			self getPlayers size = self class maxPlayers
				ifTrue: [self getGui disableAddButton].

			^ player].
	^ nil! !

!DWGame methodsFor: 'player handling' stamp: 'DH 1/31/2007 16:28'!
computerFight
	"Changes all players to computer players.
	This is only for demonstration purposes."
	
	"Only works when no game is running."
	self isOver
		ifFalse: [^ self].

	self playersDo: [:player |
		player isHumanPlayer
			ifTrue: [
				player becomeComputerPlayer]].
	
	self getGui paintPlayerlist! !

!DWGame methodsFor: 'player handling' stamp: 'DH 1/31/2007 17:21'!
removePlayer: aPlayer
	aPlayer isRemovable
		ifTrue: [
			self getPlayers remove: aPlayer.
			self setUnusedColor: aPlayer getColor.
			self getGui paintPlayerlist.
			self getPlayers size < self class maxPlayers
				ifTrue: [self getGui enableAddButton]]! !

!DWGame methodsFor: 'player color handling' stamp: 'DH 1/31/2007 17:01'!
changeColor: aColor
	"Takes a color, marks it as unused, and returns another
	unused color in exchange, which gets marked as used, then. 
	We need this to let players changing their colors."

	| color |
	
	self getUnusedColors isEmpty
		ifTrue: [
			^ aColor].

	color := self getUnusedColor.
	self setUnusedColor: aColor.

	^ color! !

!DWGame methodsFor: 'player color handling' stamp: 'DH 1/31/2007 17:22'!
getUnusedColor

	^ self getUnusedColors remove:
		self getUnusedColors atRandom! !

!DWGame methodsFor: 'player color handling' stamp: 'DH 1/31/2007 17:17'!
setUnusedColor: aColor

	self getUnusedColors add: aColor! !

!DWGame methodsFor: 'deleting' stamp: 'DF 1/30/2007 16:36'!
delete
	self getGui delete! !

!DWGame methodsFor: 'game control' stamp: 'DH 1/31/2007 17:57'!
endTurn
	"Terminate the turn of the current player, distribute the new cubes and hand over to the next player"

	self getAbort
		ifTrue: [^ self].

	"if the turn after selecting the BaseSectors terminates, remove Sector-highlight"
	self getCurrentMove
		ifNotNil: [self getCurrentMove getBaseSector unHighlight].

	self getCurrentPlayer assignDices.
	self getGui disableTurnButton.
	self getGui outermostWorldMorph doOneCycle.
	self 
		wait: 0.5;
		nextPlayer! !

!DWGame methodsFor: 'game control' stamp: 'DH 1/25/2007 17:52'!
selectBaseSector: aSector
	"The current player selects a sector as Base-Sector for a move"
	
	"Perform some tests"
	(aSector getOwner isCurrentPlayer
		and: [1 < aSector getNumberOfDices
			and: [aSector isNotEncircledByOwnSectors]])
				ifFalse: [^self].

	"Create a move"
	self setCurrentMove: 
		(DWMove from: aSector).

	"Highlight selected sector"
	aSector highlight.

	self getCurrentPlayer isHumanPlayer
		ifTrue: [
			self setState: self class waitForTargetSectorState]! !

!DWGame methodsFor: 'game control' stamp: 'DF 1/22/2007 19:08'!
selectSector: aSector
	"Bypass-method - called with one click on a sector"
	
	self getState = self class waitForMoveState
		ifTrue: [
			self selectBaseSector: aSector.
			^ self].

	self getState = self class waitForTargetSectorState
		ifTrue: [
			self selectTargetSector: aSector.
			^ self]! !

!DWGame methodsFor: 'game control' stamp: 'DH 1/31/2007 17:52'!
selectTargetSector: aSector
	"The current player selects a sector as a target of his move"

	"Abort the move if base and target sectors are the same"
	aSector == self getCurrentMove getBaseSector
		ifTrue: [
			aSector unHighlight.
			self setState: self class waitForMoveState.
			^ self].

	"Perform some tests..."
	((aSector isNeighborOf: self getCurrentMove getBaseSector)
		and: [self getCurrentMove getBaseSectorOwner ~= aSector getOwner]) 
			ifFalse: [^ self].

	aSector highlight.

	self getCurrentPlayer isHumanPlayer
		ifTrue: [self getGui disableTurnButton].

	"otherwise the highlight wouldn't be visible"
 	self getGui outermostWorldMorph doOneCycle.

	self getCurrentMove chooseTargetSector: aSector.
	self
		setState: self class showMoveState;
		"wait some time before actually showing the move"
		wait: 0.5;
		doMoveVisual: currentMove;
		setCurrentMove: nil.

	(self getCurrentPlayer isHumanPlayer
		and: [self getState ~= self class gameOverState])
			ifTrue: [self getGui enableTurnButton]! !

!DWGame methodsFor: 'game control' stamp: 'DH 1/1/2007 19:42'!
simulate: aMove during: aBlock

	self doMove: aMove.
	aBlock value.
	self undoMove: aMove! !

!DWGame methodsFor: 'game control' stamp: 'DH 1/25/2007 17:57'!
startAbortButtonPressed
	self isOver
		ifTrue: [
			self startNewGame]
		ifFalse: [
			self abort]! !

!DWGame methodsFor: 'derived' stamp: 'DH 1/31/2007 14:15'!
getNumberOfHumanPlayers
	"Returns the number of human players"
	
	^ (self getPlayers select: [:player |
		player isHumanPlayer]) size! !

!DWGame methodsFor: 'derived' stamp: 'DH 1/25/2007 16:13'!
getNumberOfPlayers

	^self getPlayers size! !

!DWGame methodsFor: 'drawing' stamp: 'DF 12/21/2006 22:26'!
redrawAllSectors
	self getSectors do: [:sector |
		sector redraw]! !

!DWGame methodsFor: 'olpc compatibility' stamp: 'DH 2/11/2007 01:35'!
wait: aNumber
	
	(Delay forSeconds: aNumber) wait! !


!DWGame class methodsFor: 'constants' stamp: 'DF 1/22/2007 18:42'!
computerMoveState
	^#computerMove! !

!DWGame class methodsFor: 'constants' stamp: 'DF 1/30/2007 13:20'!
gameOverState
	^#gameOver! !

!DWGame class methodsFor: 'constants' stamp: 'DF 1/2/2007 16:50'!
mapSectors
	^30! !

!DWGame class methodsFor: 'constants' stamp: 'DF 1/2/2007 16:50'!
mapSize
	^ 32@28! !

!DWGame class methodsFor: 'constants' stamp: 'DF 1/2/2007 15:55'!
maxPlayers
	^ 8! !

!DWGame class methodsFor: 'constants' stamp: 'DF 1/22/2007 19:10'!
showMoveState
	^#showMove! !

!DWGame class methodsFor: 'constants' stamp: 'DF 1/4/2007 12:28'!
startDicesPerSector
	^3! !

!DWGame class methodsFor: 'constants' stamp: 'DF 1/4/2007 13:29'!
startPlayers
	^3! !

!DWGame class methodsFor: 'constants' stamp: 'DF 1/22/2007 18:42'!
waitForMoveState
	^#waitForMove! !

!DWGame class methodsFor: 'constants' stamp: 'DF 1/22/2007 19:06'!
waitForTargetSectorState
	^#waitForTargetSector! !


!DWGUI methodsFor: 'event handling' stamp: 'MP 1/30/2007 18:20'!
addPlayer
	
	self getGame addComputerPlayer.
	self paintPlayerlist! !

!DWGUI methodsFor: 'event handling' stamp: 'DH 1/31/2007 17:32'!
changeDiceImage: aPlayer

	aPlayer changeColor.
	self paintPlayerlist! !

!DWGUI methodsFor: 'event handling' stamp: 'DH 1/31/2007 17:31'!
changePlayerType: aPlayer

	aPlayer changeType.
	self paintPlayerlist! !

!DWGUI methodsFor: 'event handling' stamp: 'MP 1/30/2007 18:21'!
endTurn

	self getGame endTurn! !

!DWGUI methodsFor: 'event handling' stamp: 'MP 1/30/2007 18:21'!
removePlayer: aPlayer

	self getGame removePlayer: aPlayer! !

!DWGUI methodsFor: 'event handling' stamp: 'MP 1/30/2007 18:21'!
startAbortButtonPressed

	self getGame startAbortButtonPressed! !

!DWGUI methodsFor: 'public' stamp: 'MP 1/30/2007 18:24'!
changeImageOfGameButton
	"switches between abortGame and startGame image"

	self deleteContentOf: self getGameButton.
	self getGame isOver 
		ifTrue: [
			self getGameButton addMorphCentered: self class getStartGameImage asMorph]
		ifFalse: [
			self getGameButton addMorphCentered: self class getAbortGameImage asMorph]! !

!DWGUI methodsFor: 'public' stamp: 'MP 2/1/2007 22:27'!
cleanAll

	self cleanAllButMap.
	self deleteContentOf: self getMapPanel.! !

!DWGUI methodsFor: 'public' stamp: 'MP 2/1/2007 22:26'!
cleanAllButMap

	self deleteContentOf: self getPlayerlistPanel.
	self deleteContentOf: self getMovePanel! !

!DWGUI methodsFor: 'public' stamp: 'MP 2/7/2007 22:04'!
delete

	self getGame abort.
	super delete! !

!DWGUI methodsFor: 'public' stamp: 'MP 1/30/2007 18:22'!
disableAddButton

	self getAddButton
		lock;
		hide! !

!DWGUI methodsFor: 'public' stamp: 'MP 1/30/2007 18:22'!
disableTurnButton

	self getTurnButton
		lock;
		hide! !

!DWGUI methodsFor: 'public' stamp: 'MP 1/30/2007 18:22'!
enableAddButton

	self getAddButton
		unlock;
		show! !

!DWGUI methodsFor: 'public' stamp: 'MP 1/30/2007 18:22'!
enableTurnButton

	self getTurnButton
		unlock;
		show! !

!DWGUI methodsFor: 'public' stamp: 'MP 1/30/2007 18:24'!
paintMap
	"reads the map information from the sectors array of the game 
	object and creates the map in the mappanel"

	self deleteContentOf: self getMapPanel.
	self getGame getSectors
		do: [:sector |
			sector position: sector position + self getMapPosition.
			self getMapPanel addMorph: sector]! !

!DWGUI methodsFor: 'public' stamp: 'MP 1/30/2007 18:24'!
paintPlayerlist
	"reads the playerlist information from the players array of the game 
	object and creates the playerlist in the playerlistpanel"

	self deleteContentOf: self getPlayerlistPanel.
	self getGame getPlayers reversed
		do: [:player | 
			self getPlayerlistPanel addMorph: (self createPlayerPanelFrom: player)]! !

!DWGUI methodsFor: 'public' stamp: 'MP 1/31/2007 16:15'!
showMoveInPanelWith: aMove
	"shows the move informations in the movepanel"
	| leftmovepane separator rightmovepane |

	self deleteContentOf: self getMovePanel.

	leftmovepane := self createLeftMovePanelInfoFrom: aMove getBaseSector getOwner with: aMove getBaseDices.
	leftmovepane 
		top: self getMovePanel position y + self class getPanelInset y;
		right: self getMovePanel center x - 10.

	separator := Morph new
		extent: 1 @ leftmovepane extent y;
		color: Color black;
		top: self getMovePanel position y + self class getPanelInset y;
		left: self getMovePanel center x;
		yourself.

	rightmovepane := self createRightMovePanelInfoFrom: aMove getPreviousOwner with: aMove getTargetDices.
	rightmovepane 
		top: self getMovePanel position y + self class getPanelInset y;
		left: self getMovePanel center x + 10.

	self getMovePanel 
		addMorph: leftmovepane;
		addMorph: separator;
		addMorph: rightmovepane! !

!DWGUI methodsFor: 'layout' stamp: 'MP 2/1/2007 22:28'!
createAddButton

	self setAddButton: (self createPLButtonAt: self class getAddButtonPosition
			extent: self class getAddButtonSize
			label: '+'
			action: #addPlayer
			args: nil
			info: 'adds a new player').
	^ self getAddButton! !

!DWGUI methodsFor: 'layout' stamp: 'MP 2/1/2007 22:28'!
createGameButton

	self setGameButton: (self createButtonAt: self class getGameButtonPosition
			extent: self class getGameButtonSize
			label: self class getStartGameImage asMorph
			action: #startAbortButtonPressed
			args: nil
			info: nil).
	^ self getGameButton! !

!DWGUI methodsFor: 'layout' stamp: 'MP 2/1/2007 22:28'!
createMapPanel

	self setMapPanel: ( self createPanelAt: ( self class getMapPanelPosition ) extent: ( self class getMapPanelSize )).
	^ self getMapPanel! !

!DWGUI methodsFor: 'layout' stamp: 'MP 2/1/2007 22:28'!
createMovePanel

	self setMovePanel: ( self createPanelAt: ( self class getMovePanelPosition ) extent: ( self class getMovePanelSize )).
	^ self getMovePanel! !

!DWGUI methodsFor: 'layout' stamp: 'MP 2/1/2007 22:29'!
createPlayerlistPanel

	self setPlayerlistPanel: (self createPanelAt: (self class getPlayerlistPanelPosition) 
			extent: (self class getPlayerlistPanelSize)).
	self getPlayerlistPanel 
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		layoutInset: self class getPanelInset;
		cellInset: self class getPanelSubmorphInset.
	^ self getPlayerlistPanel! !

!DWGUI methodsFor: 'layout' stamp: 'MP 2/1/2007 22:29'!
createTurnButton

	self setTurnButton: (self createButtonAt: self class getTurnButtonPosition
			extent: self class getTurnButtonSize
			label: self class getEndTurnImage asMorph
			action: #endTurn
			args: nil
			info: 'terminates current turn').
	^ self getTurnButton! !

!DWGUI methodsFor: 'layout' stamp: 'MP 2/1/2007 22:30'!
getMapPosition
	"returns the position of the map depending on the current position of the 
	mainwindow which can be derived from the position of the mappanel"

	^ self getMapPanel position + self class getPanelInset! !

!DWGUI methodsFor: 'layout' stamp: 'MP 1/30/2007 18:27'!
putSubmorphsIntoMainWindow
	"creates all panels and buttons and insert them into the mainwindow"

	self addMorph: self createMapPanel;
		addMorph: self createPlayerlistPanel;
		addMorph: self createMovePanel;
		addMorph: self createGameButton;
		addMorph: self createTurnButton;
		addMorph: self createAddButton! !

!DWGUI methodsFor: 'private' stamp: 'MP 2/1/2007 22:32'!
createButtonAt: aPositionPoint 
	extent: aSizePoint 
	label: aMorph 
	action: aSymbol 
	args: aCollection
	info: aString
	"creates a game button (not playerlist button!!) with rounded edges"
	| button |

	button := BorderedMorph new
		extent: aSizePoint;
		position: aPositionPoint;
		color: self class getButtonColor;
		borderColor: self class getButtonBorderColor;
		borderWidth: self class getButtonBorderWidth;
		cornerStyle: self class getButtonCornerStyle;
		setBalloonText: aString;
		balloonColor: self class getThemeColor muchLighter;
		yourself.
	button ensuredButtonProperties
		wantsRolloverIndicator: true;
		actWhen: #mouseDown;
		target: self;
		actionSelector: aSymbol.
	button addMorphCentered: aMorph.
	^ button! !

!DWGUI methodsFor: 'private' stamp: 'MP 2/1/2007 22:32'!
createImageAsButton: aMorph
	action: aSymbol
	args: aCollection
	"creates a button containing a picture without a border (for the playerlist)"

	aMorph addDropShadow;
		shadowColor: (Color gray twiceDarker alpha: 0.5).
	aMorph ensuredButtonProperties
		wantsRolloverIndicator: false;
		actWhen: #mouseDown;
		target: self;
		actionSelector: aSymbol;
		arguments: aCollection.
	^ aMorph! !

!DWGUI methodsFor: 'private' stamp: 'MP 2/11/2007 12:58'!
createLeftMovePanelInfoFrom: aPlayer with: anArray
	"creates a morph with the move information (of the basesector) from
	aPlayer with the results of the dicearray"
	| moveinfomorph |

	moveinfomorph := Morph new
		color: Color transparent;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		layoutInset: 0@0;
		cellInset: 0@0.
	moveinfomorph
		addMorph: (aPlayer getDiceImage asMorph
			addDropShadow;
			shadowColor: (Color gray twiceDarker alpha: 0.5)
			yourself);
		addMorph: (Morph new 
			extent: 10@20; 
			color: Color transparent; 
			yourself);
		addMorph: ((StringMorph contents: anArray sum asString)
			fontName: 'defaultName' size: 25;
			emphasis: 1).
	anArray size > 1
		ifTrue: [
			moveinfomorph 
				addMorph: ((StringMorph contents: ' = ')
					fontName: 'defaultName' size: 15);
				addMorph: ((StringMorph contents: anArray first asString)
					fontName: 'defaultName' size: 15).
			2 to: anArray size do: [:each | 
				moveinfomorph addMorph: ((StringMorph contents: ((anArray at: each) asString, ' + '))
					fontName: 'defaultName' size: 15)]].
	^ moveinfomorph! !

!DWGUI methodsFor: 'private' stamp: 'MP 1/31/2007 17:01'!
createPanelAt: aPositionPoint extent: aSizePoint
	"returns a panel at aPositionPoint with aSizePoint as size"

	^ Morph new
			extent: aSizePoint;
			position: aPositionPoint;
			color: self class getPanelColor;
			cornerStyle: self class getPanelCornerStyle;
			addDropShadow;
			yourself
					! !

!DWGUI methodsFor: 'private' stamp: 'MP 1/31/2007 17:47'!
createPLButtonAt: aPositionPoint 
	extent: aSizePoint 
	label: aStringOrMorph 
	action: aSymbol 
	args: aCollection
	info: aString
	"returns a playerlist button at aPositionPoint with aSizePoint as size and the other button attributes"
	| plbutton prop |

	plbutton := BorderedMorph new
		extent: aSizePoint;
		position: aPositionPoint;
		color: self class getPLButtonColor;
		borderColor: self class getPLButtonBorderColor;
		borderWidth: self class getPLButtonBorderWidth;
		cornerStyle: self class getPLButtonCornerStyle;
		setBalloonText: aString;
		balloonColor: self class getThemeColor muchLighter;
		addDropShadow;
		shadowColor: (Color gray twiceDarker alpha: 0.5);
		yourself.
	prop := plbutton ensuredButtonProperties
		wantsRolloverIndicator: false;
		actWhen: #mouseDown;
		target: self;
		actionSelector: aSymbol.

	"if aCollection is not nil, it has to be a remove or ai button"
	aCollection 
		ifNotNil: [
			prop arguments: aCollection.

			"if aStringOrMorph is a morph, it has to be the ai button"
			aStringOrMorph isMorph 
				ifTrue: [
					plbutton addMorphCentered: aStringOrMorph.
					^ plbutton]].
	prop addTextToButton: aStringOrMorph.
	^ plbutton! !

!DWGUI methodsFor: 'private' stamp: 'MP 2/11/2007 13:01'!
createPlayerPanelFrom: aPlayer
	"creates the submorphes of the playerpanel"
	| panel dicebutton sectormorph spacemorph removebutton aibutton aimorph |

	"----- dice button -----"
	dicebutton := self createImageAsButton: aPlayer getDiceImage asMorph
		action: #changeDiceImage:
		args: {aPlayer}.
	self getGame playerColorIsChangeable
		ifTrue: [
			dicebutton 
				setBalloonText: 'change color';
				balloonColor: self class getThemeColor muchLighter].

	"----- number of connected sectors and buffer size in a StringMorph -----"
	aPlayer getNumberOfConnectedSectors > 0 
		ifTrue: [
			aPlayer getBuffer > 0 
				ifTrue: [
					sectormorph := (StringMorph contents: (aPlayer getNumberOfConnectedSectors asString, ' (+', aPlayer getBuffer asString,')'))
						emphasis: 1]
				ifFalse: [
					sectormorph := (StringMorph contents: aPlayer getNumberOfConnectedSectors asString)
						emphasis: 1]]
		ifFalse: [
			self getGame isOver 
				ifTrue: [
					sectormorph := StringMorph contents: '']
				ifFalse: [
					sectormorph := (StringMorph contents: 'lost')
						emphasis: 1]].

	"----- space morph -----"
	spacemorph := Morph new
		color: Color transparent;
		vResizing: 5;
		hResizing: #spaceFill;
		yourself.

	"----- remove button -----"
	aPlayer isRemovable 
		ifTrue: [
			removebutton := self createPLButtonAt: 0@0 
				extent: 17 @ 17 
				label: '-' 
				action: #removePlayer: 
				args: {aPlayer}
				info: 'removes the player']
		ifFalse: [
			removebutton := Morph new
				color: Color transparent;
				extent: 20 @ 20].

	"----- ai button -----"
	aPlayer isComputerPlayer 
		ifTrue: [
			aimorph := self class getComputerPlayerImage asMorph]
		ifFalse: [
			aimorph := self class getHumanPlayerImage asMorph].
	aibutton := self createImageAsButton: aimorph
		action: #changePlayerType:
		args: {aPlayer}.
	aPlayer typeIsChangeable
		ifTrue: [
			aibutton 
				setBalloonText: 'change player type';
				balloonColor: self class getThemeColor muchLighter].

	"----- playermorph -----"
	panel := BorderedMorph new
		extent: self class getPlayerPanelSize;
		color: Color transparent;
		borderWidth: 0;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		layoutInset: 5 @ 5;
		cellInset: 5 @ 5;
		vResizing: #shrinkWrap;
		addMorph: removebutton;
		addMorph: aibutton;
		addMorph: spacemorph;
		addMorph: sectormorph;
		addMorph: dicebutton;
		yourself.
	(aPlayer isCurrentPlayer 
		and: [self getGame isOver not])
			ifTrue: [
				panel color: (self class getThemeColor alpha: 0.5)].
	^ panel! !

!DWGUI methodsFor: 'private' stamp: 'MP 2/11/2007 12:56'!
createRightMovePanelInfoFrom: aPlayer with: anArray
	"creates a morph with the move information (of the targetsector) from 
	aPlayer with the results of the dicearray"
	| moveinfomorph |

	moveinfomorph := Morph new
		color: Color transparent;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		layoutInset: 0@0;
		cellInset: 0@0.
	anArray size > 1
		ifTrue: [
			1 to: anArray size - 1 do: [:each |
				moveinfomorph addMorph: ((StringMorph contents: ' + ', ((anArray at: each) asString))
					fontName: 'defaultFont' size: 15)].
			moveinfomorph 
				addMorph: ((StringMorph contents: (anArray last asString))
					fontName: 'defaultFont' size: 15);
				addMorph: ((StringMorph contents: ' = ')
					fontName: 'defaultFont' size: 15)].
	moveinfomorph addMorph: ((StringMorph contents: anArray sum asString)
			fontName: 'defaultFont' size: 25;
			emphasis: 1);
		addMorph: (Morph new 
			extent: 10@20; 
			color: Color transparent; 
			yourself);
		addMorph: (aPlayer getDiceImage asMorph
			addDropShadow;
			shadowColor: (Color gray twiceDarker alpha: 0.5);
			yourself).
	^ moveinfomorph! !

!DWGUI methodsFor: 'private' stamp: 'MP 2/1/2007 22:39'!
deleteContentOf: aMorph
	"deletes all submorphs of aMorph"

	aMorph isMorph
		ifTrue: [
			aMorph submorphs do: [:each |
				 each delete]]
		ifFalse: [^ self]! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:27'!
getAddButton

	^ addbutton! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:27'!
getGame

	^ game! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:27'!
getGameButton

	^ gamebutton! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:27'!
getMapPanel

	^ mappanel! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:27'!
getMovePanel

	^ movepanel! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:27'!
getPlayerlistPanel

	^ playerlistpanel! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:27'!
getTurnButton

	^ turnbutton! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:27'!
setAddButton: aButton

	addbutton := aButton! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:28'!
setGameButton: aButton

	gamebutton := aButton! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:28'!
setGame: aDWGame

	game := aDWGame! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:28'!
setMapPanel: aMorph

	mappanel := aMorph! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:28'!
setMovePanel: aMorph

	movepanel := aMorph! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:28'!
setPlayerlistPanel: aMorph

	playerlistpanel := aMorph! !

!DWGUI methodsFor: 'accessing' stamp: 'MP 1/30/2007 18:28'!
setTurnButton: aButton

	turnbutton := aButton! !

!DWGUI methodsFor: 'initialization' stamp: 'MP 1/30/2007 18:28'!
defaultBorderColor

	^ self class getThemeColor muchDarker! !

!DWGUI methodsFor: 'initialization' stamp: 'MP 1/30/2007 18:29'!
defaultBorderWidth

	^ 2! !

!DWGUI methodsFor: 'initialization' stamp: 'MP 1/30/2007 18:29'!
defaultBounds

	^ (self class getMainWindowPosition) corner: (self class getMainWindowSize + self class getMainWindowPosition)! !

!DWGUI methodsFor: 'initialization' stamp: 'MP 1/31/2007 15:47'!
defaultColor
	| result upperColor lowerColor |

	upperColor := self class getThemeColor twiceDarker twiceDarker twiceDarker.
	lowerColor := self class getThemeColor twiceDarker.
	result := GradientFillStyle ramp: {
					0.0	-> upperColor. 
					1.0 -> lowerColor}.
	result origin: self bounds origin;
		 direction: 0@(self extent y).
	result radial: false.
	^ result! !

!DWGUI methodsFor: 'initialization' stamp: 'MP 1/30/2007 18:29'!
initialize

	super initialize.
	self putSubmorphsIntoMainWindow! !

!DWGUI methodsFor: 'initialization' stamp: 'MP 2/9/2007 17:01'!
openInHand

	super openInHand.
	self
		paintPlayerlist;
		showStartScreen;
		disableTurnButton! !

!DWGUI methodsFor: 'initialization' stamp: 'MP 1/31/2007 16:57'!
openInSystemWindow
	| window |

	"necessary for setting the color of the systemwindow"
	self color: self class getThemeColor.

	window := self openInWindowLabeled: 'Dicewars'.
	window position: self class getMainWindowPosition.

	"color has to be set after opening in a systemwindow"
	self color: self defaultColor! !

!DWGUI methodsFor: 'initialization' stamp: 'MP 2/9/2007 17:02'!
openInWorld

	super openInWorld.
	self
		paintPlayerlist;
		showStartScreen;
		disableTurnButton! !

!DWGUI methodsFor: 'displaying infomorphs' stamp: 'MP 2/1/2007 21:50'!
showLostGameInfo
	"the content of the lostGame info output"
	| lostscreen |

	lostscreen := Morph new
		color: (self class getThemeColor twiceDarker alpha: 0.75);
		extent: self class getMapPanelSize;
		cornerStyle: #rounded;
		yourself.
	lostscreen addMorphCentered: ((StringMorph contents: 'Game Over')
			fontName: 'defaultFont' size: 30;
			emphasis: 1;
			addDropShadow;
			shadowColor: (Color gray twiceDarker alpha: 0.5);
			yourself).
	self getMapPanel addMorphCentered: lostscreen! !

!DWGUI methodsFor: 'displaying infomorphs' stamp: 'MP 2/9/2007 16:35'!
showStartScreen
	"the content of the start screen"
	| startscreen headline |

	startscreen := Morph new
		color: Color transparent;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		layoutInset: 0 @ 0;
		cellInset: 5 @ 5;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		yourself.

	headline := Morph new
		color: Color transparent;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		layoutInset: 0 @ 0;
		cellInset: 20 @ 20;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		yourself.
	headline addMorph: ((self class diceImage: (self class colorPlayer: 8 atRandom)) asMorph
			addDropShadow;
			shadowColor: Color gray twiceLighter twiceLighter);	
		addMorph: ((StringMorph contents: 'DiceWars') 
			fontName: 'defaultFont' size: 40;
			emphasis: 1;
			addDropShadow;
			shadowColor: Color gray twiceLighter twiceLighter);
		addMorph: ((self class diceImage: (self class colorPlayer: 8 atRandom)) asMorph
			addDropShadow;
			shadowColor: Color gray twiceLighter twiceLighter).

	startscreen
		addMorph: ((StringMorph contents: 'by Dandy Fenz, Daniel Hefenbrock & Matthias Pohl')
			fontName: 'defaultFont' size: 12);
		addMorph: ((StringMorph contents: 'published under MIT license')
			fontName: 'defaultFont' size: 12);	
		addMorph: ((StringMorph contents: '')
			fontName: 'defaultFont' size: 12);
		addMorph: ((StringMorph contents: 'Hasso-Plattner-Institut Potsdam')
			fontName: 'defaultFont' size: 12);
		addMorph: (StringMorph contents: 'Software Architecture 2006/07');
		addMorph: ((StringMorph contents: '')
			fontName: 'defaultFont' size: 12);		
		addMorph: ((StringMorph contents: '')
			fontName: 'defaultFont' size: 12);	
		addMorph: ((StringMorph contents: 'inspired by gamedesign.jp')
			fontName: 'defaultFont' size: 12;
			emphasis: 2);
		addMorph: headline.

	self getMapPanel addMorph: startscreen.
	startscreen center: startscreen owner center! !

!DWGUI methodsFor: 'displaying infomorphs' stamp: 'MP 2/1/2007 21:30'!
showWinnerInfoOf: aPlayer
	"the content of the info output for a winning game"
	| wininfo winscreen |

	wininfo := Morph new
		color: Color transparent;
		layoutPolicy: TableLayout new;
		cellInset: 10@10;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		yourself.
	wininfo addMorph: ((StringMorph contents: 'wins')
			fontName: 'defaultFont' size: 30;
			emphasis: 1;
			addDropShadow;
			shadowColor: (Color gray twiceDarker alpha: 0.5);
			yourself);
		addMorph: (aPlayer getDiceImage asMorph
			addDropShadow;
			shadowColor: (Color gray twiceDarker alpha: 0.5);
			yourself).	
	wininfo center: self getMapPanel center.
	
	winscreen := Morph new
		color: (self class getThemeColor twiceDarker alpha: 0.75);
		extent: self class getMapPanelSize;
		cornerStyle: #rounded;
		addMorphCentered: wininfo;
		yourself.

	self getMapPanel addMorphCentered: winscreen! !


!DWGUI class methodsFor: 'images' stamp: 'MP 2/1/2007 22:02'!
getAbortGameImage
	"returns the morph for the AbortGame button"
	| bitmap |

	bitmap := { 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4279308561. 4280427042. 4288256409. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4293848814. 4282789916. 4284698169. 4287461475. 4289374890. 4293848814. 0. 0. 0. 0. 0. 0. 0. 0. 4290493371. 4287456141. 4278190080. 4278190080. 4282330687. 4290493371. 0. 0. 0. 0. 0. 0. 4290493371. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 0. 0. 0. 0. 0. 4283782485. 4278190080. 4278190080. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4291611852. 4283782485. 4278190080. 4283782485. 4293848814. 0. 0. 0. 0. 0. 0. 0. 0. 4291611852. 4282664004. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4284900966. 4293848814. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4284900966. 4281545523. 4278190080. 4281545523. 0. 0. 0. 0. 0. 0. 0. 4292730333. 4282218558. 4278190080. 4282218558. 4282218558. 4282418241. 4278190080. 4279308561. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4293364495. 4294150153. 4294934273. 4294150153. 4283777067. 4279308561. 4282664004. 4291611852. 0. 0. 0. 0. 0. 4287137928. 4278190080. 4291331271. 4294934526. 4294934526. 4290149302. 4278190080. 4289374890. 0. 0. 0. 0. 0. 4284900966. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4278190080. 4283782485. 0. 0. 4291611852. 4279308561. 4278190080. 4278190080. 4278190080. 4278190080. 4285953586. 4284900966. 4290493371. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4293848814. 4284900966. 4279965472. 4278190080. 4278190080. 4278190080. 4281675327. 4290493371. 0. 0. 0. 0. 0. 0. 0. 0. 4291325550. 4284169019. 4284169019. 4288897120. 4290144617. 4285942089. 4278190080. 4287137928. 0. 0. 0. 0. 0. 0. 0. 4290493371. 4278190080. 4278190080. 4290248445. 4289986558. 4289986558. 4289986558. 4288661703. 4283194203. 4287137928. 4280427042. 4278190080. 4283782485. 4290493371. 0. 0. 0. 0. 0. 0. 4287137928. 4284900966. 4280293136. 4278190080. 4284170793. 4288901182. 4293758771. 4294870800. 4278190080. 4293848814. 0. 0. 0. 0. 0. 0. 4282218558. 4281507380. 4278227714. 4278227714. 4278227714. 4278227714. 4281489715. 4278190080. 4288256409. 0. 0. 0. 0. 0. 0. 0. 4293848814. 4285879060. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4279308561. 4292730333. 0. 0. 0. 4287137928. 4278190080. 4293103074. 4294934526. 4294934526. 4294934526. 4294934526. 4291988434. 4279308561. 4292730333. 0. 0. 0. 0. 4281545523. 4289986305. 4289986305. 4278190080. 4278190080. 4278190080. 4282664004. 4289986305. 4281545523. 4283782485. 0. 4288256409. 4282664004. 4287466809. 4294967041. 4294967041. 4294967041. 4291348544. 4288914238. 4285953586. 4278190080. 4280295440. 4288914238. 4284900966. 4291611852. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4290493371. 4279965472. 4284634230. 4289235413. 4289953790. 4289953790. 4289953790. 4281675327. 4279308561. 4293848814. 0. 0. 0. 0. 0. 0. 4292730333. 4285942089. 4294924376. 4294924376. 4294924376. 4294924376. 4293751410. 4278190080. 4280427042. 0. 0. 0. 0. 0. 0. 0. 4279308561. 4281545523. 4279967776. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4288661703. 4279308561. 4283782485. 4284642934. 4289255125. 4283194203. 4281679679. 4284900966. 4293848814. 0. 4290493371. 4278190080. 4282330653. 4288901182. 4292249918. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4278190080. 4290493371. 0. 0. 0. 0. 0. 4293848814. 4280102941. 4278227714. 4278227714. 4278227714. 4278227714. 4278227714. 4281899578. 4278190080. 4280427042. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4292381204. 4294934273. 4294150153. 4280947968. 4281869070. 4294934273. 4294934273. 4294934273. 4281545523. 0. 0. 4291611852. 4278190080. 4285944950. 4294934526. 4294674938. 4278190080. 4278190080. 4293889518. 4294934526. 4285026152. 4284900966. 0. 0. 0. 0. 4279967760. 4290311465. 4290178355. 4278190080. 4279308561. 0. 4281545523. 4289254974. 4290248208. 4279967760. 4291611852. 4286019447. 4281545523. 4291348544. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4292269630. 4288914238. 4288914238. 4278190080. 4282335005. 0. 0. 0. 0. 0. 0. 0. 0. 4288256409. 4278190080. 4289235413. 4289953790. 4289953790. 4289953790. 4289953790. 4289953790. 4281675327. 4278190080. 4292730333. 0. 0. 0. 0. 0. 0. 4287137928. 4291325550. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4285942089. 4278190080. 4288256409. 0. 0. 0. 0. 0. 4292730333. 4278190080. 4285703074. 4284642934. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4289782754. 4279308561. 4281679679. 4290178541. 4289986558. 4289986558. 4290312953. 4286948258. 4278190080. 4288256409. 4282664004. 4278190080. 4294870800. 4294934273. 4294934273. 4294934273. 4291331136. 4288901182. 4278190080. 4278190080. 4280293136. 4293848814. 0. 0. 0. 0. 0. 4289374890. 4281952570. 4278227714. 4281489715. 4278190080. 4282355264. 4278227714. 4278227714. 4280102941. 4278190080. 4289374890. 0. 0. 0. 0. 0. 0. 4285619271. 4294673156. 4294934273. 4287916569. 4280427042. 4278190080. 4278190080. 4280427042. 4294934273. 4279308561. 4288256409. 0. 4286019447. 4278190080. 4292250069. 4294934526. 4290149302. 4278190080. 4278190080. 4279308561. 4294871037. 4293889518. 4278190080. 4293848814. 0. 0. 4292730333. 4278190080. 4289986305. 4289254974. 4281545523. 4280427042. 0. 4283194153. 4289782585. 4289986305. 4287870529. 4287137928. 4280427042. 4278190080. 4287466809. 4288914238. 4294901264. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4282335005. 0. 0. 0. 0. 0. 0. 0. 4291611852. 4278190080. 4290154477. 4289953790. 4289953790. 4288644295. 4286935202. 4278190080. 4278190080. 4278190080. 4278190080. 0. 0. 0. 0. 0. 0. 0. 4287452758. 4294274927. 4293751410. 4278190080. 4280292886. 4294861410. 4294924376. 4292243825. 4278190080. 4280427042. 0. 0. 0. 0. 0. 4289374890. 4280427042. 4285703074. 4286948258. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4290248445. 4278190080. 4286948258. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4288661703. 4287137928. 4280427042. 4280427042. 4294282793. 4294934273. 4285944882. 4278190080. 4278190080. 4278190080. 4278190080. 4284900966. 4290493371. 0. 0. 0. 0. 0. 0. 4287137928. 4282355264. 4279212049. 4278190080. 4281545523. 4281952570. 4278227714. 4278227714. 4282225983. 4278190080. 4282664004. 0. 0. 0. 0. 0. 0. 4283381004. 4294934273. 4294934273. 4285879060. 4283782485. 4281545523. 4280427042. 4278190080. 4294934273. 4294934273. 4282664004. 0. 4281545523. 4278190080. 4294871037. 4294934526. 4288901282. 4289374890. 4286019447. 4278190080. 4291331271. 4294934526. 4284170843. 4287137928. 0. 0. 4290493371. 4281679645. 4289986305. 4288661568. 4284900966. 4280427042. 4290312734. 4283194153. 4289986305. 4289986305. 4287870529. 4287137928. 4292730333. 4284900966. 4280427042. 4278190080. 4278190080. 4282335005. 4288914238. 4294901264. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4294901264. 4284177193. 0. 0. 0. 0. 0. 0. 0. 4281675327. 4288644295. 4289953790. 4290284537. 4283187803. 4284634230. 4284900966. 4293848814. 0. 4283782485. 4280427042. 0. 0. 0. 0. 0. 0. 0. 4280292886. 4294924376. 4290144617. 4281545523. 4278190080. 4293751410. 4294924376. 4294924376. 4282329385. 4278190080. 4290493371. 0. 0. 0. 0. 4287137928. 4283782485. 4285703074. 4287870646. 4289986558. 4289986558. 4290312953. 4289255125. 4289986558. 4289986558. 4288661703. 4290182909. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4285828493. 4287137928. 4281545523. 4281545523. 4293102905. 4294934273. 4284170793. 4282664004. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4283782485. 4281899578. 4281507380. 4278190080. 4279245072. 4282355264. 4278227714. 4278227714. 4278227714. 4279245072. 4278190080. 4291611852. 0. 0. 0.  0. 4291611852. 4283381004. 4294934273. 4294673156. 4284698169. 4279308561. 4290493371. 0. 4279308561. 4294934273. 4294934273. 4279308561. 4293848814. 4279308561. 4280293152. 4294934526. 4294934526. 4288901282. 4290493371. 0. 4279308561. 4280293152. 4294871037. 4291331271. 4283782485. 0. 0. 4288256409. 4284642866. 4289986305. 4288661568. 4286948158. 4279967760. 4285828409. 4289986305. 4289986305. 4290248208. 4279967760. 4287137928. 0. 0. 0. 4292730333. 4281545523. 4281545523. 4280295440. 4294967041. 4294967041. 4292269630. 4278190080. 4278190080. 4278190080. 4288914238. 4285953586. 4286019447. 0. 0. 0. 0. 0. 0. 4288256409. 4281675327. 4289953790. 4290217981. 4280427042. 4287137928. 4287137928. 4282664004. 4284900966. 4284900966. 4291611852. 0. 0. 0. 0. 0. 0. 0. 4291611852. 4284169019. 4294924376. 4288897120. 4278190080. 4285942089. 4294601065. 4294924376. 4294924376. 4292243825. 4278190080. 4282664004. 0. 0. 0. 0. 4284900966. 4285703074. 4285703074. 4288661703. 4289986558. 4289986558. 4288661703. 4279967776. 4289986558. 4289986558. 4289986558. 4289986558. 4290246389. 4279967776. 4289986558. 4289986558. 4289986558. 4283194203. 4289374890. 4286019447. 4281545523. 4291331136. 4294934273. 4287456057. 4286019447. 4292730333. 4284900966. 4284900966. 4291611852. 0. 0. 0. 0. 0. 0. 0. 4279245072. 4279212049. 4278227714. 4278227714. 4278227714. 4278227714. 4278227714. 4278227714. 4278227714. 4282355264. 4278190080. 4284900966. 0. 0. 0. 0. 4288256409. 4291134745. 4294934273. 4294150153. 4283381004. 4281869070. 4287137928. 4287461475. 4282789916. 4294934273. 4294934273. 4278190080. 4287137928. 4281545523. 4284170843. 4294934526. 4294934526. 4288901282. 4290493371. 0. 4286019447. 4278190080. 4293103074. 4294282996. 4280293152. 0. 0. 4286019447. 4287870529. 4289986305. 4289986305. 4288661568. 4290178355. 4289986305. 4289986305. 4289986305. 4285828409. 4278190080. 4289374890. 0. 0. 0. 0. 4286019447. 4289572096. 4284177193. 4294967041. 4294967041. 4292269630. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4292730333. 0. 0. 0. 0. 0. 0. 4281545523. 4289235413. 4289953790. 4286935202. 4278190080. 4279308561. 4290493371. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4290144617. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4294861410. 4280292886. 4278190080. 4292730333. 0. 0. 0. 4282664004. 4285703074. 4282664004. 4289782754. 4289986558. 4289986558. 4285828493. 4278190080. 4289782754. 4289986558. 4289986558. 4289986558. 4283194203. 4278190080. 4289986558. 4289986558. 4289986558. 4278190080. 4291611852. 4288256409. 4280427042. 4288901182. 4294934273. 4290149185. 4278190080. 4288901182. 4288901182. 4284170793. 4287137928. 0. 0. 0. 0. 0. 0. 4291611852. 4280895017. 4278227714. 4278227714. 4278227714. 4280130847. 4282218558. 4280852010. 4278227714. 4278227714. 4279212049. 4279245072. 4278190080. 4292730333. 0. 0. 0. 4286540373. 4294150153. 4294934273. 4294934273. 4294934273. 4292381204. 4291134745. 4293364495. 4294934273. 4294934273. 4294934273. 4279308561. 4287137928. 4282664004. 4285944950. 4294934526. 4294934526. 4291331271. 4287137928. 0. 4288256409. 4278190080. 4291331271. 4294934526. 4280293152. 4291611852. 0. 4283782485. 4288661568. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4288661568. 4278190080. 4279308561. 0. 0. 0. 0. 0. 4283782485. 4289572096. 4287466809. 4294967041. 4294967041. 4291348544. 4287137928. 4291611852. 4284900966. 4284900966. 4290493371. 0. 0. 0. 0. 0. 0. 4293848814. 4278190080. 4290152189. 4290152189. 4279965472. 4278190080. 4291611852. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4283782485. 4293096307. 4294924376. 4294924376. 4294924376. 4291325550. 4291325550. 4294924376. 4294924376. 4294924376. 4291325550. 4278190080. 4284900966. 0. 0. 0. 4280427042. 4285703074. 4281679679. 4290311668. 4289986558. 4289986558. 4279967776. 4284900966. 4287870646. 4289986558. 4289986558. 4288661703. 4278190080. 4281679679. 4289986558. 4289986558. 4290311668. 4278190080. 0. 4290493371. 4282664004. 4284170793. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4290149185. 4283782485. 0. 0. 0. 0. 0. 0. 4287137928. 4282418241. 4278227714. 4279212049. 4281489715. 4278190080. 4278190080. 4281952570. 4278227714. 4278227714. 4278227714. 4282418241. 4278190080. 4284900966. 0. 0. 0. 4282789916. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4278190080. 4282664004. 4288256409. 4283782485. 4285944950. 4294934526. 4294934526. 4293103074. 4282664004. 0. 4287137928. 4278190080. 4291331271. 4294934526. 4284170843. 4290493371. 0. 4281545523. 4289782585. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4288661568. 4278190080. 4278190080. 4289374890. 0. 0. 0. 0. 0. 4280427042. 4289572096. 4290164289. 4294967041. 4294967041. 4290164289. 4288256409. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4289374890. 4281675327. 4289953790. 4289760738. 4278190080. 4283782485. 0. 0. 4291611852. 4281675327. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4280427042. 4292730333. 0. 0. 4280292886. 4294861410. 4294924376. 4292243825. 4282329385. 4278190080. 4278190080. 4293751410. 4294924376. 4294924376. 4294861410. 4280292886. 4278190080. 4292730333. 0. 0. 4279308561. 4285703074. 4278190080. 4289986558. 4289986558. 4290248445. 4278190080. 4287137928. 4283194203. 4289986558. 4290312953. 4279967776. 4278190080. 4284642934. 4289986558. 4289986558. 4289255125. 4281545523. 0. 4292730333. 4282664004. 4280293136. 4294934273. 4294934273. 4290149185. 4278190080. 4278190080. 4278190080. 4283782485. 0. 0. 0. 0. 0. 0. 4283782485. 4281899578. 4278227714. 4282225983. 4278190080. 4278190080. 4282664004. 4279245072. 4278227714. 4278227714. 4278227714. 4280130847. 4278190080. 4278190080. 4292730333. 0. 4292730333. 4284102937. 4294934273. 4294934273. 4283381004. 4287916569. 4294934273. 4294934273. 4294150153. 4283381004. 4280947968. 4279308561. 4290493371. 4288256409. 4284900966. 4282330687. 4294934526. 4294934526. 4294871037. 4280293152. 4290493371. 4280427042. 4284170843. 4293758957. 4294934526. 4285944950. 4290493371. 0. 4279308561. 4290311465. 4289986305. 4290178355. 4288661568. 4289986305. 4290312734. 4278190080. 4278190080. 4287137928. 0. 0. 0. 0. 0. 4293848814. 4282664004. 4289572096. 4293124921. 4294967041. 4294967041. 4288914238. 4289374890. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288256409. 4284634230. 4289953790. 4289235413. 4278190080. 4287137928. 0. 0. 4288256409. 4285817741. 4289953790. 4289953790. 4289953790. 4289953790. 4290285300. 4278190080. 4284900966. 0. 4291611852. 4284169019. 4294924376. 4294924376. 4282329385. 4278190080. 4281545523. 4281545523. 4291325550. 4294924376. 4294924376. 4294924376. 4288897120. 4278190080. 4284900966. 0. 4293848814. 4279308561. 4285703074. 4283194203. 4289986558. 4289986558. 4289782754. 4278190080. 4284900966. 4278190080. 4286948258. 4283194203. 4278190080. 4279308561. 4287870646. 4289986558. 4289986558. 4287870646. 4283782485. 0. 0. 4280427042. 4282330653. 4294870800. 4294934273. 4280293136. 4278190080. 4283782485. 4284900966. 4291611852. 0. 0. 0. 0. 0. 0. 4279245072. 4279212049. 4278227714. 4282225983. 4278190080. 4284900966. 0. 4279245072. 4280852010. 4278227714. 4278227714. 4278227714. 4282218558. 4278190080. 4284900966. 0. 4288256409. 4288177716. 4294934273. 4290345790. 4281869070. 4280947968. 4283381004. 4294934273. 4294150153. 4279308561. 4279308561. 4287137928. 0. 4290493371. 4283782485. 4280293152. 4294871037. 4294934526. 4294934526. 4293758957. 4280293152. 4278190080. 4288901282. 4294934526. 4294934526. 4285944950. 4291611852. 4293848814. 4278190080. 4290248208. 4289986305. 4289254974. 4279967760. 4290248208. 4289986305. 4284900966. 4287137928. 0. 0. 0. 0. 0. 0. 4290493371. 4289572096. 4284177193. 4294309161. 4294967041. 4294967041. 4284177193. 4291611852. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288256409. 4284634230. 4289953790. 4289235413. 4278190080. 4288256409. 0. 0. 4288256409. 4287855542. 4289953790. 4289953790. 4289953790. 4289953790. 4290284537. 4278190080. 4284900966. 0. 4287137928. 4290144617. 4294924376. 4294924376. 4282329385. 4278190080. 4292730333. 4287137928. 4287452758. 4294924376. 4294924376. 4294924376. 4294601065. 4278190080. 4278190080. 4292730333. 4291611852. 4281545523. 4285703074. 4285828493. 4289986558. 4289986558. 4288661703. 4283782485. 4280427042. 4278190080. 4278190080. 4280427042. 4284900966. 4281545523. 4289782754. 4289986558. 4289986558. 4283194203. 4287137928. 0. 0. 4280427042. 4282664004. 4293102905. 4294934273. 4285944882. 4289374890. 0. 0. 0. 0. 4286019447. 4291611852. 0. 0. 4291611852. 4280895017. 4278227714. 4278227714. 4282225983. 4278190080. 4282664004. 0. 4283782485. 4282355264. 4278227714. 4280852010. 4282218558. 4278190080. 4278190080. 4278190080. 4292730333. 4284900966. 4291331136. 4294934273. 4285944882. 4280427042. 4278190080. 4280947968. 4282789916. 4294934273. 4291331136. 4285944882. 0. 0. 4293848814. 4279308561. 4287317642. 4293103074. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4285944950. 0. 4291611852. 4279967760. 4289986305. 4289986305. 4288661568. 4278190080. 4287137928. 4289986305. 4289986305. 4280427042. 4292730333. 0. 0. 0. 0. 0. 4287137928. 4289572096. 4282335005. 4294967041. 4294967041. 4294901264. 4278190080. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4289374890. 4279965472. 4289953790. 4290217981. 4278190080. 4284900966. 0. 0. 4292730333. 4278190080. 4285817741. 4289953790. 4288644295. 4279965472. 4286935202. 4282664004. 4286019447. 0. 4283782485. 4293096307. 4294924376. 4294924376. 4284169019. 4278190080. 4290493371. 4291611852. 4280292886. 4294924376. 4294924376. 4291325550. 4284169019. 4278190080. 4278190080. 4284900966. 4290493371. 4283782485. 4285703074. 4287870646. 4289986558. 4289986558. 4285828493. 4288256409. 0. 0. 4286019447. 4286019447. 4288256409. 4278190080. 4290248445. 4289986558. 4289986558. 4279967776. 4290493371. 0. 0. 4282664004. 4282664004. 4290149185. 4294934273. 4290149185. 4282664004. 4284900966. 4281545523. 4278190080. 4278190080. 4287456057. 4280293136. 0. 0. 4286019447. 4282418241. 4278227714. 4278227714. 4281507380. 4278190080. 4280427042. 0. 4286019447. 4280895017. 4280102941. 4282218558. 4278201601. 4278201601. 4282664004. 4278190080. 4291611852. 4280427042. 4294282793. 4294934273. 4280293136. 4280427042. 4290493371. 4281545523. 4278190080. 4294282793. 4294934273. 4280293136. 4292730333. 0. 0. 4283782485. 4287317642. 4285944950. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4294871037. 4290149302. 0. 4289374890. 4283194153. 4289986305. 4289986305. 4288661568. 4278190080. 4279308561. 4289986305. 4289986305. 4288256409. 4284900966. 0. 0. 0. 0. 0. 4284900966. 4289572096. 4285953586. 4294967041. 4294967041. 4293124921. 4281545523. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4293848814. 4278190080. 4288644295. 4289953790. 4289235413. 4278190080. 4287137928. 0. 0. 4283782485. 4287855542. 4289953790. 4287855542. 4278190080. 4281545523. 4284900966. 4290493371. 4293848814. 4278190080. 4294861410. 4294924376. 4294924376. 4285942089. 4278190080. 4288256409. 4293848814. 4278190080. 4284169019. 4285942089. 4288689975. 4288689975. 4290493371. 4280427042. 4282664004. 4288256409. 4284900966. 4284900966. 4286948258. 4289986558. 4289986558. 4281679679. 4291611852. 0. 0. 0. 4280427042. 4288256409. 4283194203. 4289986558. 4289986558. 4290311668. 4278190080. 4293848814. 0. 0. 4284900966. 4282664004. 4287456057. 4294934273. 4293758771. 4288901182. 4288901182. 4293758771. 4294934273. 4294934273. 4294934273. 4278190080. 4292730333. 0. 4281545523. 4281899578. 4278227714. 4278227714. 4282355264. 4278190080. 4279308561. 0. 4291611852. 4281545523. 4278201601. 4278201601. 4283782485. 4281545523. 4288256409. 0. 0. 4279308561. 4288901182. 4294934273. 4293102905. 4279308561. 4287137928. 4285944882. 4285944882. 4294934273. 4294934273. 4280293136. 4291611852. 0. 0. 4289374890. 4288256409. 4285944950. 4291331271. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4291331271. 4292730333. 0. 4287137928. 4284642866. 4289986305. 4289986305. 4286948158. 4278190080. 4278190080. 4289986305. 4289986305. 4289986305. 4279308561. 4292730333. 0. 0. 0. 0. 4281545523. 4289572096. 4290164289. 4294967041. 4294967041. 4290164289. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4278190080. 4289235413. 4289953790. 4290088176. 4283187803. 4278190080. 4278190080. 4283187803. 4290218490. 4290284537. 4279965472. 4278190080. 4293848814. 0. 0. 4289374890. 4284169019. 4294924376. 4294924376. 4294861410. 4282329385. 4278190080. 4287137928. 0. 4286019447. 4282664004. 4288689975. 4288689975. 4280427042. 4284900966. 4293848814. 0. 4287137928. 4278190080. 4278190080. 4278190080. 4278190080. 4286948258. 4279967776. 0. 0. 0. 4291611852. 4283782485. 4283782485. 4287870646. 4289986558. 4289986558. 4289255125. 4281545523. 0. 0. 0. 4287137928. 4284900966. 4280293136. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294674715. 4288901182. 4284170793. 4278190080. 4290493371. 4293848814. 4278190080. 4279212049. 4281507380. 4280895017. 4280102941. 4279308561. 4278190080. 0. 0. 4290493371. 4279308561. 4281545523. 4288256409. 0. 0. 0. 0. 4283782485. 4285944882. 4282330653. 4291331136. 4291611852. 4286019447. 4291331136. 4294934273. 4294934273. 4291331136. 4280293136. 4292730333. 0. 0. 0. 4282664004. 4287317642. 4280293152. 4293758957. 4294934526. 4294934526. 4294934526. 4294934526. 4294282996. 4291331271. 0. 0. 4287137928. 4286948158. 4289986305. 4289986305. 4285828409. 4281545523. 4279308561. 4279308561. 4289986305. 4289986305. 4286019447. 4284900966. 0. 0. 0. 0. 4280427042. 4283782485. 4293124921. 4294967041. 4294967041. 4284177193. 4291611852. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4278190080. 4284634230. 4288971733. 4289953790. 4289953790. 4289953790. 4289953790. 4288644295. 4279308561. 4278190080. 4284900966. 0. 0. 0. 4286019447. 4290144617. 4294924376. 4290144617. 4278190080. 4281545523. 4278190080. 4287137928. 0. 0. 4282664004. 4278190080. 4284900966. 4293848814. 0. 0. 0. 0. 4288256409. 4283782485. 4278190080. 4278190080. 4278190080. 4286019447. 0. 0. 0. 4287137928. 4278190080. 4278190080. 4289782754. 4289986558. 4289986558. 4287870646. 4286019447. 0. 0. 0. 4289374890. 4281545523. 4284170793. 4294282793. 4294934273. 4292249918. 4288901182. 4280293136. 4278190080. 4278190080. 4278190080. 4278190080. 4291611852. 4292730333. 4278190080. 4278190080. 4279308561. 4278201601. 4278201601. 4284900966. 4280427042. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288256409. 4284900966. 4294934273. 4280427042. 4280427042. 4287137928. 4293758771. 4294934273. 4290149185. 4280293136. 4280427042. 0. 0. 0. 0. 4291611852. 4288256409. 4287317642. 4278190080. 4288901282. 4294871037. 4294934526. 4291331271. 4288901282. 0. 0. 0. 4284900966. 4288661568. 4289986305. 4289986305. 4283194153. 4282664004. 4287137928. 4278190080. 4283782485. 4283782485. 4278190080. 4282664004. 0. 0. 0. 4291611852. 4278190080. 4278190080. 4278190080. 4287466809. 4288914238. 4284177193. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288256409. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4279308561. 4292730333. 0. 0. 0. 4284900966. 4278190080. 4278190080. 4285942089. 4288689975. 4288689975. 4279308561. 4288256409. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4287137928. 0. 0. 0. 0. 4286019447. 4278190080. 4278190080. 4278190080. 4285828493. 4289255125. 4283194203. 4289374890. 0. 0. 0. 4293848814. 4278190080. 4283782485. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4282664004. 0. 0. 4287137928. 4278190080. 4278201601. 4278201601. 4280427042. 4281545523. 4292730333. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4282664004. 4281545523. 4294934273. 4294934273. 4294934273. 4279308561. 4278190080. 4278190080. 4279308561. 4289374890. 0. 0. 0. 0. 0. 4287137928. 4284900966. 4279308561. 4278190080. 4278190080. 4284170843. 4293758957. 0. 0. 0. 0. 4288256409. 4278190080. 4289782585. 4286948158. 4278190080. 4282664004. 0. 4280427042. 4278190080. 4278190080. 4279308561. 4290493371. 0. 0. 0. 0. 4287137928. 4281545523. 4278190080. 4278190080. 4278190080. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4293848814. 4283782485. 4284900966. 4284900966. 4284900966. 4284900966. 4284900966. 4283782485. 4293848814. 0. 0. 0. 0. 4292730333. 4281545523. 4280427042. 4288689975. 4288689975. 4278190080. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288256409. 4280427042. 4278190080. 4278190080. 4278190080. 4280427042. 0. 0. 0. 0. 0. 4283782485. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4280427042. 4284900966. 4288256409. 0. 0. 0. 0. 0. 4290493371. 4280427042. 4279308561. 4286019447. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4282664004. 4279308561. 4280427042. 4280427042. 4279308561. 4282664004. 4290493371. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4283782485. 4278190080. 4281545523. 4278190080. 4286019447. 0. 4289374890. 4278190080. 4286019447. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4278190080. 4284900966. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4283782485. 4278190080. 4281545523. 4290493371. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4280427042. 4281545523. 4292730333. 0. 0. 0. 0. 0. 4289374890. 4278190080. 4279308561. 4284900966. 4287137928. 0. 0. 0. 0. 0. 0. 0 }.
	^ Form extent: 147@19 depth: 32 fromArray: bitmap offset: 0! !

!DWGUI class methodsFor: 'images' stamp: 'MP 2/1/2007 22:02'!
getComputerPlayerImage
	"returns the morph of the computer player image"
	| bitmap |

	bitmap := { 0. 0. 4140223170. 4135816579. 4133122658. 4132133742. 4130948194. 4129894994. 4129698135. 4129305173. 4129306441. 4133711474. 4139499966. 0. 0. 0. 0. 4285626228. 4280299851. 4280829535. 4281225580. 4282934400. 4284511896. 4283461796. 4281690279. 4282546870. 4281885318. 4279445297. 4286022028. 4206673863. 0. 0. 4285953410. 4283784854. 4290699504. 4290112492. 4290636002. 4292015092. 4285768378. 4279393171. 4281830610. 4282944971. 4279976566. 4282147996. 4163254607. 0. 0. 4286019458. 4284443018. 4291883519. 4290636031. 4291026681. 4292340988. 4285964222. 4279261595. 4281503198. 4282024655. 4280503950. 4283870173. 4162998106. 0. 0. 4285954938. 4283918709. 4291422463. 4291222271. 4291875325. 4293058559. 4286551738. 4279981979. 4281959902. 4283138764. 4280568701. 4282952423. 4162735972. 0. 0. 4285823605. 4283656312. 4291225343. 4290895871. 4291286778. 4292667134. 4286029232. 4279656088. 4281435364. 4282745033. 4280437872. 4283475942. 4163718495. 0. 0. 4285887863. 4284379012. 4291883007. 4291226111. 4291617535. 4292537855. 4286161592. 4279523731. 4281960161. 4283072969. 4280962675. 4283865296. 4163321664. 0. 0. 4285362290. 4282009946. 4286882238. 4287542744. 4288592870. 4290697198. 4285109428. 4280245920. 4282680550. 4284123864. 4279644247. 4282539136. 4170554520. 0. 0. 4288652191. 4281022267. 4278721589. 4279447622. 4280302427. 4281027688. 4281952122. 4281494165. 4281888179. 4281883532. 4279444782. 4290758600. 0. 0. 0. 0. 4287929754. 4278983468. 4280959565. 4280829021. 4279382348. 4280171853. 4280171611. 4278987359. 4279711319. 4280103723. 4287928211. 0. 0. 0. 4293454309. 4287073418. 4281418832. 4285234848. 4284971960. 4284579262. 4283528360. 4282738079. 4282999727. 4285170618. 4282473308. 4287205508. 0. 0. 4288257684. 4280361766. 4278190853. 4278190080. 4279047204. 4281284710. 4282866320. 4283658647. 4284249758. 4283720856. 4283061624. 4284575594. 4291942090. 0. 4169962381. 4278585625. 4284834440. 4287601319. 4282274641. 4278787596. 4278919199. 4279183667. 4281289027. 4283458903. 4286218622. 4291480780. 0. 0. 0. 4163253793. 4279572284. 4282599014. 4287405229. 4290501100. 4288594888. 4280895834. 4280563015. 4280955699. 4293586151. 0. 0. 0. 0. 0. 4174698960. 4284968556. 4280690990. 4280954686. 4283258997. 4283982471. 4282994798. 4284771442. 4283193157. 0. 0. 0. 0. 0. 0. 0. 0. 4288257420. 4283848784. 4283255893. 4284436855. 4284043878. 4284903261. 4291350464. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4141932764. 4134893425. 4131932220. 4136801924. 0. 0. 0. 0. 0. 0. 0. 0 }.
	^ Form extent: 15@17 depth: 32 fromArray: bitmap offset: 0! !

!DWGUI class methodsFor: 'images' stamp: 'MP 2/1/2007 22:02'!
getEndTurnImage
	"returns the morph for the endTurn button"
	| bitmap |

	bitmap := { 0. 0. 0. 0. 0. 0. 4287137928. 4284900966. 4281545523. 4278190080. 4282664004. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4292730333. 4284900966. 4284900966. 4278190080. 4286019447. 0. 0. 0. 0. 0. 4288256409. 4278190080. 4278190080. 4284642934. 4286019447. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4283782485. 4278190080. 4278190080. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4282664004. 4278190080. 4278190080. 4280427042. 4284900966. 4291611852. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4290493371. 4282264664. 4280232960. 4280232960. 4280232960. 4280232960. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4292730333. 4284900966. 4284900966. 4278190080. 4286019447. 0. 0. 0. 0. 4287137928. 4284900966. 4280292886. 4278190080. 4284169019. 4288897120. 4293751410. 4294601065. 4278190080. 4293848814. 0. 0. 0. 0. 0. 0. 4291611852. 4284900966. 4292730333. 0. 4290493371. 4279245072. 4282218558. 4282218558. 4282355264. 4281545523. 0. 0. 0. 0. 0. 4283782485. 4288661703. 4289986558. 4290178541. 4286948258. 4278190080. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4291611852. 4280427042. 4278190080. 4278190080. 4278190080. 4278190080. 4285822003. 4284900966. 4291611852. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4290493371. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4281545523. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287396518. 4289690862. 4289953790. 4289953790. 4289953790. 4289953790. 4280232960. 4278190080. 4283782485. 0. 0. 0. 0. 0. 0. 4291611852. 4284900966. 4292730333. 0. 4290493371. 4279967760. 4286948158. 4286948158. 4288661568. 4281545523. 0. 0. 4290493371. 4278190080. 4282329385. 4288897120. 4292243825. 4294924376. 4294924376. 4294924376. 4294924376. 4294861410. 4278190080. 4291611852. 0. 0. 0. 4287137928. 4278190080. 4279245072. 4282218558. 4282218558. 4280895017. 0. 4281545523. 4279245072. 4278227714. 4278227714. 4279212049. 4278190080. 4293848814. 0. 0. 0. 0. 4279967776. 4290312953. 4289986558. 4289986558. 4289986558. 4290182909. 4284642934. 4283194203. 4293848814. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4281545523. 4287269435. 4294309124. 4294309124. 4294309124. 4291019585. 4288651071. 4285822003. 4278190080. 4282269214. 4288651071. 4284900966. 4291611852. 0. 0. 0. 0. 4286019447. 4285944882. 4294934273. 4294934273. 4294934273. 4280293136. 4278190080. 4290493371. 0. 4293848814. 4284900966. 4290493371. 0. 0. 0. 0. 0. 0. 4284435833. 4289953790. 4289953790. 4282264664. 4282264664. 4278190080. 4289953790. 4289953790. 4283450721. 4285161083. 0. 0. 4287137928. 4278190080. 4279967760. 4286948158. 4286948158. 4283194153. 0. 4281545523. 4279967760. 4289986305. 4289986305. 4290248208. 4278190080. 4293848814. 0. 4282664004. 4278190080. 4294861410. 4294924376. 4294924376. 4294924376. 4291325550. 4288897120. 4278190080. 4278190080. 4279308561. 4293848814. 0. 0. 4289374890. 4278190080. 4281899578. 4278227714. 4278227714. 4278227714. 4281489715. 4282664004. 4281545523. 4278190080. 4279212049. 4278227714. 4278227714. 4279245072. 4291611852. 0. 0. 0. 4292730333. 4283194203. 4289986558. 4289986558. 4288661703. 4290178541. 4289986558. 4289986558. 4289255125. 4283194203. 4293848814. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4284900966. 4281545523. 4291019585. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4291874879. 4288651071. 4288651071. 4278190080. 4282269214. 0. 0. 4279308561. 4292249918. 4294934273. 4294934273. 4293758771. 4278190080. 4278190080. 4289374890. 0. 4287137928. 4284170793. 4288901182. 4278190080. 4278190080. 4287137928. 0. 0. 0. 4286076841. 4290219254. 4290088177. 4282264664. 4279308561. 0. 4283450721. 4289887987. 4289953790. 4284762496. 4291611852. 4289374890. 4278190080. 4289782585. 4289986305. 4289986305. 4289986305. 4284642866. 4282664004. 4281545523. 4278190080. 4290248208. 4289986305. 4289986305. 4279967760. 4291611852. 0. 4280427042. 4280427042. 4294601065. 4294924376. 4284169019. 4278190080. 4278190080. 4278190080. 4278190080. 4284900966. 4291611852. 0. 0. 0. 4280427042. 4286019447. 4282418241. 4278227714. 4278227714. 4278227714. 4281507380. 4278190080. 4286019447. 4279308561. 4280852010. 4278227714. 4278227714. 4280895017. 4288256409. 0. 0. 0. 4289374890. 4286948258. 4289986558. 4290312953. 4278190080. 4278190080. 4284642934. 4289986558. 4289986558. 4288661703. 4286019447. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4279308561. 4278190080. 4287269435. 4289901121. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4280229648. 0. 4291611852. 4278190080. 4294870800. 4294934273. 4294934273. 4288901182. 4278190080. 4279308561. 0. 0. 4283782485. 4291331136. 4294934273. 4294934273. 4290149185. 4278190080. 4293848814. 0. 4293848814. 4280818745. 4289953790. 4289953787. 4281545523. 4280427042. 0. 4286274205. 4289953790. 4289953790. 4289559786. 4287137928. 4280427042. 4286019447. 4287870529. 4289986305. 4289986305. 4289986305. 4290178355. 4278190080. 4286019447. 4279308561. 4290311465. 4289986305. 4289986305. 4283194153. 4288256409. 0. 4281545523. 4281545523. 4293096307. 4294924376. 4284169019. 4282664004. 4287137928. 0. 0. 0. 0. 0. 0. 0. 4280427042. 4278663432. 4281489715. 4278227714. 4278227714. 4278227714. 4278227714. 4280895017. 4283782485. 4281545523. 4281899578. 4278227714. 4278227714. 4281952570. 4287137928. 0. 0. 0. 4287137928. 4288661703. 4289986558. 4288661703. 4278190080. 4286019447. 4286948258. 4283194203. 4289986558. 4290248445. 4279308561. 4293848814. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4292730333. 4284900966. 4280427042. 4278190080. 4278190080. 4284111402. 4289901121. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4294309124. 4294045985. 4284111402. 0. 4287137928. 4284170793. 4294934273. 4294934273. 4294934273. 4280293136. 4278190080. 4283782485. 0. 4293848814. 4278190080. 4294870800. 4294934273. 4294934273. 4287456057. 4278190080. 4290493371. 0. 4290493371. 4284762496. 4289953790. 4289887987. 4286019447. 4280427042. 4289953790. 4286274205. 4289953790. 4289953790. 4289559786. 4287137928. 4280427042. 4289374890. 4284642866. 4289986305. 4289986305. 4289986305. 4289986305. 4283194153. 4283782485. 4281545523. 4289782585. 4289986305. 4289986305. 4285828409. 4287137928. 0. 4286019447. 4281545523. 4291325550. 4294924376. 4287452758. 4287137928. 4292730333. 4284900966. 4284900966. 4291611852. 0. 0. 0. 0. 4282664004. 4278663432. 4280895017. 4278227714. 4278227714. 4278227714. 4278227714. 4282225983. 4278190080. 4282664004. 4282355264. 4278227714. 4278227714. 4282418241. 4284900966. 0. 0. 0. 4283782485. 4290178541. 4289986558. 4285828493. 4278190080. 4279308561. 4286423971. 4285828493. 4288992981. 4289986558. 4285828493. 4289374890. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4291611852. 4281545523. 4281545523. 4280229648. 4294309124. 4294309124. 4291874879. 4278190080. 4278190080. 4278190080. 4288651071. 4285822003. 4287137928. 0. 4284900966. 4290149185. 4294934273. 4294934273. 4294282793. 4278190080. 4278190080. 4288256409. 0. 4289374890. 4284170793. 4294934273. 4294934273. 4294934273. 4280293136. 4278190080. 4288256409. 0. 4288256409. 4287522998. 4289953790. 4289887987. 4289231070. 4282856540. 4288377034. 4289953790. 4289953790. 4289953790. 4282856540. 4287137928. 4282664004. 4288256409. 4283194153. 4289986305. 4289986305. 4289986305. 4289986305. 4289254974. 4278190080. 4282664004. 4288661568. 4289986305. 4289986305. 4287870529. 4284900966. 0. 4288256409. 4280427042. 4288897120. 4294924376. 4290144617. 4278190080. 4288897120. 4288897120. 4282329385. 4287137928. 0. 0. 0. 0. 4283782485. 4287137928. 4280102941. 4278227714. 4278227714. 4278227714. 4278227714. 4278227714. 4279245072. 4281545523. 4281952570. 4278227714. 4278227714. 4282355264. 4283782485. 0. 0. 0. 4279308561. 4290248445. 4289986558. 4279967776. 4278190080. 4280427042. 4281545523. 4286019447. 4283194203. 4289986558. 4288661703. 4286019447. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4286019447. 4287137928. 4285822003. 4294309124. 4294309124. 4291874879. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4293848814. 0. 4281545523. 4291331136. 4294934273. 4294934273. 4291331136. 4278190080. 4278190080. 4293848814. 0. 4284900966. 4291331136. 4294934273. 4294934273. 4294282793. 4278190080. 4278190080. 4289374890. 0. 4287137928. 4289231070. 4289953790. 4289953790. 4289887987. 4289953790. 4289953790. 4289953790. 4289953790. 4288377034. 4280818745. 4289374890. 4283782485. 4287137928. 4281679645. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4279967760. 4281545523. 4285828409. 4289986305. 4289986305. 4288661568. 4283782485. 0. 4290493371. 4281545523. 4284169019. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4290144617. 4284900966. 0. 0. 0. 0. 4286019447. 4287137928. 4278190080. 4278227714. 4278227714. 4281952570. 4281507380. 4278227714. 4282355264. 4278190080. 4280895017. 4278227714. 4278227714. 4282225983. 4282664004. 0. 0. 4291611852. 4283194203. 4289986558. 4290246389. 4278190080. 4278190080. 4287137928. 4292730333. 4279308561. 4281679679. 4289986558. 4288661703. 4282664004. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4282664004. 4288256409. 4288651071. 4294309124. 4294309124. 4291019585. 4287137928. 4291611852. 4284900966. 4284900966. 4291611852. 0. 0. 4278190080. 4294282793. 4294934273. 4294934273. 4290149185. 4278190080. 4280427042. 0. 4293848814. 4280293136. 4294282793. 4294934273. 4294934273. 4291331136. 4278190080. 4278190080. 4291611852. 0. 4285161083. 4289887987. 4289953790. 4289953790. 4289953790. 4289953790. 4289953790. 4289953790. 4289887987. 4280818745. 4279308561. 0. 4286019447. 4287137928. 4278190080. 4289986305. 4289986305. 4285828409. 4290178355. 4289986305. 4288661568. 4278190080. 4283194153. 4289986305. 4289986305. 4289254974. 4282664004. 0. 4292730333. 4282664004. 4280292886. 4294924376. 4294861410. 4288897120. 4278190080. 4278190080. 4278190080. 4286019447. 0. 0. 0. 0. 4287137928. 4284900966. 4278190080. 4280130847. 4278227714. 4282218558. 4280102941. 4278227714. 4280130847. 4278190080. 4279245072. 4278227714. 4278227714. 4281507380. 4280427042. 0. 0. 4287137928. 4287870646. 4289986558. 4287870646. 4278190080. 4278190080. 4291611852. 0. 4286019447. 4283194203. 4289986558. 4287870646. 4280427042. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4280427042. 4287137928. 4291019585. 4294309124. 4294309124. 4289901121. 4288256409. 0. 0. 0. 0. 0. 4292730333. 4278190080. 4294870800. 4294934273. 4294934273. 4288901182. 4278190080. 4282664004. 0. 4287137928. 4285944882. 4294934273. 4294934273. 4294934273. 4287456057. 4278190080. 4280427042. 0. 0. 4283450721. 4289953790. 4289953790. 4289953790. 4289953790. 4289953790. 4289953790. 4289953787. 4280818745. 4278190080. 4288256409. 0. 4287137928. 4284900966. 4278190080. 4290312734. 4289986305. 4286948158. 4281679645. 4289986305. 4290312734. 4278190080. 4279967760. 4289986305. 4289986305. 4290178355. 4280427042. 0. 0. 4280427042. 4282329385. 4294861153. 4294924376. 4280292886. 4278190080. 4283782485. 4284900966. 4292730333. 0. 0. 0. 0. 4290493371. 4282664004. 4280427042. 4280852010. 4278227714. 4282355264. 4278190080. 4282225983. 4278227714. 4283782485. 4278190080. 4278227714. 4278227714. 4280130847. 4279245072. 0. 0. 4283782485. 4289782754. 4289986558. 4281679679. 4278190080. 4279308561. 0. 0. 4287137928. 4287870646. 4289986558. 4283194203. 4280427042. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4292730333. 4283782485. 4283782485. 4292664378. 4294309124. 4294309124. 4287269435. 4290493371. 0. 0. 0. 0. 0. 4292730333. 4278190080. 4294934273. 4294934273. 4294934273. 4291331136. 4278190080. 4279308561. 4292730333. 4280293136. 4293102905. 4294934273. 4294934273. 4294934273. 4280293136. 4278190080. 4286019447. 0. 0. 4281674054. 4289953790. 4289953790. 4289953790. 4289887987. 4289953790. 4289953790. 4280818745. 4278190080. 4287137928. 0. 0. 4290493371. 4282664004. 4280427042. 4290311465. 4289986305. 4288661568. 4278190080. 4289254974. 4289986305. 4283782485. 4278190080. 4289986305. 4289986305. 4290312734. 4279967760. 0. 0. 4280427042. 4283782485. 4293096307. 4294924376. 4284169019. 4289374890. 0. 0. 0. 0. 4286019447. 4291611852. 0. 4291611852. 4280427042. 4281545523. 4281899578. 4278227714. 4280852010. 4278190080. 4280427042. 4278227714. 4281507380. 4278190080. 4278227714. 4278227714. 4278227714. 4278190080. 0. 0. 4279967776. 4290182909. 4290246389. 4278190080. 4278190080. 4286019447. 0. 4293848814. 4281679679. 4290246389. 4290182909. 4278190080. 4281545523. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4289374890. 4286019447. 4284111402. 4294045985. 4294309124. 4294309124. 4284111402. 4292730333. 0. 0. 0. 0. 0. 4292730333. 4278190080. 4294934273. 4294934273. 4294934273. 4294870800. 4284170793. 4278190080. 4278190080. 4291331136. 4294934273. 4294934273. 4294934273. 4294282793. 4278190080. 4278190080. 4291611852. 0. 4293848814. 4280818745. 4289953790. 4289953790. 4289953787. 4282856540. 4289953790. 4289953790. 4289231070. 4287793059. 0. 0. 0. 4291611852. 4280427042. 4281545523. 4289782585. 4289986305. 4290311465. 4278190080. 4280427042. 4289986305. 4290178355. 4278190080. 4289986305. 4289986305. 4289986305. 4278190080. 0. 0. 4282664004. 4282664004. 4291325550. 4294924376. 4288897120. 4282664004. 4284900966. 4280427042. 4278190080. 4278190080. 4287452758. 4279308561. 0. 4293848814. 4278190080. 4283782485. 4282355264. 4278227714. 4278227714. 4280102941. 4282664004. 4281899578. 4278227714. 4278227714. 4278227714. 4278227714. 4278227714. 4280102941. 4292730333. 4291611852. 4283194203. 4289986558. 4287870646. 4278190080. 4278190080. 4290493371. 4291611852. 4283194203. 4288661703. 4289986558. 4289782754. 4278190080. 4283782485. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4287137928. 4280229648. 4294309124. 4294309124. 4294309139. 4280229648. 0. 0. 0. 0. 0. 0. 4293848814. 4278190080. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4288901182. 4278190080. 4281545523. 0. 0. 4291611852. 4282856540. 4289953790. 4289953790. 4289953787. 4280818745. 4289887987. 4289953790. 4289953790. 4282529363. 4292730333. 0. 0. 4293848814. 4278190080. 4283782485. 4288661568. 4289986305. 4289986305. 4281679645. 4282664004. 4289782585. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4281679645. 4292730333. 0. 4284900966. 4283782485. 4288897120. 4294924376. 4293751410. 4288897120. 4288897120. 4293751410. 4294924376. 4294924376. 4294861410. 4278190080. 4293848814. 0. 4279308561. 4283782485. 4282418241. 4278227714. 4278227714. 4281952570. 4278663432. 4281489715. 4278227714. 4278227714. 4278227714. 4278227714. 4278227714. 4280895017. 4291611852. 4287137928. 4288661703. 4289986558. 4289255125. 4279967776. 4278190080. 4278190080. 4285828493. 4290114032. 4289986558. 4289986558. 4281679679. 4278190080. 4288256409. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4283782485. 4288256409. 4287269435. 4294309124. 4294309124. 4292664378. 4283782485. 0. 0. 0. 0. 0. 0. 0. 4284170793. 4292249918. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294282793. 4278190080. 4278190080. 4288256409. 0. 0. 4289374890. 4286274205. 4289953790. 4289953790. 4289887987. 4278190080. 4282856540. 4289953790. 4289953790. 4289953787. 4289231070. 0. 0. 0. 4279308561. 4283782485. 4287870529. 4289986305. 4289986305. 4285828409. 4287137928. 4284642866. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4283194153. 4291611852. 0. 4287137928. 4284900966. 4280292886. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4294666087. 4288897120. 4284169019. 4278190080. 4290493371. 0. 4281545523. 4284900966. 4281952570. 4278227714. 4278227714. 4282355264. 4283782485. 4282218558. 4281507380. 4278227714. 4278227714. 4278227714. 4278227714. 4281489715. 4290493371. 4283782485. 4290178541. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4290311668. 4283194203. 4278190080. 4279308561. 4293848814. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4281545523. 4287137928. 4291019585. 4294309124. 4294309124. 4289901121. 4287137928. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4284170793. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294870800. 4284170793. 4278190080. 4281545523. 0. 0. 0. 4288256409. 4287522998. 4289953790. 4289953790. 4289559786. 4278190080. 4280818745. 4289231070. 4289953790. 4289953790. 4282856540. 4290493371. 0. 0. 4281545523. 4284900966. 4285828409. 4289986305. 4289986305. 4288661568. 4283782485. 4286948158. 4290178355. 4289986305. 4289986305. 4289986305. 4289986305. 4284642866. 4290493371. 0. 4289374890. 4281545523. 4284169019. 4294274927. 4294924376. 4292243825. 4288897120. 4280292886. 4278190080. 4278190080. 4278190080. 4278190080. 4291611852. 0. 4283782485. 4284900966. 4280895017. 4278227714. 4278227714. 4281899578. 4278190080. 4278663432. 4281489715. 4278227714. 4280130847. 4282218558. 4282218558. 4280102941. 4288256409. 4282664004. 4278190080. 4285828493. 4288661703. 4289986558. 4289986558. 4289986558. 4290178541. 4284642934. 4278190080. 4278190080. 4278190080. 4288256409. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4280427042. 4283782485. 4292664378. 4294309124. 4294309124. 4282269214. 4292730333. 0. 0. 0. 0. 0. 0. 0. 0. 4287456057. 4291331136. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294870800. 4284170793. 4278190080. 4280427042. 4293848814. 0. 0. 0. 4287137928. 4289231070. 4289953790. 4289953790. 4288377034. 4281545523. 4279308561. 4280818745. 4289953790. 4289953790. 4289559786. 4284900966. 0. 0. 4283782485. 4284900966. 4283194153. 4289986305. 4289986305. 4289782585. 4278190080. 4290493371. 4284642866. 4289986305. 4290312734. 4286948158. 4286948158. 4281679645. 4288256409. 0. 4293848814. 4278190080. 4283782485. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4282664004. 0. 0. 4286019447. 4286019447. 4278190080. 4278190080. 4278190080. 4278190080. 4279308561. 4282664004. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4289374890. 4290493371. 4282664004. 4284900966. 4283194203. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4281545523. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4291611852. 4278190080. 4278190080. 4278190080. 4288651071. 4288651071. 4284111402. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288901182. 4285944882. 4291331136. 4294934273. 4294934273. 4294934273. 4290149185. 4280293136. 4278190080. 4282664004. 4293848814. 0. 0. 0. 0. 4284900966. 4289887987. 4289953790. 4289953790. 4287522998. 4282664004. 4288256409. 4280818745. 4288377034. 4288377034. 4280818745. 4282664004. 0. 0. 4286019447. 4286019447. 4278190080. 4278190080. 4278190080. 4278190080. 4279308561. 4282664004. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4289374890. 0. 0. 4283782485. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4281545523. 4284900966. 4290493371. 0. 0. 0. 0. 4287137928. 4278190080. 4278190080. 4278190080. 4278190080. 4280427042. 4292730333. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4279308561. 0. 0. 4282664004. 4284900966. 4285304205. 4285304205. 4285304205. 4285304205. 4285304205. 4279308561. 4278190080. 4281545523. 4293848814. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4286019447. 4280427042. 4278190080. 4278190080. 4278190080. 4288256409. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4292730333. 4288901182. 4280293136. 4278190080. 4278190080. 4278190080. 4283782485. 4290493371. 0. 0. 0. 0. 0. 0. 4289374890. 4280818745. 4289953790. 4289231070. 4280818745. 4282664004. 0. 4280427042. 4278190080. 4278190080. 4279308561. 4290493371. 0. 0. 4287137928. 4278190080. 4278190080. 4278190080. 4278190080. 4280427042. 4292730333. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4279308561. 0. 0. 0. 4289374890. 4278190080. 4279308561. 4284900966. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 4292730333. 4278190080. 4283782485. 4293848814. 0. 0. 0. 4282664004. 4282664004. 4293848814. 4282664004. 4278190080. 4279308561. 4290493371. 0. 0. 4293848814. 4284900966. 4280427042. 4278190080. 4278190080. 4278190080. 4278190080. 4280427042. 4286019447. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4278190080. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4285161083. 4280818745. 4283450721. 4278190080. 4286019447. 0. 4290493371. 4278190080. 4286019447. 0. 0. 0. 0. 4292730333. 4278190080. 4283782485. 4293848814. 0. 0. 0. 4282664004. 4282664004. 4293848814. 4282664004. 4278190080. 4279308561. 4290493371. 0 }.
	^ Form extent: 117@19 depth: 32 fromArray: bitmap offset: 0! !

!DWGUI class methodsFor: 'images' stamp: 'MP 2/1/2007 22:02'!
getHumanPlayerImage
	"returns the morph of the human player image"
	| bitmap |

	bitmap := { 0. 0. 0. 4142193367. 4135088240. 4130810153. 4136466544. 4139430062. 4140879826. 4137456274. 4140352964. 4142262249. 0. 0. 0. 0. 0. 4286412665. 4285484353. 4288377687. 4285486912. 4286010431. 4288375885. 4286999391. 4285093201. 4287127887. 4288313961. 4290821051. 0. 0. 0. 4287990666. 4288117094. 4286339392. 4288310607. 4292057202. 4290084455. 4291794532. 4290744163. 4284630327. 4287850060. 4291530336. 4287787094. 4292334034. 0. 4157129409. 4282593324. 4286339395. 4291992170. 4290808419. 4285220663. 4283052327. 4287720531. 4287588690. 4284434754. 4287525225. 4288442979. 4287257406. 4289568926. 0. 4153047670. 4288047429. 4290019929. 4291266650. 4288243014. 4282922278. 4284307286. 4291276200. 4292654506. 4293905610. 4294961118. 4294960609. 4287917673. 4287860366. 0. 4150941518. 4291203689. 4290808154. 4284169774. 4287130208. 4291535260. 4294826454. 4294959053. 4294957003. 4294959318. 4288913301. 4283329385. 4290286480. 4287463291. 0. 4151595326. 4293104477. 4288044860. 4285090370. 4293970879. 4293645003. 4292527293. 4294693061. 4294889157. 4294957773. 4286680453. 4286481280. 4294035134. 4289103227. 4154826911. 4154233230. 4289293120. 4290147913. 4286997342. 4294958806. 4280045132. 4283262562. 4294823370. 4294957005. 4294960086. 4294825419. 4294693062. 4294959063. 4294101436. 4151667043. 4155221672. 4284429860. 4289819464. 4285483842. 4293509304. 4289766813. 4294102728. 4294956751. 4292261039. 4286936944. 4287197802. 4293643456. 4292261295. 4294167234. 4152126817. 4154562711. 4286866517. 4290871375. 4287585352. 4293379000. 4294694856. 4293575610. 4294957773. 4294100929. 4288840573. 4291013799. 4290158490. 4284500811. 4294496717. 4153178220. 0. 4288582032. 4284168490. 4286732625. 4294955977. 4287000169. 4282003243. 4290289819. 4289959312. 4290288533. 4288514953. 4288584604. 4289830556. 4294959066. 4151796819. 0. 4289238667. 4290547074. 4292649877. 4294952632. 4292985273. 4285555038. 4284571746. 4290428093. 4290427579. 4292270040. 4292401625. 4292130223. 4294955981. 4150218819. 0. 4288979349. 4291534224. 4291136903. 4292978332. 4294957515. 4294694860. 4290092181. 4289043094. 4291873995. 4291676874. 4289240217. 4294695114. 4291471513. 4152590459. 0. 0. 4288718238. 4286283383. 4286212196. 4291467154. 4294955980. 4294959828. 4294101693. 4292983473. 4292917681. 4294299849. 4294959058. 4285883478. 4156736451. 0. 0. 0. 0. 4292336602. 4287596419. 4288315769. 4292851889. 4294959829. 4294960088. 4294960344. 4293445564. 4287725434. 4289375143. 0. 0. 0. 0. 0. 0. 0. 4140551884. 4136272511. 4135021925. 4135876979. 4135811442. 4135548785. 4139893441. 0. 0 }.
	^ Form extent: 15@16 depth: 32 fromArray: bitmap offset: 0! !

!DWGUI class methodsFor: 'images' stamp: 'MP 2/1/2007 22:02'!
getStartGameImage
	"returns the morph for the startGame button"
	| bitmap |

	bitmap := { 0. 0. 0. 0. 4287137928. 4283909235. 4279636000. 4279636000. 4283517787. 4288256409. 0. 0. 0. 4290493371. 4280427042. 4278190080. 4281545523. 4291611852. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4279308561. 4280427042. 4288256409. 0. 0. 0. 0. 0. 0. 0. 4290493371. 4280295424. 4280295424. 4280295424. 4278190080. 4278190080. 4278190080. 0. 0. 0. 0. 0. 4283782485. 4278190080. 4278190080. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4291611852. 4282664004. 4278190080. 4283782485. 4293848814. 0. 0. 0. 0. 0. 0. 0. 0. 4291611852. 4284171846. 4280290059. 4280290059. 4280290059. 4280290059. 4280290059. 4284900966. 4293848814. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4284900966. 4281545523. 4278190080. 4282664004. 0. 0. 0. 0. 0. 4290493371. 4281609790. 4285618326. 4289888506. 4289953790. 4289953790. 4288904158. 4279636000. 4283782485. 0. 0. 4283782485. 4281613854. 4279640064. 4279640064. 4279640064. 4282008858. 4285495641. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4292403681. 4288925150. 4279640096. 4288925150. 4288925150. 4289453547. 4279640096. 4279308561. 0. 0. 0. 0. 0. 0. 0. 4286019447. 4293188912. 4294967041. 4292137736. 4292137736. 4292137736. 4292137736. 4280295424. 4285164106. 0. 0. 4291611852. 4280427042. 4280291328. 4280291328. 4280291328. 4280291328. 4289423425. 4284900966. 4291611852. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4293848814. 4284900966. 4279644186. 4278194688. 4278194688. 4278194688. 4280699182. 4290493371. 0. 0. 0. 0. 0. 0. 0. 0. 4293951477. 4287387798. 4287387798. 4292115422. 4293164779. 4289423541. 4280291360. 4287137928. 0. 0. 0. 0. 0. 0. 0. 4290493371. 4278190080. 4280290059. 4294924376. 4294924376. 4294924376. 4294924376. 4294401122. 4287384154. 4287137928. 4280427042. 4278190080. 4283782485. 4290493371. 0. 0. 0. 0. 0. 0. 4287137928. 4284900966. 4279965472. 4278190080. 4283187803. 4286935202. 4290154477. 4290284537. 4278190080. 4293848814. 0. 0. 0. 4288452262. 4279636000. 4289691637. 4289953790. 4289953790. 4289953790. 4289953790. 4289953790. 4288904158. 4278190080. 4291611852. 0. 4279308561. 4285630010. 4289986305. 4289986305. 4289986305. 4289986305. 4288924986. 4288924986. 4282008858. 4279640064. 4288067904. 4285495641. 4287137928. 0. 0. 0. 0. 0. 0. 4288925150. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4287144885. 4278190080. 4288256409. 0. 0. 0. 0. 0. 0. 4283256109. 4294900997. 4294967041. 4280295424. 4280295424. 4278190080. 4292137736. 4294967041. 4283256109. 4285164106. 0. 4287137928. 4281545523. 4290867776. 4294934273. 4294934273. 4294934273. 4293951265. 4292115258. 4289423425. 4280291328. 4285285422. 4292115258. 4284900966. 4291611852. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4290493371. 4279644186. 4281692481. 4279144980. 4278227714. 4278227714. 4278227714. 4280699182. 4279308561. 4293848814. 0. 0. 0. 0. 0. 0. 4292730333. 4289423541. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4280291360. 4280427042. 0. 0. 0. 0. 0. 0. 0. 4279308561. 4281545523. 4282983723. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4293943146. 4280290059. 4285158741. 4289418857. 4294401122. 4289418857. 4285282886. 4286145636. 4293848814. 0. 4290493371. 4278190080. 4281675327. 4286935202. 4289235413. 4289953790. 4289953790. 4289953790. 4289953790. 4290217981. 4278190080. 4291611852. 0. 0. 4293848814. 4279636000. 4289953790. 4289953790. 4289953790. 4282002508. 4279636000. 4279636000. 4287129781. 4279636000. 4278190080. 4289374890. 4292730333. 4280427042. 4283918126. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4288924986. 4288924986. 4285630010. 4279640064. 4288256409. 0. 0. 4293848814. 4283918195. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4289986046. 4279640096. 4280427042. 0. 0. 0. 0. 0. 0. 4281282319. 4294967041. 4294967041. 4280295424. 4279308561. 0. 4283256109. 4294967041. 4294967041. 4285294382. 4291611852. 4284900966. 4281545523. 4293951265. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294410259. 4292115258. 4292115258. 4280291328. 4285285422. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287011206. 4278194688. 4279144980. 4278227714. 4278227714. 4278227714. 4278227714. 4278227714. 4280699182. 4278190080. 4292730333. 0. 0. 0. 0. 0. 0. 4288120727. 4293951477. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4287387798. 4278190080. 4288256409. 0. 0. 0. 0. 0. 4292730333. 4278190080. 4288033845. 4287384154. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4281276954. 4285282886. 4294924376. 4294924376. 4294924376. 4294924376. 4292108658. 4280290059. 4288256409. 4282664004. 4278190080. 4290217981. 4289953790. 4289953790. 4289953790. 4288644295. 4286935202. 4278190080. 4278190080. 4279308561. 4293848814. 0. 0. 4289374890. 4285618326. 4289953790. 4289953790. 4288904158. 4279636000. 4278190080. 4280427042. 4286019447. 4279308561. 4278190080. 4290493371. 4287137928. 4278190080. 4283918126. 4288924986. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289719073. 4287137928. 0. 0. 4289374890. 4288068043. 4289986558. 4287144885. 4279640096. 4289719285. 4289986558. 4289986558. 4283918195. 4278190080. 4289374890. 0. 0. 0. 0. 4293848814. 4280295424. 4294967041. 4294440211. 4283256109. 4280427042. 0. 4287399482. 4294967041. 4294967041. 4293188912. 4287137928. 4279308561. 4278190080. 4290867776. 4293164592. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4282985498. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4291611852. 4278194688. 4278227714. 4278227714. 4278227714. 4279931170. 4281304891. 4278194688. 4278194688. 4278194688. 4278190080. 0. 0. 0. 0. 0. 0. 0. 4287387798. 4294934526. 4294934526. 4280291360. 4282985548. 4294934526. 4294934526. 4294410490. 4280291360. 4281545523. 0. 0. 0. 0. 0. 4290493371. 4280427042. 4288033845. 4290862448. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4280290059. 4290862448. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4293943146. 4287137928. 4280427042. 4280427042. 4290284537. 4289953790. 4283187803. 4278190080. 4278190080. 4278190080. 4278190080. 4284900966. 4291611852. 0. 0. 0. 4289374890. 4288049867. 4289953790. 4289953790. 4289954046. 4279636000. 4286019447. 4293848814. 4284900966. 4279308561. 4284900966. 0. 0. 4287137928. 4283782485. 4279640064. 4279640064. 4279640064. 4288924986. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4289986305. 4288924986. 4289374890. 0. 0. 4287137928. 4289719285. 4289986558. 4279640096. 4281545523. 4288068043. 4289986558. 4289986558. 4289918458. 4279640096. 4282664004. 0. 0. 0. 0. 4290493371. 4285294382. 4294967041. 4293978913. 4286019447. 4280427042. 4294967041. 4287399482. 4294967041. 4294967041. 4293188912. 4287137928. 4292730333. 4284900966. 4280427042. 4280291328. 4280291328. 4287387706. 4293164592. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4294934273. 4287387706. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4280699182. 4279931170. 4278227714. 4278227714. 4281360187. 4281692481. 4284900966. 4280238369. 4280238369. 4283782485. 4280427042. 0. 0. 0. 0. 0. 0. 0. 4282985548. 4294934526. 4293164779. 4283252045. 4280291360. 4294934526. 4294934526. 4294934526. 4285285491. 4278190080. 4290493371. 0. 0. 0. 0. 4287137928. 4283782485. 4288033845. 4293157232. 4294924376. 4294924376. 4294924376. 4293943146. 4294924376. 4294924376. 4293943146. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4292108658. 4287137928. 4281545523. 4281545523. 4289760738. 4289953790. 4283187803. 4282664004. 4287137928. 0. 0. 0. 0. 0. 0. 0. 4293848814. 4285618326. 4289953790. 4289953790. 4289953790. 4289888506. 4283909235. 4289429227. 0. 0. 0. 0. 0. 0. 0. 0. 4286019447. 4278190080. 4282600749. 4289719073. 4289986305. 4289986305. 4283918126. 4279640064. 4279640064. 4285630010. 4288924986. 4283918126. 4293848814. 0. 0. 4284574314. 4289986046. 4289986558. 4279640096. 4282008908. 4289719285. 4289986558. 4289986558. 4289986558. 4282008908. 4278190080. 4291611852. 0. 0. 0. 4288256409. 4289438529. 4294967041. 4293978913. 4292136250. 4282991898. 4290885952. 4294967041. 4294967041. 4294967041. 4282991898. 4287137928. 0. 0. 0. 4291611852. 4281545523. 4281545523. 4282985498. 4294934273. 4294934273. 4294410259. 4280291328. 4280291328. 4280291328. 4292115258. 4289423425. 4288120695. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288256409. 4280699182. 4278227714. 4278227714. 4280168734. 4286024311. 4287137928. 4282664004. 4284900966. 4284900966. 4291611852. 0. 0. 0. 0. 0. 0. 0. 4291611852. 4287387798. 4294934526. 4289423541. 4280291360. 4289423541. 4294934526. 4294934526. 4294934526. 4293951477. 4280291360. 4283782485. 0. 0. 0. 0. 4286019447. 4286019447. 4286019447. 4293943146. 4294924376. 4294924376. 4293943146. 4282983723. 4294924376. 4294924376. 4294924376. 4294924376. 4294924376. 4285282886. 4294924376. 4294924376. 4294924376. 4287384154. 4289374890. 4286019447. 4281545523. 4288644295. 4289953790. 4285817741. 4287137928. 4292730333. 4284900966. 4284900966. 4291611852. 0. 0. 0. 0. 0. 4288904158. 4288904158. 4289953790. 4289953790. 4289953790. 4289953790. 4289888506. 4287129781. 4289888506. 0. 0. 0. 0. 0. 0. 4293848814. 4281545523. 4284574282. 4289986305. 4289986305. 4289986305. 4283918126. 4278190080. 4278190080. 4278190080. 4278190080. 4286019447. 0. 0. 0. 4282008908. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4289986558. 4289719285. 4279640096. 4284900966. 0. 0. 0. 4287137928. 4292136250. 4294967041. 4294967041. 4293978913. 4294967041. 4294967041. 4294967041. 4294967041. 4290885952. 4280295424. 4289374890. 0. 0. 0. 0. 4286019447. 4287137928. 4289423425. 4294934273. 4294934273. 4294410259. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4293848814. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4281155373. 4279144980. 4278227714. 4281304891. 4278194688. 4279308561. 4290493371. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4293164779. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4294934526. 4282985548. 4278190080. 4292730333. 0. 0. 0. 4283782485. 4287137928. 4284171846. 4294401122. 4294924376. 4294924376. 4292108658. 4280290059. 4294859099. 4294924376. 4294924376. 4294924376. 4287384154. 4280290059. 4294924376. 4294924376. 4294924376. 4280290059. 4291611852. 4288256409. 4280427042. 4286935202. 4289953790. 4287855542. 4278190080. 4286935202. 4286935202. 4281675327. 4287137928. 0. 0. 0. 0. 0. 4293848814. 4283909235. 4285618326. 4289888506. 4289953790. 4289953790. 4289953790. 4289953790. 4288049867. 4289439157. 0. 0. 0. 0. 0. 4290493371. 4286019447. 4285630010. 4289986305. 4289986305. 4289986305. 4279640064. 0. 4287137928. 4284900966. 4287137928. 0. 0. 0. 4291611852. 4285630102. 4289986558. 4289986558. 4289986558. 4289986558. 4288925150. 4289986558. 4289986558. 4289986558. 4289986558. 4282008908. 4278190080. 4292730333. 0. 0. 4283782485. 4293978913. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4293978913. 4280295424. 4279308561. 0. 0. 0. 0. 0. 4282664004. 4288256409. 4292115258. 4294934273. 4294934273. 4293951265. 4287137928. 4291611852. 4284900966. 4284900966. 4291611852. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4293848814. 4278194688. 4278227714. 4278227714. 4279644186. 4278190080. 4291611852. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4285160042. 4294869246. 4294934526. 4294934526. 4294934526. 4293951477. 4293951477. 4294934526. 4294934526. 4294934526. 4293951477. 4280291360. 4284900966. 0. 0. 0. 4281545523. 4288033845. 4282263849. 4294924376. 4294924376. 4294924376. 4287384154. 4284900966. 4293157232. 4294924376. 4294924376. 4293943146. 4280290059. 4282983723. 4294924376. 4294924376. 4294924376. 4280290059. 4293848814. 4290493371. 4281545523. 4283187803. 4289953790. 4289953790. 4289953790. 4289953790. 4289953790. 4287855542. 4284900966. 0. 0. 0. 0. 0. 0. 4291611852. 4280427042. 4279636000. 4285618326. 4289691637. 4289953790. 4289953790. 4289953790. 4282002508. 0. 0. 0. 0. 0. 4287137928. 4287137928. 4279640064. 4289986305. 4289986305. 4289986305. 4283918126. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4289453547. 4289986558. 4289986558. 4287144885. 4279640096. 4279640096. 4288068043. 4289986558. 4289986558. 4289986558. 4289453547. 4279640096. 4284900966. 0. 0. 4283256109. 4294900997. 4294967041. 4294967041. 4294967041. 4294967041. 4294967041. 4294440211. 4280295424. 4278190080. 4288256409. 0. 0. 0. 0. 0. 4280427042. 4287137928. 4293951265. 4294934273. 4294934273. 4293164592. 4288256409. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4289374890. 4280699182. 4278227714. 4278424326. 4278194688. 4283782485. 0. 0. 4291611852. 4280699182. 4278194688. 4278194688. 4278194688. 4278194688. 4278194688. 4280168734. 4292730333. 0. 0. 4282985548. 4294934526. 4294934526. 4294410490. 4282985548. 4280291360. 4280291360. 4294934526. 4294934526. 4294934526. 4294934526. 4280291360. 4278190080. 4292730333. 0. 0. 4279308561. 4288033845. 4280290059. 4294924376. 4294924376. 4294924376. 4280290059. 4288256409. 4287384154. 4294924376. 4294924376. 4282983723. 4278190080. 4287384154. 4294924376. 4294924376. 4294401122. 4283250744. 0. 4292730333. 4282664004. 4279965472. 4289953790. 4290217981. 4286935202. 4278190080. 4278190080. 4278190080. 4286019447. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4280427042. 4279636000. 4288904158. 4289953790. 4289953790. 4285618326. 4288256409. 0. 0. 0. 0. 4284900966. 4288256409. 4285630010. 4289986305. 4289986305. 4289986305. 4283521851. 0. 0. 0. 0. 0. 0. 0. 4284574314. 4289986046. 4289986558. 4289918458. 4279640096. 4278190080. 4282664004. 4282008908. 4289986558. 4289986558. 4289986558. 4289986558. 4279640096. 4278190080. 4292730333. 0. 4281282319. 4294967041. 4294967041. 4294967041. 4293978913. 4294967041. 4294967041. 4280295424. 4278190080. 4287137928. 0. 0. 0. 0. 0. 4292730333. 4283782485. 4285160010. 4294868997. 4294934273. 4294934273. 4290867776. 4290493371. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288256409. 4281692481. 4278227714. 4279144980. 4278190080. 4287137928. 0. 0. 4288256409. 4281630016. 4278227714. 4278227714. 4278227714. 4278227714. 4278227714. 4278194688. 4284900966. 0. 4291611852. 4287387798. 4294934526. 4294934526. 4285285491. 4278190080. 4281545523. 4282265150. 4293951477. 4294934526. 4294934526. 4294934526. 4292115422. 4280291360. 4284900966. 0. 0. 4279308561. 4288033845. 4285282886. 4294924376. 4294924376. 4294859099. 4280290059. 4286019447. 4280290059. 4292108658. 4287384154. 4280290059. 4280427042. 4293157232. 4294924376. 4294924376. 4293157232. 4283782485. 0. 0. 4280427042. 4281675327. 4290152189. 4289953790. 4279965472. 4278190080. 4283782485. 4284900966. 4292730333. 0. 0. 0. 0. 0. 4288256409. 4283782485. 4293848814. 0. 0. 4287137928. 4283909235. 4289953790. 4289953790. 4287129781. 4283782485. 0. 0. 0. 0. 4281545523. 4288256409. 4288924986. 4289986305. 4289986305. 4289985797. 4285495641. 0. 0. 0. 0. 0. 0. 0. 4282008908. 4289986558. 4289986558. 4289918458. 4278190080. 4284900966. 0. 4282008908. 4289986558. 4289986558. 4289986558. 4289986558. 4288925150. 4278190080. 4284900966. 4293848814. 4280295424. 4294967041. 4294967041. 4294440211. 4282991898. 4294967041. 4294967041. 4286151001. 4288124791. 0. 0. 0. 0. 0. 0. 4289374890. 4286019447. 4287387706. 4294934273. 4294934273. 4294934273. 4287387706. 4292730333. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288256409. 4281692481. 4278227714. 4279144980. 4278194688. 4288256409. 0. 0. 4288256409. 4280716593. 4278227714. 4278227714. 4278227714. 4278227714. 4278227714. 4278194688. 4284900966. 0. 4287137928. 4293164779. 4294934526. 4294934526. 4285285491. 4278190080. 4292730333. 4287137928. 4290867915. 4294934526. 4294934526. 4294934526. 4294934526. 4280291360. 4278190080. 4292730333. 4292730333. 4281545523. 4288033845. 4290862448. 4294924376. 4294924376. 4293943146. 4283782485. 4281545523. 4278190080. 4278190080. 4280427042. 4283782485. 4283250744. 4293943146. 4294924376. 4294924376. 4289418857. 4287137928. 0. 0. 4280427042. 4283782485. 4289760738. 4289953790. 4283187803. 4289374890. 0. 0. 0. 0. 4286019447. 4291611852. 0. 0. 4280427042. 4287137928. 4278190080. 4284900966. 4293848814. 4292730333. 4280688431. 4289888506. 4289953790. 4282002508. 4280427042. 0. 0. 0. 0. 4280427042. 4287469431. 4289719073. 4289986305. 4289986305. 4289453360. 4287137928. 0. 0. 0. 0. 0. 0. 4291611852. 4285630102. 4289986558. 4289986558. 4289918458. 4279640096. 4282664004. 0. 4284574314. 4289719285. 4289986558. 4289986558. 4288925150. 4279640096. 4278190080. 4278190080. 4291611852. 4282991898. 4294967041. 4294967041. 4294440211. 4280295424. 4288124791. 4294967041. 4294967041. 4285294382. 4292730333. 0. 0. 0. 0. 0. 4287137928. 4287137928. 4282985498. 4294934273. 4294934273. 4294934273. 4282985498. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4289374890. 4279644186. 4278227714. 4278227714. 4278194688. 4284900966. 0. 0. 4292730333. 4278194688. 4281630016. 4278227714. 4279931170. 4279644186. 4281304891. 4282076475. 4286019447. 0. 4285160042. 4294869246. 4294934526. 4294934526. 4285285491. 4278190080. 4290493371. 4291611852. 4282985548. 4294934526. 4294934526. 4293951477. 4287387798. 4280291360. 4278190080. 4284900966. 4290493371. 4283782485. 4288033845. 4293157232. 4294924376. 4294924376. 4290862448. 4287137928. 0. 0. 4286019447. 4284900966. 4288033845. 4280290059. 4294924376. 4294924376. 4294924376. 4282983723. 4290493371. 0. 0. 4282664004. 4282664004. 4288644295. 4289953790. 4286935202. 4282664004. 4284900966. 4280427042. 4278190080. 4278190080. 4283782485. 4279308561. 0. 4288256409. 4286019447. 4289953790. 4290284537. 4286935202. 4278190080. 4278190080. 4284634230. 4289953790. 4289691637. 4279636000. 4283782485. 0. 0. 0. 4291611852. 4283782485. 4288067904. 4289986305. 4289986305. 4289986305. 4285630010. 4291611852. 0. 0. 0. 0. 0. 0. 4286019447. 4289453547. 4289986558. 4289986558. 4289986558. 4279640096. 4280427042. 0. 4286019447. 4285630102. 4283918195. 4288925150. 4287469463. 4284713612. 4282664004. 4278190080. 4287137928. 4287399482. 4294967041. 4294967041. 4293978913. 4278190080. 4281282319. 4294967041. 4294967041. 4294440211. 4292136250. 0. 0. 0. 0. 0. 4283782485. 4288256409. 4290867776. 4294934273. 4294934273. 4294868997. 4285160010. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4293848814. 4278194688. 4279931170. 4278227714. 4278948625. 4278197504. 4285368942. 0. 0. 4283063370. 4280716593. 4278227714. 4280716593. 4278190080. 4281545523. 4284900966. 4290493371. 4293848814. 4280291360. 4294934526. 4294934526. 4294934526. 4289423541. 4278190080. 4288256409. 4293848814. 4280291360. 4287387798. 4290867915. 4292115422. 4285611378. 4285611378. 4279308561. 4283782485. 4288256409. 4284900966. 4284900966. 4292108658. 4294924376. 4294924376. 4287384154. 4291611852. 0. 0. 0. 4280427042. 4288033845. 4287384154. 4294924376. 4294924376. 4294924376. 4280290059. 4293848814. 0. 0. 4284900966. 4283782485. 4286935202. 4289953790. 4290154477. 4286935202. 4286935202. 4290154477. 4289953790. 4289953790. 4289953790. 4278190080. 4293848814. 4283782485. 4282664004. 4287855542. 4289953790. 4289953790. 4289953790. 4289953790. 4290217981. 4284900966. 4278190080. 4278190080. 4287137928. 0. 0. 0. 4289374890. 4286019447. 4282008858. 4289986305. 4289986305. 4289986305. 4282008858. 0. 0. 0. 0. 0. 0. 0. 4282600781. 4289986046. 4289986558. 4289986558. 4289719285. 4279640096. 4279308561. 0. 4291611852. 4281545523. 4290493371. 4290493371. 4283782485. 4281545523. 4288256409. 0. 4288256409. 4289438529. 4294967041. 4294967041. 4293188912. 4278190080. 4280295424. 4292136250. 4294967041. 4294967041. 4282991898. 4290493371. 0. 0. 0. 0. 4281545523. 4287137928. 4293951265. 4294934273. 4294934273. 4293164592. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4278194688. 4279144980. 4278227714. 4278227714. 4280316199. 4278194688. 4278194688. 4280577580. 4278227714. 4278227714. 4279644186. 4278190080. 4293848814. 0. 0. 4289374890. 4287387798. 4294934526. 4294934526. 4294934526. 4285285491. 4278190080. 4287137928. 0. 4284900966. 4283782485. 4285611378. 4286019447. 4280427042. 4284900966. 4293848814. 0. 4289374890. 4278190080. 4278190080. 4280290059. 4280290059. 4292108658. 4280290059. 0. 0. 0. 4291611852. 4283782485. 4284900966. 4293157232. 4294924376. 4294924376. 4294859099. 4283250744. 0. 0. 0. 4287137928. 4284900966. 4279965472. 4289953790. 4289953790. 4289953790. 4289953790. 4289953790. 4290284537. 4289953790. 4281545523. 4278190080. 4290493371. 4287137928. 4281545523. 4281675327. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4279308561. 4293848814. 0. 0. 0. 4287137928. 4286019447. 4285630010. 4289986305. 4289986305. 4289918227. 4285495641. 0. 0. 0. 0. 0. 0. 4293848814. 4279640096. 4289986558. 4289986558. 4285630102. 4283918195. 4279308561. 4278190080. 0. 0. 4290493371. 4279308561. 4281545523. 4288256409. 0. 0. 0. 4287137928. 4292136250. 4294967041. 4294967041. 4290885952. 4281545523. 4279308561. 4280295424. 4294967041. 4294967041. 4293188912. 4284900966. 0. 0. 0. 0. 4280427042. 4283782485. 4294868997. 4294934273. 4294934273. 4285285422. 4292730333. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4278190080. 4281300282. 4278293252. 4278227714. 4278227714. 4278227714. 4278227714. 4279931170. 4279181839. 4278194688. 4284900966. 0. 0. 0. 4286019447. 4293164779. 4294934526. 4293164779. 4280291360. 4283252045. 4278190080. 4287137928. 0. 0. 4282664004. 4278190080. 4284900966. 4293848814. 0. 0. 0. 0. 4288256409. 4283782485. 4278190080. 4278190080. 4278190080. 4286019447. 0. 0. 0. 4287137928. 4278190080. 4278190080. 4294859099. 4294924376. 4294924376. 4293157232. 4286019447. 0. 0. 0. 4289374890. 4281545523. 4283187803. 4290285300. 4289953790. 4289235413. 4286935202. 4279965472. 4278190080. 4278190080. 4278190080. 4278190080. 4291611852. 4293848814. 4280427042. 4284895111. 4284895111. 4284895111. 4284895111. 4284895111. 4278190080. 4278190080. 4278190080. 4290493371. 0. 0. 0. 0. 4283782485. 4278190080. 4279640064. 4285630010. 4288924986. 4285630010. 4289374890. 0. 0. 0. 0. 0. 0. 4292730333. 4279640096. 4279640096. 4280692527. 4287469463. 4284713612. 4284900966. 4280427042. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4284900966. 4293978913. 4294967041. 4294967041. 4289438529. 4282664004. 4288256409. 4280295424. 4290885952. 4290885952. 4280295424. 4282664004. 0. 0. 0. 4291611852. 4278190080. 4278190080. 4280291328. 4292115258. 4292115258. 4287387706. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288256409. 4278190080. 4278190080. 4278194688. 4278194688. 4278194688. 4278194688. 4278190080. 4278190080. 4279308561. 4292730333. 0. 0. 0. 4284900966. 4280291360. 4280291360. 4289423541. 4285611378. 4285611378. 4279308561. 4288256409. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4287137928. 0. 0. 0. 0. 4286019447. 4278190080. 4278190080. 4280290059. 4290862448. 4294401122. 4287384154. 4289374890. 0. 0. 0. 4293848814. 4278190080. 4283782485. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4282664004. 0. 0. 4287137928. 4281545523. 4278190080. 4278190080. 4278190080. 4278190080. 4279308561. 4284900966. 4292730333. 0. 0. 0. 0. 0. 4290493371. 4283782485. 4278190080. 4278190080. 4278190080. 4280427042. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4278190080. 4287137928. 4288256409. 4280427042. 4281545523. 4292730333. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4289374890. 4280295424. 4294900997. 4292136250. 4280295424. 4282664004. 0. 4280427042. 4278190080. 4278190080. 4279308561. 4290493371. 0. 0. 0. 0. 4286019447. 4280427042. 4278190080. 4278190080. 4278190080. 4288256409. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4293848814. 4283782485. 4284900966. 4284900966. 4284900966. 4284900966. 4284900966. 4283782485. 4293848814. 0. 0. 0. 0. 4292730333. 4281545523. 4280427042. 4285611378. 4283782485. 4278190080. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288256409. 4281545523. 4278190080. 4278190080. 4278190080. 4280427042. 0. 0. 0. 0. 0. 4283782485. 4278190080. 4278190080. 4278190080. 4278190080. 4278190080. 4281545523. 4284900966. 4290493371. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4292730333. 4281545523. 4280427042. 4292730333. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4290493371. 4280427042. 4279308561. 4286019447. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4283782485. 4278190080. 4281545523. 4278190080. 4286019447. 0. 4290493371. 4278190080. 4286019447. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4278190080. 4287137928. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4283782485. 4278190080. 4282664004. 4290493371. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287137928. 4280427042. 4281545523. 4292730333. 0. 0. 0. 0. 0. 4289374890. 4278190080. 4279308561. 4284900966. 4287137928. 0. 0. 0. 0. 0. 0. 0 }.
	^ Form extent: 150@19 depth: 32 fromArray: bitmap offset: 0! !

!DWGUI class methodsFor: 'position constants' stamp: 'MP 2/1/2007 22:05'!
getAddButtonPosition
	"returns the position of the add button depending on the playerlistpanel position"

	^ 	(self getPlayerlistPanelPosition x + 
		self getPanelInset x ) 
		@ 
		(self getPlayerlistPanelPosition y + 
		self getPlayerlistPanelSize y - 
		self getPanelInset y - 
		self getAddButtonSize y)! !

!DWGUI class methodsFor: 'position constants' stamp: 'MP 2/1/2007 22:05'!
getGameButtonPosition
	"returns the position of the game button depending on the position of the playerlistpanel"

	^ 	self getPlayerlistPanelPosition x 
		@
		(self getPlayerlistPanelPosition y + 
		self getPlayerlistPanelSize y + 
		self getWindowSubmorphInset y)! !

!DWGUI class methodsFor: 'position constants' stamp: 'MP 2/1/2007 22:06'!
getMainWindowPosition
	"returns the position of the mainwindow"

	^ 25 @ 25! !

!DWGUI class methodsFor: 'position constants' stamp: 'MP 2/1/2007 22:06'!
getMapPanelPosition
	"returns the position of the map panel depending on the mainwindow position"

	^ self getMainWindowPosition + self getWindowInset! !

!DWGUI class methodsFor: 'position constants' stamp: 'MP 2/1/2007 22:07'!
getMovePanelPosition
	"returns the position of the move panel depending on the position of the mappanel"

	^ 	self getMapPanelPosition x
		@
		(self getMapPanelPosition y + 
		self getMapPanelSize y + 
		self getWindowSubmorphInset y)! !

!DWGUI class methodsFor: 'position constants' stamp: 'MP 2/1/2007 22:08'!
getPlayerlistPanelPosition
	"returns the position of the playerlist panel depending on the position of the mappanel"

	^ 	(self getMapPanelPosition x + 
		self getMapPanelSize x + 
		self getWindowSubmorphInset x)
		@ 
		self getMapPanelPosition y! !

!DWGUI class methodsFor: 'position constants' stamp: 'MP 2/1/2007 22:09'!
getTurnButtonPosition
	"returns the position of the endTurn button (in the center of the movepanel)"

	^ 	self getMovePanelPosition +
		((( self getMovePanelSize x / 2 ) - 
		( self getTurnButtonSize x / 2 ))
		@
		(( self getMovePanelSize y / 2 ) + 
		( self getTurnButtonSize y / 8 )))! !

!DWGUI class methodsFor: 'size constants' stamp: 'MP 2/1/2007 22:09'!
getAddButtonSize
	"returns the size of the add button depending on the size of the playerlist panel"

	^ ( self getPlayerlistPanelSize x - ( 2 * self getPanelInset x ) ) @ 20! !

!DWGUI class methodsFor: 'size constants' stamp: 'MP 2/1/2007 22:10'!
getGameButtonSize
	"returns the size of the game button depending on the size of the startgame image"

	^ 200 @ ( self getStartGameImage extent y + self getPanelInset y )! !

!DWGUI class methodsFor: 'size constants' stamp: 'MP 2/1/2007 22:15'!
getMainWindowSize
	"returns the size of the mainwindow depending on the size of all components"

	^	(self getWindowInset x +
		self getMapPanelSize x +
		self getWindowSubmorphInset x +
		self getGameButtonSize x +
		self getWindowInset x)
		@
		(self getWindowInset y +
		self getMapPanelSize y +
		self getWindowSubmorphInset y +
		self getMovePanelSize y +
		self getWindowInset y)! !

!DWGUI class methodsFor: 'size constants' stamp: 'MP 2/1/2007 22:12'!
getMapPanelSize
	"returns the size of the mappanel depending on the fixed size of the map"

	^ 	(self getPanelInset x + 
		self getMapSize x + 
		self getPanelInset x)
		@
		(self getPanelInset y + 
		self getMapSize y + 
		self getPanelInset y)! !

!DWGUI class methodsFor: 'size constants' stamp: 'MP 2/1/2007 22:13'!
getMapSize
	"returns the fixed size of the map"

	^ 720 @ 430! !

!DWGUI class methodsFor: 'size constants' stamp: 'MP 2/1/2007 22:16'!
getMovePanelSize
	"returns the size of the movepanel depending on the size of the mappanel"

	^ self getMapPanelSize x @ 100! !

!DWGUI class methodsFor: 'size constants' stamp: 'MP 2/1/2007 22:17'!
getPlayerlistPanelSize
	"returns the size of the playerlist panel depending on the size of the game button and the map panel"

	^ 	self getGameButtonSize x
		@
		(self getMapPanelSize y + 
		self getMovePanelSize y - 
		self getGameButtonSize y)! !

!DWGUI class methodsFor: 'size constants' stamp: 'MP 2/1/2007 22:19'!
getPlayerPanelSize
	"returns the size of a playerinfo panel from the playerlist panel depending on the width of the playerpanel"

	^ ( self getPlayerlistPanelSize x - ( 2 * self getPanelInset x ) ) @ 15! !

!DWGUI class methodsFor: 'size constants' stamp: 'MP 2/1/2007 22:20'!
getTurnButtonSize
	"returns the size of the endTurn button depending on the size of the endTurn image"

	^ self getEndTurnImage extent + ( 40 @ 10 )! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:21'!
getButtonBorderColor
	"returns the border color of the endTurn and the game button"

	^ Color black! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:21'!
getButtonBorderWidth
	"returns the border width of the endTurn and game button"

	^ 1! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:21'!
getButtonColor
	"returns the background color of the endTurn and game button"

	^ Color white! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:22'!
getButtonCornerStyle
	"returns the corner style of the endTurn and game button border"

	^ #rounded! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:22'!
getPanelColor
	"returns the background color of a panel"

	^ Color white! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:22'!
getPanelCornerStyle
	"returns the corner style of a panel border"

	^ #rounded! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:24'!
getPanelInset
	"returns a point, which represents the horizontal and vertical layout inset of the panels"

	^ 15 @ 15! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:24'!
getPanelSubmorphInset
	"returns a point, which represents the horizontal and vertical cell inset of the panels"

	^ 10 @ 10! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:25'!
getPLButtonBorderColor
	"returns the color of the button border of buttons in the playerlist"

	^ Color black! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:25'!
getPLButtonBorderWidth
	"returns the width of the button border of buttons from the playerlist"

	^ 1! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:25'!
getPLButtonColor
	"returns the background color of the playerlist buttons"

	^ Color white! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:25'!
getPLButtonCornerStyle
	"returns the corner style of buttons from the playerlist"

	^ #squared! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/9/2007 16:36'!
getThemeColor
	
	^ Color red! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:25'!
getWindowInset
	"returns a point, which represents the horizontal and vertical layout inset of the mainwindow"

	^ 25 @ 25! !

!DWGUI class methodsFor: 'style constants' stamp: 'MP 2/1/2007 22:25'!
getWindowSubmorphInset
	"returns a point, which represents the horizontal and vertical cell inset of the mainwindow"

	^ 20 @ 20! !

!DWGUI class methodsFor: 'instance creation' stamp: 'MP 2/1/2007 22:02'!
new: aGame
	"initializes a new mainwindow and sets the game reference"

	super initialize.
	^ self basicNew setGame: aGame;
		initialize;
		yourself! !

!DWGUI class methodsFor: 'color' stamp: 'DH 2/1/2007 14:43'!
colorHighlightedSector
	^ self colorSectorBorder! !

!DWGUI class methodsFor: 'color' stamp: 'MP 2/9/2007 16:43'!
colorPlayer: anInt

	^ Color
		"Pl.#	1[violet]	2[cyan]	3[yellow]	4[darkgreen]		5[orange]		6[lightgreen]	7[red]		8[pink]"
		r: 	(({	179.		179.		255.		0.					255.			179.			255.		255} at: anInt) / 255)
		g:	(({	127.		255.		255.		147.				127.			255.			88.			127} at: anInt) / 255)
		b:	(({	254.		254.		1.			2.					1.				1.				88.			254} at: anInt) / 255)! !

!DWGUI class methodsFor: 'color' stamp: 'MP 2/1/2007 22:02'!
colorSectorBorder

	^ Color r: (34/255) g: (34/255) b: (68/255)! !

!DWGUI class methodsFor: 'color' stamp: 'MP 2/1/2007 22:02'!
widthSectorBorder

	^ 3! !

!DWGUI class methodsFor: 'dices' stamp: 'MP 2/11/2007 21:58'!
dice1
	"violet dice"

	^ {0. 0. 0. 0. 0. 0. 0. 0. 4286470313. 4286275226. 4286275226. 4286275226. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4286470313. 4286470313. 4286470313. 4286667437. 4286536106. 4286274210. 4286275226. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286404519. 4286404519. 4286404519. 4286274211. 4286275226. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286535850. 4286470312. 4286470313. 4286470313. 4286273189. 4286470313. 4286470313. 4286275226. 0. 0. 0. 0. 0. 0. 0. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286338982. 4286470313. 4286470313. 4286470313. 4286470313. 4286275226. 0. 0. 0. 0. 0. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4288249528. 4291345620. 4289303235. 4286470313. 4286404519. 4286338982. 4286470313. 4286470313. 4286470313. 4286470313. 4282790238. 0. 0. 0. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4290686416. 4294967295. 4292398565. 4286470313. 4286470056. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4282790238. 4282790238. 0. 4289296355. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4287062451. 4288379838. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4285090445. 4280687154. 4279569693. 4290485216. 4289690602. 4288967645. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286601642. 4285878940. 4281147198. 4279569693. 4279569693. 4287195567. 4285813405. 4287324860. 4288376273. 4287784644. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286667437. 4286076065. 4281475652. 4280293670. 4279832867. 4279832867. 4284828548. 4284499074. 4284170111. 4285024143. 4287061942. 4287916231. 4287521726. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286799023. 4286076065. 4281607238. 4279503899. 4285031278. 4284767850. 4279832867. 4284828548. 4284828548. 4290886090. 4286672027. 4284235390. 4285353364. 4287127736. 4287850438. 4286470313. 4286470313. 4286470313. 4286470313. 4286470313. 4286930354. 4285944734. 4281475907. 4279569949. 4280359210. 4285952636. 4282004290. 4279832865. 4284104060. 4284828548. 4292729315. 4293189609. 4284367487. 4284367487. 4284498818. 4285747355. 4287587520. 4287850438. 4286470313. 4286470313. 4286470313. 4285418900. 4281278783. 4279701535. 4280029989. 4280095782. 4280425003. 4279832867. 4279832865. 4284104060. 4284104060. 4285025927. 4287527589. 4284367487. 4284367487. 4284433281. 4284104315. 4284235392. 4286470314. 4287719107. 4286470313. 4285155982. 4281147453. 4279767071. 4280029989. 4280029989. 4279964452. 4279832866. 4279964452. 4279832865. 4284367742. 4284367742. 4287067805. 4285026182. 4284367487. 4284367487. 4284301694. 4289635514. 4288713137. 4284104572. 4285353364. 4285419157. 4281870155. 4279832865. 4280029989. 4280029989. 4280029989. 4279964452. 4279964452. 4279832865. 0. 0. 4285092485. 4292202715. 4293321450. 4284367487. 4284367487. 4284367487. 4289503420. 4294967295. 4286869661. 4284367487. 4283513197. 4280490288. 4279964195. 4279832610. 4279898403. 4280029989. 4279964452. 4279964452. 4279832865. 0. 0. 4284763520. 4286277525. 4290951373. 4284367487. 4284367487. 4284367487. 4283906936. 4287132831. 4285486988. 4284367487. 4283513197. 4280227370. 4279767073. 4281148725. 4280820017. 4279832866. 4279964452. 4279832865. 0. 0. 0. 0. 4284763520. 4284763520. 4284367487. 4284367487. 4284367487. 4287002010. 4286672791. 4283709557. 4284367487. 4283513197. 4280029991. 4280425259. 4286610821. 4282793805. 4279503901. 4279832865. 0. 0. 0. 0. 0. 0. 4284367487. 4284367487. 4284367487. 4284367487. 4289108660. 4294967295. 4287133085. 4284367487. 4283513197. 4279898404. 4281675324. 4286281344. 4280491052. 4279832865. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4284170872. 4284170872. 4284170872. 4289568955. 4286935963. 4284367487. 4283513197. 4280095783. 4280162087. 4280425003. 4279832865. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4290293444. 4284237176. 4283578481. 4284367487. 4283513197. 4280029989. 4279898659. 4279832865. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4289635514. 4284367487. 4283513197. 4279832865. 0. 0. 0. 0. 0. 0. 0. 0}! !

!DWGUI class methodsFor: 'dices' stamp: 'MP 2/11/2007 21:59'!
dice2
	"cyan dice"

	^ {0. 0. 0. 0. 0. 0. 0. 0. 4288071880. 4285641907. 4286166195. 4288463554. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4288334024. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4286894287. 4286894287. 4286894287. 4283992970. 4283663235. 4286894287. 4286894287. 4286894287. 4286038207. 4289122512. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4286894287. 4286894287. 4286894287. 4285113764. 4278255616. 4278190080. 4284388499. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4288069310. 0. 0. 0. 0. 0. 0. 0. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4283399034. 4283069298. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4284717978. 0. 0. 0. 0. 0. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4282152565. 0. 0. 0. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4281301368. 4283329130. 0. 4291427837. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4284459946. 4278798407. 4280044362. 4291163637. 4292673535. 4290836470. 4287618267. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4285509037. 4285047971. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4285446841. 4279720023. 4278203443. 4278203443. 4287023817. 4285446841. 4288536285. 4289852916. 4288341219. 4286894287. 4286894287. 4286894287. 4286894287. 4285904565. 4278651402. 4278190080. 4284256399. 4286894287. 4286894287. 4286894287. 4285710270. 4280049245. 4278200875. 4278529070. 4278529070. 4284918955. 4283802530. 4283802530. 4283598471. 4287617239. 4288538341. 4286894287. 4286894287. 4286894287. 4286894287. 4282145883. 4281420362. 4286894287. 4286894287. 4286762958. 4285776063. 4280180318. 4278202416. 4278981144. 4278982686. 4278529070. 4285115820. 4283802530. 4280762691. 4278190080. 4282216818. 4285184183. 4287551703. 4288473319. 4286894287. 4286894287. 4286894287. 4286894287. 4286894287. 4286960080. 4285578684. 4279917402. 4278202929. 4278399795. 4279175955. 4278659629. 4278269751. 4285838001. 4283802530. 4283802530. 4279770402. 4281819234. 4283868837. 4283340437. 4285050028. 4288079332. 4288341733. 4286894287. 4286894287. 4286894287. 4284854961. 4279588437. 4278202673. 4278270264. 4278335030. 4278529584. 4278269751. 4278269751. 4286954170. 4283802530. 4280499006. 4279440409. 4283802530. 4283868837. 4281489754. 4278649608. 4282743676. 4286631886. 4288144354. 4287223252. 4284460203. 4279391315. 4278202930. 4278270264. 4278787361. 4278658087. 4278204986. 4278269494. 4278269751. 4289515471. 4283802530. 4283802530. 4279110417. 4281225555. 4283868837. 4283868837. 4279374617. 4280234036. 4283408286. 4284920497. 4284920754. 4280116323. 4278203443. 4278204728. 4278464304. 4279239951. 4278723624. 4278204728. 4278269494. 0. 0. 4283802530. 4281093969. 4280365109. 4283802530. 4283868837. 4282018925. 4280167215. 4283868837. 4283408286. 4283473051. 4282749585. 4278666564. 4278203700. 4278205498. 4278464047. 4279048222. 4278334773. 4279057982. 4279057982. 0. 0. 4284327075. 4281620570. 4278321152. 4281292376. 4283868837. 4281953646. 4278583299. 4280565057. 4283408286. 4283408286. 4282288777. 4278402621. 4278204470. 4278529325. 4278464304. 4278270008. 4278269494. 4278269494. 0. 0. 0. 0. 4283134322. 4283134322. 4282020210. 4283868837. 4282218873. 4280233265. 4281556576. 4283408286. 4283408286. 4282354313. 4278402621. 4278333745. 4279109649. 4278723367. 4278204471. 4278204471. 0. 0. 0. 0. 0. 0. 4287545021. 4283802530. 4283868837. 4281292889. 4278386688. 4281094484. 4283408286. 4283408286. 4282288520. 4278402878. 4278592808. 4279241493. 4278464818. 4278464818. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4284916128. 4284916128. 4280499520. 4280697413. 4283408286. 4283408286. 4282091141. 4278401851. 4278333489. 4278529583. 4278529583. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4283800218. 4283800218. 4283408286. 4283408286. 4281762176. 4278269750. 4278203958. 4278203958. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4284455577. 4284455577. 4280704092. 4280830538. 0. 0. 0. 0. 0. 0. 0. 0}! !

!DWGUI class methodsFor: 'dices' stamp: 'MP 2/11/2007 21:59'!
dice3
	"yellow dice"

	^ {0. 0. 0. 0. 0. 0. 0. 0. 4291348487. 4291348487. 4291348487. 4291348487. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4291348487. 4291611649. 4291611649. 4291809025. 4291809025. 4290558987. 4289177345. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4290690571. 4289177345. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4291940609. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4290558994. 4289177345. 0. 0. 0. 0. 0. 0. 0. 4292137985. 4291809025. 4291809025. 4291809025. 4291809025. 4292006401. 4292137985. 4291874817. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291085313. 4289177345. 0. 0. 0. 0. 0. 4292401153. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4287532547. 4281940226. 4286282499. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291085313. 4285427225. 0. 0. 0. 4292861697. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4283913987. 4278190081. 4282071812. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291085313. 4285492993. 4282071809. 0. 4294901346. 4292993280. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291414274. 4289045763. 4290756354. 4291545857. 4291809025. 4291809025. 4291809025. 4291809025. 4291282689. 4289177345. 4282071809. 4280755968. 4294440801. 4294967188. 4294506576. 4292795904. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291348481. 4290230017. 4283190273. 4280755968. 4280755968. 4291414301. 4290361604. 4292466998. 4293980209. 4293322249. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291809025. 4291677441. 4291809025. 4291809025. 4291809025. 4291545857. 4290624769. 4283650817. 4280295171. 4280624133. 4279702798. 4287598338. 4288322048. 4288519424. 4289769481. 4292006425. 4293388049. 4292927492. 4291809025. 4291809025. 4292006401. 4291809025. 4291809025. 4291809025. 4291809025. 4291743233. 4290624769. 4283716609. 4280558593. 4279439374. 4279702798. 4279702798. 4287598338. 4286611204. 4280492300. 4285755909. 4288519424. 4289572104. 4292269584. 4293388041. 4292532737. 4291874817. 4291809025. 4291809025. 4291809025. 4291809025. 4290427393. 4283453441. 4280558593. 4280887299. 4279175954. 4280558343. 4279702798. 4287598338. 4287598338. 4279637005. 4279571470. 4288124418. 4287598338. 4287598338. 4290164229. 4293059076. 4293519617. 4292466945. 4291809025. 4291874817. 4289637889. 4283058689. 4280624385. 4281084929. 4281019137. 4280755972. 4281084929. 4279702798. 4287598338. 4287598338. 4287598338. 4285032199. 4287993090. 4287598338. 4287598338. 4287598338. 4288848384. 4291480065. 4293256449. 4292269569. 4289177345. 4282861313. 4280624385. 4281084929. 4281084929. 4281084929. 4281084928. 4281019137. 4279702798. 4287598338. 4287598338. 4284045319. 4287598338. 4287598338. 4287598338. 4287598338. 4281544970. 4283058441. 4288058881. 4289637889. 4289703681. 4283979777. 4280755969. 4281084929. 4281084929. 4281084929. 4281019137. 4281019137. 4281545485. 0. 0. 4287598338. 4279703053. 4279176718. 4286940419. 4287598338. 4287598338. 4282400522. 4278190096. 4285229575. 4288453632. 4287203585. 4281874433. 4280887553. 4281150720. 4281150720. 4281019137. 4281019137. 4281545485. 4279702798. 0. 0. 4285953551. 4285953551. 4281347597. 4286216452. 4287598338. 4287598338. 4287993090. 4284966408. 4286545412. 4288124673. 4286677249. 4281479681. 4281019137. 4280624132. 4280690180. 4281084929. 4280953345. 4279702798. 0. 0. 0. 0. 4287598338. 4287598338. 4287598338. 4287598338. 4287664129. 4283913479. 4284571910. 4287927553. 4287795713. 4286743041. 4281479681. 4280755715. 4278978834. 4280229385. 4281084928. 4279702798. 0. 0. 0. 0. 0. 0. 4287203585. 4287598338. 4287598338. 4287729920. 4282203146. 4278190095. 4284505863. 4287993088. 4286611457. 4281479680. 4280295175. 4279241747. 4280821763. 4279702798. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287598338. 4287598338. 4286874626. 4282400267. 4284571655. 4287729920. 4286414081. 4281282305. 4280821763. 4280755716. 4279702798. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288124698. 4287598338. 4287598338. 4287532545. 4286019329. 4281019137. 4281019137. 4279702798. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4287532545. 4287532545. 4286414081. 4281019137. 0. 0. 0. 0. 0. 0. 0. 0}! !

!DWGUI class methodsFor: 'dices' stamp: 'MP 2/11/2007 22:00'!
dice4
	"darkgreen dice"

	^ {0. 0. 0. 0. 0. 0. 0. 0. 4278217985. 4278217985. 4278217985. 4278217985. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4278217985. 4278217985. 4282550083. 4282812999. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4278217985. 4278217985. 4281105965. 4294703355. 4294967295. 4281631540. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 4279331090. 0. 0. 0. 0. 0. 0. 0. 4278217985. 4278217985. 4278217985. 4278676744. 4285179499. 4285113705. 4278217985. 4287869843. 4290761151. 4281237039. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 0. 0. 0. 0. 0. 4278217985. 4278217985. 4285177963. 4285310061. 4278808330. 4278217985. 4278217985. 4278217985. 4292207061. 4294967295. 4282485570. 4278937356. 4282352448. 4279134479. 4278217985. 4278217985. 4279780377. 0. 0. 0. 4278219265. 4278217985. 4281697846. 4294966015. 4294967039. 4281303855. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 4290235063. 4294967295. 4287543183. 4278217985. 4278215681. 4278204673. 4278197760. 0. 4278225154. 4278219521. 4278217985. 4278217985. 4282487362. 4282027323. 4279136527. 4290497724. 4293586410. 4282354495. 4278217985. 4278217985. 4278217985. 4283799125. 4288989092. 4282025531. 4278215168. 4278212097. 4278197760. 4278197760. 4283475793. 4278226434. 4278224130. 4278219009. 4278217985. 4278217985. 4278217985. 4278939660. 4290236855. 4292996577. 4281566772. 4280448546. 4284455008. 4279923995. 4278217985. 4278217985. 4278217985. 4278214401. 4278199552. 4278193920. 4278193920. 4278209024. 4278214145. 4278219008. 4278222338. 4278220289. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 4290629821. 4294967295. 4287675024. 4278217985. 4278217985. 4278214913. 4278200320. 4279245840. 4278195712. 4278193920. 4278209024. 4278209537. 4278209537. 4278209537. 4278218241. 4278220801. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 4282092092. 4286427262. 4280515363. 4278217985. 4278217985. 4278200832. 4278195712. 4284901225. 4284573029. 4278260993. 4278209024. 4278209537. 4290101176. 4282414658. 4278209537. 4278212865. 4278218498. 4278220545. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 4278217985. 4278200577. 4278195712. 4279050253. 4286873737. 4281088558. 4278260993. 4278209024. 4278209024. 4292402393. 4292862944. 4278209537. 4278209537. 4278209537. 4278214145. 4278219778. 4278220546. 4278217985. 4278217985. 4278217985. 4278213121. 4278199809. 4278194688. 4278195712. 4278393091. 4279839258. 4278260993. 4278195712. 4278209024. 4278208512. 4280443171. 4284123483. 4278209537. 4278209537. 4278209537. 4278209537. 4278210561. 4278216450. 4278220034. 4278218241. 4278211841. 4278199297. 4278195712. 4278195712. 4278195712. 4278195712. 4278195712. 4278195712. 4278195712. 4278209281. 4278209281. 4278209537. 4278209537. 4283070540. 4285567858. 4278537477. 4278209536. 4278209537. 4278209537. 4278212865. 4278213121. 4278201601. 4278195200. 4278195712. 4278195712. 4278195712. 4278195712. 4278195712. 4278195712. 0. 0. 4279917339. 4278209537. 4278209537. 4284713572. 4294967295. 4285831286. 4278209537. 4278209537. 4278209537. 4278209793. 4278208257. 4278197504. 4278195456. 4278195712. 4278195712. 4278195712. 4278195712. 4278195712. 4278195712. 0. 0. 4278865675. 4278209537. 4278209537. 4278209537. 4285699700. 4284319839. 4278209537. 4278209537. 4278209537. 4278209537. 4278206977. 4278196480. 4278194944. 4279970588. 4279510549. 4278195200. 4278195712. 4278193920. 0. 0. 0. 0. 4280311073. 4280311073. 4278209537. 4278209537. 4278209537. 4284055642. 4284055899. 4278209537. 4278209537. 4278207233. 4278195712. 4279049998. 4286939274. 4282140478. 4278193920. 4278193920. 0. 0. 0. 0. 0. 0. 4278208001. 4278207745. 4278207745. 4278209537. 4287078793. 4294967295. 4283596628. 4278209537. 4278206977. 4278194944. 4281088045. 4287005579. 4279247377. 4278193920. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4278207745. 4278205952. 4278995981. 4287539088. 4283333456. 4278209537. 4278206465. 4278195968. 4278984460. 4279773209. 4278195200. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4278995981. 4279914266. 4278206977. 4278208769. 4278205697. 4278195712. 4278195200. 4278195200. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4278206977. 4278208769. 4279317266. 4280825128. 0. 0. 0. 0. 0. 0. 0. 0}! !

!DWGUI class methodsFor: 'dices' stamp: 'MP 2/11/2007 22:02'!
dice5
	"orange dice"

	^ {0. 0. 0. 0. 0. 0. 0. 0. 4293506427. 4292385366. 4292058468. 4292058468. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4294490223. 4294490223. 4294490223. 4294490223. 4294490223. 4294490223. 4292058468. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4294490223. 4294490223. 4288511048. 4288510790. 4294490223. 4294490223. 4294490223. 4294490223. 4294490223. 4292058468. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4293703028. 4294490223. 4290416984. 4278191360. 4278191616. 4290547794. 4294620777. 4294490223. 4294490223. 4294490223. 4294490223. 4294490223. 4292058468. 0. 0. 0. 0. 0. 0. 0. 4294490223. 4294490223. 4294490223. 4294490223. 4287131970. 4287394626. 4294490223. 4283188771. 4281086484. 4290481485. 4294357088. 4294490223. 4294490223. 4294490223. 4290413902. 0. 0. 0. 0. 0. 4294490223. 4294490223. 4286015294. 4286277695. 4294490223. 4294490223. 4294490223. 4294490223. 4280166928. 4278195457. 4289561930. 4292255063. 4288707137. 4292320082. 4294490223. 4294490223. 4288830743. 0. 0. 0. 4294490223. 4294490223. 4289827424. 4278190848. 4278192641. 4290943586. 4293965428. 4294490223. 4294490223. 4294490223. 4294490223. 4293766756. 4281347863. 4278190080. 4284699178. 4294490223. 4294490223. 4288830743. 4284428550. 0. 4294034311. 4294490223. 4294490223. 4294490223. 4289761888. 4290221408. 4294490223. 4280757781. 4278589957. 4289562962. 4294490223. 4294490223. 4294490223. 4288116546. 4283714853. 4289889865. 4294490223. 4292513339. 4284428550. 4284428550. 4294034311. 4294034311. 4294034311. 4294490223. 4294490223. 4294490223. 4294490223. 4294490223. 4282138401. 4280101649. 4290548570. 4290745177. 4286802748. 4291598938. 4294490223. 4294490223. 4294490223. 4293172556. 4285677325. 4282392579. 4282392579. 4293303885. 4293303885. 4294034311. 4294367404. 4294101653. 4294490223. 4294490223. 4294490223. 4293966200. 4294490223. 4294490223. 4281216024. 4278190080. 4284699695. 4294490223. 4294490223. 4293435987. 4286137617. 4281604868. 4281802762. 4282392579. 4292772126. 4292772126. 4292837662. 4293563962. 4293769593. 4294102169. 4293968778. 4294490223. 4294490223. 4294490223. 4294490223. 4289891414. 4286080570. 4291402332. 4294490223. 4293370709. 4286137875. 4282129666. 4279703056. 4280162576. 4282392579. 4292772126. 4292772126. 4280756499. 4288635675. 4293231388. 4293104445. 4293835902. 4294101911. 4294490223. 4294490223. 4294490223. 4294293619. 4294490223. 4294359408. 4293173073. 4285874705. 4282195201. 4282262024. 4279112724. 4281606157. 4281081101. 4292639252. 4292772126. 4279902736. 4279836689. 4292247071. 4292902937. 4292706075. 4293237833. 4294035085. 4294167704. 4294490223. 4294490223. 4294490223. 4292842819. 4285611531. 4282064387. 4282721286. 4282524422. 4281868554. 4282655750. 4281081101. 4292639252. 4292772126. 4290801944. 4287388184. 4292771610. 4293559579. 4292837402. 4292639508. 4292838176. 4293570150. 4294035602. 4294490223. 4292709944. 4285676295. 4282129923. 4282721286. 4282721286. 4282721286. 4282721285. 4282524422. 4281081101. 4292639252. 4292639252. 4293033237. 4292772126. 4287452948. 4285155348. 4292574232. 4292837143. 4292705301. 4292639507. 4293170236. 4293367100. 4287187211. 4282261508. 4282655750. 4282721286. 4282655750. 4282589958. 4282524422. 4281081101. 0. 0. 4292639252. 4292638740. 4292772126. 4286270996. 4278192397. 4285680404. 4293427222. 4292705045. 4292639508. 4292836628. 4291851028. 4284034823. 4282458630. 4282852614. 4282786821. 4282589958. 4282589958. 4282854418. 4281081101. 0. 0. 4292966419. 4292966419. 4292638484. 4292376085. 4285811477. 4287124501. 4293623573. 4293295380. 4292704532. 4292901652. 4291193874. 4283246855. 4282589957. 4281802505. 4281999369. 4282655494. 4282524422. 4281081101. 0. 0. 0. 0. 4292966419. 4292966419. 4292966419. 4293163540. 4293294869. 4286270483. 4286599188. 4292770069. 4292901396. 4291259410. 4283246598. 4281999624. 4278915859. 4281081101. 4282655493. 4281081101. 0. 0. 0. 0. 0. 0. 4292966419. 4292966419. 4292966419. 4292835347. 4283841555. 4278193165. 4287518229. 4293360660. 4291193618. 4283246854. 4281212172. 4279244052. 4282065417. 4281081101. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4292966419. 4292966419. 4292966419. 4284104725. 4287715093. 4292966419. 4290865169. 4282984198. 4282130440. 4281803018. 4281081101. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4292966419. 4292966419. 4292966419. 4292506900. 4290274065. 4283246854. 4282524422. 4281081101. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4292966419. 4292966419. 4291193618. 4283246854. 0. 0. 0. 0. 0. 0. 0. 0}! !

!DWGUI class methodsFor: 'dices' stamp: 'MP 2/11/2007 22:02'!
dice6
	"lightgreen dice"

	^ {0. 0. 0. 0. 0. 0. 0. 0. 4288734209. 4287741727. 4288003130. 4284249881. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288601863. 4288997889. 4288997889. 4289195521. 4288997889. 4288997889. 4284249881. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288865793. 4288997889. 4288997889. 4285372677. 4285042949. 4288997889. 4288997889. 4288997889. 4288139787. 4284249881. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4288997633. 4288866049. 4288997889. 4286756357. 4278190084. 4278190083. 4285833991. 4288997889. 4288997889. 4288997889. 4288997889. 4288138770. 4284249881. 0. 0. 0. 0. 0. 0. 0. 4289195009. 4289195009. 4289063425. 4288997889. 4288997889. 4284845062. 4284845062. 4288338435. 4288997889. 4288997889. 4288997889. 4288997889. 4288997889. 4288997889. 4284249881. 0. 0. 0. 0. 0. 4289326848. 4289458945. 4289260803. 4289260802. 4289063425. 4288997889. 4288206595. 4285372932. 4287086084. 4288997889. 4288997889. 4282934277. 4279705092. 4284515846. 4288997889. 4288997889. 4284249881. 0. 0. 0. 4289787657. 4289722624. 4287283716. 4280035076. 4281089285. 4288338436. 4288997889. 4282341382. 4278190080. 4281023239. 4288997889. 4288997889. 4281352710. 4278190082. 4283461128. 4288997889. 4288997889. 4281287169. 4280166150. 0. 4291623517. 4289853198. 4289789184. 4286690565. 4278321667. 4279507718. 4288140293. 4288997889. 4286756357. 4283197958. 4286360837. 4288997889. 4288997889. 4288997889. 4287415557. 4288997889. 4288997889. 4286822913. 4281287169. 4280166150. 4291623517. 4291623517. 4292607870. 4289591043. 4289459456. 4288601604. 4288733700. 4289326849. 4288997889. 4288997889. 4287877124. 4287086084. 4288997889. 4288997889. 4288997889. 4288997889. 4288997889. 4287679489. 4282144000. 4280232960. 4280166150. 4288994333. 4287744777. 4290306642. 4291623517. 4290312984. 4289459712. 4289393152. 4289195265. 4288997889. 4287679236. 4278717188. 4278190082. 4285701894. 4288997889. 4288997889. 4288668161. 4287943169. 4282473473. 4279902979. 4280166150. 4279571983. 4287150098. 4285306881. 4285306881. 4287216655. 4289650488. 4290574382. 4289787403. 4288997889. 4288997889. 4288667907. 4283000070. 4282077702. 4287547141. 4288997889. 4288865793. 4287943425. 4282539265. 4280100865. 4279308559. 4279571983. 4279571983. 4287281181. 4285306881. 4285306881. 4285306881. 4285306881. 4287347986. 4289717552. 4290443813. 4288997889. 4288997889. 4288997889. 4288997889. 4288997889. 4288997889. 4287811329. 4282341633. 4280101120. 4280364036. 4279175956. 4280100361. 4279571983. 4287806256. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4287808791. 4290244655. 4290444319. 4288997889. 4288997889. 4288997889. 4287218177. 4282077953. 4280101121. 4280430593. 4280430593. 4280430593. 4280496385. 4280100361. 4287806256. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4285834496. 4286295554. 4288731924. 4290116621. 4289195520. 4286822913. 4281946113. 4280166913. 4280430593. 4279638539. 4279902217. 4280430593. 4280430593. 4280100361. 4287806256. 4285306881. 4285306881. 4285306881. 4285306881. 4280100358. 4284186373. 4285306881. 4285306881. 4285306881. 4287152640. 4287218433. 4282802689. 4280232705. 4280430593. 4280430593. 4278978069. 4279968010. 4280430593. 4280430593. 0. 0. 4285306881. 4285306881. 4285306881. 4284977412. 4278782724. 4279244036. 4285306881. 4285306881. 4285306881. 4285306881. 4285307137. 4281155329. 4280430593. 4280430593. 4280430593. 4279571984. 4280430593. 4280430593. 4279902219. 0. 0. 4285306881. 4285306881. 4285306881. 4285306881. 4284384005. 4282473222. 4285306881. 4285306881. 4285306881. 4285306881. 4284911617. 4280760065. 4280430593. 4280430593. 4280430593. 4280430593. 4280430593. 4279902219. 0. 0. 0. 0. 4285833227. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4284911873. 4280825600. 4280430593. 4279044371. 4279902219. 4280430593. 4279902219. 0. 0. 0. 0. 0. 0. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4284845825. 4280825856. 4280430593. 4279241748. 4280298500. 4279902219. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4285306881. 4284713985. 4280694017. 4280430593. 4280430593. 4279902219. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4285306881. 4285306881. 4285306881. 4285306881. 4284384257. 4280430593. 4280430593. 4279902219. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4285306881. 4285306881. 4284384257. 4280430593. 0. 0. 0. 0. 0. 0. 0. 0}! !

!DWGUI class methodsFor: 'dices' stamp: 'MP 2/11/2007 22:03'!
dice7
	"red dice"

	^ {0. 0. 0. 0. 0. 0. 0. 0. 4284678657. 4286776322. 4285137408. 4281991424. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4289727493. 4290647310. 4290647310. 4290647310. 4290647310. 4288742400. 4283957504. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4290384137. 4290647310. 4290647310. 4291264895. 4291393138. 4290647310. 4290647310. 4290647310. 4288807680. 4283629824. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4290581260. 4290647310. 4290647310. 4290727240. 4294705151. 4294571252. 4290390050. 4290647310. 4290647310. 4290647310. 4290647310. 4288282880. 4281729281. 0. 0. 0. 0. 0. 0. 0. 4290778639. 4290647310. 4290647310. 4290647310. 4290647310. 4291250242. 4290851630. 4290647310. 4290647310. 4290647310. 4290647310. 4290647310. 4290647310. 4290647310. 4284153856. 0. 0. 0. 0. 0. 4290647310. 4290647310. 4290647310. 4290647310. 4290647310. 4290647310. 4290647310. 4290596425. 4290325029. 4290647310. 4290647310. 4290999666. 4292589493. 4290594114. 4290647310. 4290647310. 4283236352. 0. 0. 0. 4290647310. 4290647310. 4290850858. 4292393399. 4292984251. 4290849316. 4290647310. 4291859601. 4294967295. 4293311675. 4290647310. 4290647310. 4292919744. 4294967295. 4291720306. 4290647310. 4290647310. 4284743680. 4279435264. 0. 4294002493. 4290647310. 4290647310. 4291116600. 4294308080. 4294570224. 4291114287. 4290647310. 4291051065. 4292843669. 4291383113. 4290647310. 4290647310. 4290057231. 4290390564. 4290647310. 4290647310. 4287955200. 4281401344. 4280287232. 4288160798. 4294528578. 4293541685. 4291304983. 4290647310. 4291110689. 4290978845. 4290712074. 4290647310. 4290647310. 4290647310. 4290647310. 4290647310. 4290647310. 4290647310. 4290647310. 4290647310. 4289004032. 4282910986. 4282329388. 4280680962. 4288285446. 4289006088. 4291240990. 4292752427. 4291896605. 4290909454. 4290777868. 4290778639. 4290647310. 4290647310. 4291129709. 4291991188. 4290587686. 4290647310. 4290647310. 4290647310. 4289332224. 4282712064. 4283648077. 4286807429. 4280549891. 4286971904. 4286906368. 4286906368. 4288152579. 4290780697. 4292028704. 4291436311. 4290778382. 4290711818. 4290647310. 4293713886. 4294967295. 4291650141. 4290647310. 4290647310. 4289332737. 4282974208. 4280156160. 4285753712. 4284105800. 4279959552. 4286316544. 4287898661. 4291474360. 4288692033. 4286906368. 4288415751. 4290912282. 4291896862. 4291107347. 4290647310. 4290982187. 4291183421. 4290647310. 4290647310. 4289136130. 4282712064. 4283648591. 4283513406. 4281075464. 4280944135. 4279894016. 4285530112. 4287303440. 4293056217. 4293451488. 4286906368. 4286906368. 4287102976. 4288941323. 4291568926. 4292028190. 4290647310. 4290647310. 4290647310. 4288480258. 4282122240. 4281210391. 4287664025. 4283051569. 4282657838. 4284963166. 4279369728. 4284416000. 4286906368. 4287832354. 4289485147. 4286906368. 4286906368. 4287102976. 4286906368. 4287365377. 4290057488. 4291765018. 4290647310. 4288020736. 4282318848. 4281473307. 4282261538. 4284237901. 4280747270. 4286676357. 4284830809. 4279369728. 4286775296. 4286906368. 4286906368. 4286906368. 4288497996. 4289687153. 4286973189. 4286906368. 4286906368. 4286840832. 4288414209. 4288479744. 4283170816. 4281868322. 4287071630. 4281800216. 4282262566. 4283316027. 4283974471. 4280552461. 0. 0. 4285661184. 4286906368. 4286906368. 4289290852. 4294967295. 4290081653. 4286906368. 4286906368. 4286840832. 4286971904. 4286251008. 4281139200. 4284173650. 4286082420. 4281141514. 4286939786. 4284435280. 4279828480. 4278583296. 0. 0. 4285661184. 4286119936. 4286906368. 4286906368. 4289950068. 4289354847. 4286906368. 4286906368. 4286906368. 4286906368. 4285792256. 4281008128. 4281668630. 4282261538. 4281734680. 4285621612. 4281405200. 4278976512. 0. 0. 0. 0. 4286119936. 4285202432. 4286906368. 4286906368. 4286906368. 4288567130. 4288829530. 4286906368. 4286906368. 4285792256. 4280877056. 4281603864. 4286610308. 4282063645. 4280418304. 4279173120. 0. 0. 0. 0. 0. 0. 4285202432. 4282908672. 4286906368. 4286906368. 4290152072. 4294901759. 4288827731. 4286906368. 4285726720. 4280614912. 4284173393. 4286741379. 4280878084. 4279369728. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4286185472. 4284416000. 4286450700. 4290612367. 4288630095. 4286906368. 4285530112. 4280811520. 4282129696. 4281866780. 4279435264. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4286450700. 4286906368. 4286906368. 4286906368. 4285202432. 4280811520. 4280483840. 4279107584. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4281204736. 4283432960. 4282056704. 4279762944. 0. 0. 0. 0. 0. 0. 0. 0}! !

!DWGUI class methodsFor: 'dices' stamp: 'MP 2/11/2007 22:04'!
dice8
	"pink dice"

	^ {0. 0. 0. 0. 0. 0. 0. 0. 4294868435. 4294925246. 4294925246. 4292758953. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4292758953. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4294925246. 4294925246. 4294925246. 4293559489. 4294016964. 4294924990. 4294925246. 4294925246. 4294925246. 4292758953. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4294925246. 4294925246. 4294925246. 4293822146. 4293918712. 4294441210. 4294668227. 4294925246. 4294925246. 4294925246. 4294924478. 4294923971. 4292758953. 0. 0. 0. 0. 0. 0. 0. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294682584. 4294745301. 4294925246. 4294925246. 4294924990. 4294924478. 4294923966. 4294923967. 4294923716. 4292758953. 0. 0. 0. 0. 0. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294924222. 4294923710. 4294923710. 4294922697. 4291241870. 0. 0. 0. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294923462. 4292220311. 4286709825. 0. 4294934974. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294924734. 4294925246. 4294925246. 4294393017. 4288741728. 4286709825. 4294934974. 4294934974. 4294943167. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4293691842. 4293762251. 4294925246. 4294925246. 4294925502. 4294925246. 4294925246. 4294724542. 4289530732. 4286709825. 4286906692. 4294912702. 4294912702. 4294932414. 4294939070. 4294934974. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4293716204. 4294639615. 4294547921. 4294924475. 4294925246. 4294925246. 4294791616. 4289859697. 4286644288. 4287103303. 4286906692. 4294912702. 4294912702. 4294912702. 4294917822. 4294929854. 4294935742. 4294932926. 4294925246. 4294925246. 4294925246. 4294675916. 4294679763. 4294925246. 4294925246. 4294925246. 4294726079. 4289859953. 4286644289. 4287103303. 4287103303. 4286906692. 4294912702. 4294913214. 4294913470. 4294912702. 4294912190. 4294918590. 4294930622. 4294935230. 4294931134. 4294925246. 4294925246. 4294925246. 4294925246. 4294925246. 4294725310. 4289728111. 4286709823. 4287103045. 4287037766. 4287037766. 4286906692. 4294912702. 4294912190. 4294911934. 4294912702. 4294912702. 4294912702. 4294912190. 4294920638. 4294933182. 4294935486. 4294931134. 4294925246. 4294925246. 4294656700. 4289661294. 4286709824. 4287037766. 4287037766. 4287037766. 4287037766. 4286906692. 4294912702. 4294912702. 4294388666. 4294910141. 4294781373. 4294912702. 4294912702. 4294650045. 4294520506. 4294924989. 4294934462. 4294929855. 4294785469. 4289856625. 4286709825. 4287037766. 4286538358. 4287061881. 4287037766. 4286972228. 4286906692. 4294912702. 4294912702. 4292531420. 4294912702. 4294912702. 4292789465. 4294912702. 4293355970. 4292857309. 4294910145. 4294910145. 4294918082. 4291233670. 4286840899. 4287103045. 4286778956. 4286940299. 4287180126. 4286971970. 4286906692. 0. 0. 4294912702. 4293710312. 4293841642. 4294912702. 4293586928. 4293900001. 4294327487. 4293652208. 4293898463. 4294910145. 4294646457. 4288544861. 4286841155. 4287037766. 4287037766. 4286979925. 4287037766. 4287037766. 4286906692. 0. 0. 4294652866. 4294652866. 4294912702. 4294912702. 4294525381. 4294465482. 4294912702. 4294524355. 4294527687. 4294910144. 4294121138. 4287758417. 4286972229. 4287037766. 4287037766. 4286971970. 4286906692. 4286906692. 0. 0. 0. 0. 4294716865. 4294716865. 4294912702. 4294912702. 4294912702. 4294912702. 4294912702. 4294912702. 4294910145. 4294121394. 4287627599. 4286972229. 4287037766. 4286972229. 4286906692. 4286906692. 0. 0. 0. 0. 0. 0. 4294711482. 4294711482. 4294711482. 4294912702. 4294912702. 4294912702. 4294912702. 4294910145. 4294055345. 4287562062. 4286906692. 4286972229. 4286906692. 4286906692. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4294912702. 4294912702. 4294912702. 4294912702. 4294912702. 4294910145. 4293924014. 4287430988. 4286841155. 4286906692. 4286906692. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4294520254. 4294520254. 4294912702. 4294910145. 4293529769. 4287103047. 4286906692. 4286906692. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 0. 4294520254. 4293529769. 4289861493. 4287178834. 0. 0. 0. 0. 0. 0. 0. 0}! !

!DWGUI class methodsFor: 'dices' stamp: 'DH 2/11/2007 01:21'!
diceImage: aColor
	"Returns a dice image for the given color"
	
	"Lazy initialization - set up a dictionary which maps colors to dice images"
	self getColor2Dice ifNil: [
		self setColor2Dice: Dictionary new.
		1 to: 8 do: [:i |
			self getColor2Dice 
				at: (self colorPlayer: i) 
				put: (self perform: (('dice', (i asString)) asSymbol))]].

	^ (Form
		extent: 21@22
		depth: 32
		fromArray: (color2dice at: aColor)
		offset: 0)! !

!DWGUI class methodsFor: 'dices' stamp: 'MP 2/1/2007 23:30'!
getColor2Dice

	^ color2dice! !

!DWGUI class methodsFor: 'dices' stamp: 'MP 2/1/2007 23:47'!
setColor2Dice: aDictionary

	color2dice := aDictionary! !


!DWHexagon methodsFor: 'geometry' stamp: 'DH 1/3/2007 16:32'!
rotateVerticesBy: anInt
	"Rotates the own vertices <anInt> times"
	
	| verts |
	verts := self vertices asOrderedCollection.

	anInt timesRepeat: [
		verts addLast: (verts removeFirst)].

	self setVertices: verts asArray! !

!DWHexagon methodsFor: 'positioning' stamp: 'DH 1/3/2007 16:19'!
moveToPosition: aPoint
	self position: (self class relativePositionOf: aPoint)! !


!DWHexagon class methodsFor: 'instance creation' stamp: 'DH 1/27/2007 19:23'!
createAtField: aPoint
	"Creates a hexagon at the position of <field>"

	"inspect:[(DWHexagon createFromField: 1@1) openInWorld]"

	^ self new
		setVertices: {0@11. 11@4. 11@-4. 0@-11. -11@-4. -11@4};
		moveToPosition: aPoint;
		yourself! !

!DWHexagon class methodsFor: 'as yet unclassified' stamp: 'DH 1/27/2007 19:23'!
relativePositionOf: aPoint
	"Returns the relative position of a hexagon which has the grid position <aPoint>"

	 ^ (aPoint y odd
				ifTrue: [(aPoint x - 1) * 22] 
				ifFalse: [(aPoint x - 1) * 22 + 11])
			@ ((aPoint y - 1) * 15)! !


!DWLauncherMorph methodsFor: 'initalization' stamp: 'rkrk 11/22/2007 20:30'!
initializeToStandAlone

	self openInHand  ! !

!DWLauncherMorph methodsFor: 'initalization' stamp: 'MP 2/9/2007 16:09'!
openInHand
	"This is little tricky."

	^ DWGame new openInHand! !


!DWLauncherMorph class methodsFor: 'parts bin' stamp: 'DF 2/10/2007 14:10'!
descriptionForPartsBin
	"Answer a description of the receiver for use in a parts bin"

	^ self partName: 	'DiceWars'
		categories:		#('Games')
		documentation:	'A DiceWars implementation.'
		sampleImageForm: (Form
	extent: 21@22
	depth: 32
	fromArray: DWGUI dice7
	offset: 0@0)! !

!DWLauncherMorph class methodsFor: 'parts bin' stamp: 'rkrk 11/22/2007 20:34'!
launchPartVia: aSelector label: aString

	DWGame new openInHand! !


!DWMapMaker methodsFor: 'interface' stamp: 'DH 2/4/2007 00:03'!
createMap
	"Creates a set of sectors which represent a dicewars map"

	"inspect:[DWMapMaker size: 32@28 sectors: 30 game: nil]"

	'Creating Map ...'
		displayProgressAt: Display center
		from: 0 to: 5
		during: [:bar |
			self createSectors. 
			bar value: 1.
			self makeMapPartition. 
			bar value: 2.
			self makeNeighbors. 
			bar value: 3.
			self deleteEmptySectors. 
			bar value: 4.
			self finishSectors. 
			bar value: 5].

	^ self getSectors! !

!DWMapMaker methodsFor: 'accessing' stamp: 'DF 12/27/2006 15:31'!
getFieldGrid
	^ fieldGrid! !

!DWMapMaker methodsFor: 'accessing' stamp: 'DH 12/13/2006 15:53'!
getGame
	^ game! !

!DWMapMaker methodsFor: 'accessing' stamp: 'DF 12/27/2006 15:32'!
getSectors
	^ sectors! !

!DWMapMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 15:09'!
getSize
	^ size! !

!DWMapMaker methodsFor: 'accessing' stamp: 'DF 12/27/2006 15:43'!
setFieldGrid: aMatrix
	fieldGrid := aMatrix! !

!DWMapMaker methodsFor: 'accessing' stamp: 'DH 12/12/2006 16:06'!
setGame: aGame
	game := aGame! !

!DWMapMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 15:09'!
setNumOfSectors: anInt
	numSectors := anInt! !

!DWMapMaker methodsFor: 'accessing' stamp: 'DF 12/27/2006 15:33'!
setSectors: anArray
	sectors := anArray! !

!DWMapMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 15:09'!
setSize: aPoint	
	size := aPoint! !

!DWMapMaker methodsFor: 'grid accessing' stamp: 'DH 1/2/2007 16:15'!
gridAt: aPoint 
	^ self getFieldGrid at: aPoint y at: aPoint x ifInvalid: false! !

!DWMapMaker methodsFor: 'grid accessing' stamp: 'DH 1/2/2007 16:15'!
gridAt: aPoint set: aSectorMaker
	self getFieldGrid at: aPoint y at: aPoint x put: aSectorMaker! !

!DWMapMaker methodsFor: 'grid accessing' stamp: 'DH 1/2/2007 16:16'!
gridEmptyNeighborFieldsOf: aPoint
	^ (self gridNeighborFieldsOf: aPoint) 
		select: [:field | self gridIsEmptyAt: field]! !

!DWMapMaker methodsFor: 'grid accessing' stamp: 'DH 1/2/2007 16:16'!
gridIsEmptyAt: aPoint
	^ (self gridAt: aPoint) isNil! !

!DWMapMaker methodsFor: 'grid accessing' stamp: 'DH 1/2/2007 16:34'!
gridIsInvalidField: aPoint
	^ ( 
		(aPoint > (0 @ 0)) 
		& (aPoint <= (self getSize)) ) not! !

!DWMapMaker methodsFor: 'grid accessing' stamp: 'DH 1/2/2007 16:35'!
gridNeighborFieldsOf: aPoint
	
	| o |
	o := aPoint y odd.

	^ {((o ifTrue: [aPoint x - 1] ifFalse: [aPoint x]) @ (aPoint y - 1)).
		((o ifTrue: [aPoint x] ifFalse: [aPoint x + 1]) @ (aPoint y - 1)).
		((aPoint x - 1) @ (aPoint y)). ((aPoint x + 1) @ (aPoint y)).
		((o ifTrue: [aPoint x - 1] ifFalse: [aPoint x]) @ (aPoint y + 1)).
		((o ifTrue: [aPoint x] ifFalse: [aPoint x + 1]) @ (aPoint y + 1))} 
			reject: [:field | self gridIsInvalidField: field]
	! !

!DWMapMaker methodsFor: 'private' stamp: 'DH 1/2/2007 16:35'!
createSectors
	"Sets up the field grid and initializes all sectors"
	
	self setFieldGrid: 
		(Matrix 
			rows: (self getSize y) 
			columns: (self getSize x)).

	self setSectors: (
		(Array new: (self getTotalNumberOfSectors))
			collect: [:unused | DWSectorMaker new: self])

	! !

!DWMapMaker methodsFor: 'private' stamp: 'DH 1/2/2007 16:35'!
deleteEmptySectors
	"Deletes random sectors"

	| sector sectorsSet |
	sectorsSet := self getSectors asSet.

	(self getNumberOfEmptySectors) timesRepeat: [		
		sector := sectorsSet atRandom.	"find a random sector which is no bottleneck"
		[sector isBottleNeck] 
			whileTrue: [sector := sectorsSet atRandom].
		sector unlinkSelf.						"delete this sector"
		sectorsSet remove: sector].

	self setSectors: sectorsSet asArray! !

!DWMapMaker methodsFor: 'private' stamp: 'DH 1/3/2007 14:40'!
finishSectors
	"Creates sectors from sector makers"
	| sector |

	"We need to create the map from top to bottom, otherwise
	some dices will get shroud by sectors or dices from other sectors.
	Therefore we have to sort the sectors array."
	self getSectors sort: [:a :b |
		a getOrigin y <= (b getOrigin y)].

	self getSectors do: [:sectorMaker |
		sector := sectorMaker makeSector.
		sectorMaker becomeForward: sector]	"forward all neighbor references to the sector"
			displayingProgress: 'Assembling Sectors ...'! !

!DWMapMaker methodsFor: 'private' stamp: 'DH 2/2/2007 00:04'!
makeMapPartition
	"produces the map partitioning"
	| done |

	done := false.
	[done == false] whileTrue: [
		done := true.
		self getSectors do: [:sector |
			sector canGrow ifTrue: [
				(sector growBy: (self class sectorsGrowFieldsAtATime))
					ifTrue: [done := false]]]]! !

!DWMapMaker methodsFor: 'private' stamp: 'DH 1/2/2007 16:35'!
makeNeighbors
	"computes all neighbor references"	

	self getSectors do: [:sector |
		sector computeNeighborSectors]! !

!DWMapMaker methodsFor: 'derived' stamp: 'DH 2/2/2007 00:04'!
getNumberOfEmptySectors
	"computes the number of sectors which will be deleted later"

	^ (numSectors * (self class emptySectorsRatio)) rounded! !

!DWMapMaker methodsFor: 'derived' stamp: 'DH 1/2/2007 16:21'!
getTotalNumberOfSectors
	"computes the total amount of sectors, including
	those which will be deleted"

	^ numSectors + (self getNumberOfEmptySectors)
	! !


!DWMapMaker class methodsFor: 'interface' stamp: 'DH 1/27/2007 19:23'!
size: aPoint sectors: anInt game: aGame
	
	 ^ self new
		setSize: aPoint;
		setNumOfSectors: anInt;
		setGame: aGame;
		createMap! !

!DWMapMaker class methodsFor: 'constants' stamp: 'DH 2/2/2007 00:02'!
emptySectorsRatio
	"Specifies how many sectors will additionally be created and deleted afterwards
	in order to achieve a complex map shape. Standard is 0.35"

	^ 0.35! !

!DWMapMaker class methodsFor: 'constants' stamp: 'DH 2/2/2007 00:02'!
sectorsGrowFieldsAtATime
	"Specifies by how much fields a sector grows at a time.
	Note that a low value will decrease the performance.
	Standard is 12."
	
	^ 12! !


!DWMove methodsFor: 'accessing' stamp: 'DF 12/21/2006 22:55'!
getBaseDices
	^ baseDices! !

!DWMove methodsFor: 'accessing' stamp: 'DF 12/21/2006 22:56'!
getBaseSector
	^ baseSector! !

!DWMove methodsFor: 'accessing' stamp: 'DH 12/21/2006 15:32'!
getPreviousOwner
	^ previousOwner! !

!DWMove methodsFor: 'accessing' stamp: 'DF 12/21/2006 23:01'!
getTargetDices
	^ targetDices! !

!DWMove methodsFor: 'accessing' stamp: 'DF 12/21/2006 23:01'!
getTargetSector
	^ targetSector! !

!DWMove methodsFor: 'accessing' stamp: 'DH 12/23/2006 15:17'!
setBaseDices: anArray
	baseDices := anArray! !

!DWMove methodsFor: 'accessing' stamp: 'DF 12/21/2006 23:00'!
setBaseSector: aSector
	baseSector := aSector! !

!DWMove methodsFor: 'accessing' stamp: 'DF 12/21/2006 23:07'!
setPreviousOwner: aPlayer
	previousOwner := aPlayer! !

!DWMove methodsFor: 'accessing' stamp: 'DF 12/21/2006 23:06'!
setTargetDices: anArray
	targetDices := anArray! !

!DWMove methodsFor: 'accessing' stamp: 'DF 12/21/2006 23:00'!
setTargetSector: aSector
	targetSector := aSector! !

!DWMove methodsFor: 'interface' stamp: 'DH 12/23/2006 16:59'!
chooseTargetSector: aSector
	self
		setTargetSector: aSector;
		setTargetDices: (Array new: aSector getNumberOfDices);
		setPreviousOwner: aSector getOwner! !

!DWMove methodsFor: 'interface' stamp: 'DH 12/23/2006 19:34'!
makeSuccessful
	self
		setBaseDices: (self getBaseDices atAllPut: 1);
		setTargetDices: (self getTargetDices atAllPut: 0)
	! !

!DWMove methodsFor: 'interface' stamp: 'DH 12/23/2006 17:01'!
makeUnsuccessful
	self
		setBaseDices: (self getBaseDices atAllPut: 0);
		setTargetDices: (self getTargetDices atAllPut: 1)! !

!DWMove methodsFor: 'interface' stamp: 'DH 2/1/2007 22:16'!
perform
	"Throws the dices"
		
	1 to: (self getBaseDices size) do: [:index|
		self getBaseDices at: index put: (6 atRandom)].

	1 to: (self getTargetDices size) do: [:index|
		self getTargetDices at: index put: (6 atRandom)]! !

!DWMove methodsFor: 'wrappers' stamp: 'DH 12/23/2006 15:54'!
getBasePlayer
	^ self getBaseSector getOwner! !

!DWMove methodsFor: 'wrappers' stamp: 'DF 1/2/2007 12:25'!
getBaseSectorNumberOfDices
	^ self getBaseSector getNumberOfDices! !

!DWMove methodsFor: 'wrappers' stamp: 'DF 1/2/2007 12:24'!
getBaseSectorOwner
	^ self getBaseSector getOwner! !

!DWMove methodsFor: 'wrappers' stamp: 'DH 12/23/2006 15:54'!
getTargetPlayer
	^ self getTargetSector getOwner! !

!DWMove methodsFor: 'wrappers' stamp: 'DF 1/2/2007 12:16'!
getTargetPlayerSectors
	^ self getTargetSector getOwner getSectors! !

!DWMove methodsFor: 'wrappers' stamp: 'DF 1/2/2007 12:24'!
setBaseSectorNumberOfDices: anInt
	self getBaseSector setNumberOfDices: anInt! !

!DWMove methodsFor: 'wrappers' stamp: 'DF 1/5/2007 15:13'!
setTargetSectorNumberOfDices: anInt
	self getTargetSector setNumberOfDices: anInt! !

!DWMove methodsFor: 'wrappers' stamp: 'DF 1/5/2007 15:22'!
setTargetSectorOwnerAsBaseSectorOwner
	self getTargetSector setOwner: self getBaseSectorOwner! !

!DWMove methodsFor: 'derived' stamp: 'DH 12/23/2006 16:55'!
getNumberOfBaseDices
	^ self getBaseDices size! !

!DWMove methodsFor: 'derived' stamp: 'DH 12/23/2006 16:55'!
getNumberOfTargetDices
	^ self getTargetDices size! !

!DWMove methodsFor: 'testing' stamp: 'DH 12/23/2006 16:00'!
isSuccessful
	^ self getBaseDices sum > self getTargetDices sum! !


!DWMove class methodsFor: 'instance creation' stamp: 'DH 1/27/2007 19:22'!
from: aBaseSector
	^ self new
		setBaseSector: aBaseSector;
		setBaseDices: (Array new: aBaseSector getNumberOfDices)
		yourself! !

!DWMove class methodsFor: 'instance creation' stamp: 'DH 1/27/2007 19:22'!
from: aBaseSector to: aTargetSector
	^ (self from: aBaseSector)
		chooseTargetSector: aTargetSector;
		yourself! !


!DWPlayer methodsFor: 'private' stamp: 'DF 1/24/2007 19:12'!
countConnectedSectors: someSectors of: aSector
	"Counts recursively how many sectors of <someSectors> 
	are connected (inderectly) to <aSector>.
	Assumption: <aSector> is in <someSectors>"
	| count |

	someSectors remove: aSector.
	count := 1. "for the removed sector"
	
	(aSector getNeighbors) do: [:sector |
		(someSectors includes: sector)
			ifTrue: [count := count + (self countConnectedSectors: someSectors of: sector)]].
	^ count! !

!DWPlayer methodsFor: 'private' stamp: 'DH 2/1/2007 22:03'!
getDicesFromBuffer: anInt
	! !

!DWPlayer methodsFor: 'private' stamp: 'DF 1/24/2007 19:13'!
getNumberOfDices
	"Returns the total amount of dices of this player"

	^ self getSectors detectSum: [:sector |
			sector getNumberOfDices]! !

!DWPlayer methodsFor: 'private' stamp: 'DH 1/27/2007 18:40'!
makeMove
	
	^ self getAI findBestMoveDoing: [:base :target |
		self getGame
			selectBaseSector: base;
			selectTargetSector: target]! !

!DWPlayer methodsFor: 'private' stamp: 'DH 2/1/2007 22:11'!
setBufferTo: anInt
	"Sets the number of dices in the dice buffer. Assures 
	that does not contain more than 50 dices."
	
	anInt >50
		ifTrue: [
			self setBuffer: 50]
		ifFalse: [
			self setBuffer: anInt]! !

!DWPlayer methodsFor: 'accessing' stamp: 'DH 12/23/2006 14:55'!
getAI
	^ ai! !

!DWPlayer methodsFor: 'accessing' stamp: 'DF 12/27/2006 14:49'!
getBuffer
	^ buffer! !

!DWPlayer methodsFor: 'accessing' stamp: 'DH 12/13/2006 14:45'!
getColor
	^ color! !

!DWPlayer methodsFor: 'accessing' stamp: 'DH 12/23/2006 18:43'!
getGame
	^ game! !

!DWPlayer methodsFor: 'accessing' stamp: 'DF 12/27/2006 14:52'!
getSectors
	^ sectors! !

!DWPlayer methodsFor: 'accessing' stamp: 'DH 12/23/2006 14:51'!
setAI: anIA
	ai := anIA! !

!DWPlayer methodsFor: 'accessing' stamp: 'DF 12/27/2006 14:50'!
setBuffer: anInt
	buffer := anInt! !

!DWPlayer methodsFor: 'accessing' stamp: 'DF 12/27/2006 14:51'!
setColor: aColor
	color := aColor! !

!DWPlayer methodsFor: 'accessing' stamp: 'DF 12/27/2006 14:51'!
setGame: aGame
	game := aGame! !

!DWPlayer methodsFor: 'accessing' stamp: 'DF 12/27/2006 14:59'!
setSectors: aSet
	sectors := aSet! !

!DWPlayer methodsFor: 'initialization' stamp: 'DF 1/3/2007 20:31'!
initialize
	super initialize.
	self reset! !

!DWPlayer methodsFor: 'testing' stamp: 'DF 1/4/2007 12:43'!
isActive
	^ self getNumberOfSectors ~= 0! !

!DWPlayer methodsFor: 'testing' stamp: 'DH 12/23/2006 14:55'!
isComputerPlayer
	^ self getAI notNil! !

!DWPlayer methodsFor: 'testing' stamp: 'DH 2/4/2007 00:04'!
isCurrentPlayer
	^ self == self getGame getCurrentPlayer! !

!DWPlayer methodsFor: 'testing' stamp: 'DH 12/23/2006 14:52'!
isHumanPlayer
	^ self isComputerPlayer not! !

!DWPlayer methodsFor: 'testing' stamp: 'DH 2/1/2007 13:49'!
isRemovable
	
	^ self getGame getNumberOfPlayers > 2
		and: [self getGame isOver]
		and: [self getGame getNumberOfHumanPlayers > 1
			or: [self isComputerPlayer]]! !

!DWPlayer methodsFor: 'testing' stamp: 'DH 1/31/2007 16:45'!
typeIsChangeable
	"Returns true if the type of this player is changeable,
	otherwise false."

	^ (self getGame isOver				"Either the game is not running..."
		or: [self isCurrentPlayer not		"... or the player isn't the current player..."
			and: [self isActive]])			"... and is still in the game."
		and: [self isComputerPlayer		"Additionally, there has to be at least one human player"
			or: [self getGame getNumberOfHumanPlayers >= 2]]
		! !

!DWPlayer methodsFor: 'public' stamp: 'MP 2/1/2007 23:31'!
getDiceImage
	^ DWGUI diceImage: self getColor! !

!DWPlayer methodsFor: 'dices' stamp: 'DH 1/21/2007 22:18'!
addDicesToRandomSectors: anInt
	"Distributes the specified amount of dices to this players sectors which do
	not already have eight dices. Returns how many dices have actually been assigned."

	| sector emptySlots dices |

	"Compute how many dices will actually get distributed"
	emptySlots := self getFreeDiceSlots.
	dices := 
		anInt < emptySlots
			ifTrue: [
				anInt]
			ifFalse: [
				emptySlots].

	dices timesRepeat: [
		sector := self getSectors atRandom.
		[sector addDice] whileFalse: [
			sector := self getSectors atRandom]].

	^ dices
	! !

!DWPlayer methodsFor: 'dices' stamp: 'DH 2/1/2007 22:11'!
assignDices
	"Distributes dices at the end of the turn"
	| dices |

	dices := self getNumberOfConnectedSectors + self getBuffer.

	"Assign dices amd add remaining ones to the buffer"
	self setBufferTo: dices - (self addDicesToRandomSectors: dices).	
	
	self redrawAllSectors! !

!DWPlayer methodsFor: 'dices' stamp: 'DH 1/21/2007 22:16'!
getFreeDiceSlots
	"Returns how many dices can maximally distributed"
	
	^ 8* (self getNumberOfSectors) - (self getNumberOfDices)! !

!DWPlayer methodsFor: 'sectors' stamp: 'DF 1/3/2007 12:31'!
addSector: aSector
	"Stores the sector in the sector array of the player"

	self getSectors add: aSector! !

!DWPlayer methodsFor: 'sectors' stamp: 'DF 1/24/2007 19:20'!
getNumberOfConnectedSectors
	"Finds the largest connected block of sectors of this player and 
	returns the number of sectors in it."
	| sectorsLeft count maxCount |

	sectorsLeft := self getSectors copy asSet.
	maxCount := 0.

	[sectorsLeft size > maxCount] whileTrue: [
		count := self countConnectedSectors: sectorsLeft of: sectorsLeft anyOne.
		(count > maxCount)
			ifTrue: [maxCount := count]].

	^ maxCount! !

!DWPlayer methodsFor: 'sectors' stamp: 'DH 2/1/2007 13:48'!
getNumberOfSectors
	
	^self getSectors size! !

!DWPlayer methodsFor: 'sectors' stamp: 'DH 1/27/2007 19:00'!
redrawAllSectors
	"Redraws all sectors of this player"

	self sectorsDo: [: sector |
		sector redraw]! !

!DWPlayer methodsFor: 'sectors' stamp: 'DH 1/27/2007 19:01'!
removeSector: aSector
	"Removes the sector from the sector array"

	self getSectors remove: aSector! !

!DWPlayer methodsFor: 'sectors' stamp: 'DF 12/27/2006 14:55'!
sectorsDo: aBlock
	self getSectors do: [:sector |
		aBlock value: sector]! !

!DWPlayer methodsFor: 'type' stamp: 'DH 2/1/2007 13:48'!
becomeComputerPlayer
	
	self setAI: (DWPlayerAI game: self getGame player: self)! !

!DWPlayer methodsFor: 'type' stamp: 'DH 2/1/2007 13:48'!
becomeHumanPlayer
	
	self setAI: nil! !

!DWPlayer methodsFor: 'type' stamp: 'DH 1/31/2007 17:31'!
changeType
	
	(self getGame isOver
		or: [self isCurrentPlayer not
			and: [self isActive]])
				ifTrue: [
					self isComputerPlayer
						ifTrue: [
							self becomeHumanPlayer]
						ifFalse: [
							self getGame getNumberOfHumanPlayers >= 2
								ifTrue: [	"There has to be at least one human player"
									self becomeComputerPlayer]]]! !

!DWPlayer methodsFor: 'misc' stamp: 'DH 2/9/2007 17:42'!
changeColor
	
	self getGame playerColorIsChangeable
		ifFalse: [ ^ self ].

	self setColor: 
		(self getGame changeColor: 
			(self getColor))! !

!DWPlayer methodsFor: 'misc' stamp: 'DH 2/1/2007 13:47'!
doSomething
	"make some moves"

	| done duration |
	done := false.

	[done 
		or: [self getGame isOver]]
			whileFalse: [
				duration := Time millisecondsToRun: [
					done := self makeMove not].

				"if the move was very fast, we wait a little"
				duration < 500
					ifTrue: [
						(Delay forMilliseconds: (500 - duration)) wait]].

	self getGame endTurn! !

!DWPlayer methodsFor: 'misc' stamp: 'DF 1/3/2007 20:30'!
reset
	sectors := Set new.
	buffer := 0.! !


!DWPlayer class methodsFor: 'instance creation' stamp: 'DH 1/27/2007 19:22'!
game: aGame color: aColor
	^ self new
		setColor: aColor;
		setGame: aGame;
		becomeHumanPlayer;
		yourself! !


!DWPlayerAI methodsFor: 'private' stamp: 'DH 1/27/2007 18:37'!
allPromisingMovesDo: aBlock
	"Generates a list of promising moves (possible moves which will probably succeed)
	and applies <aBlock> to them."

	self getPlayer sectorsDo: [:sector |
		sector neighborsDo: [:neighbor |
			(self getPlayer ~= neighbor getOwner 		"filter out own sectors as targets"
				and: [
					sector getNumberOfDices > 1			"filter out basesectors with only one dice"
						and: [
							sector getNumberOfDices >= neighbor getNumberOfDices	]])	"filter out targets with too much dices"
								ifTrue: [
									aBlock value: sector value: neighbor]]]! !

!DWPlayerAI methodsFor: 'private' stamp: 'DH 1/30/2007 16:41'!
computeOwnPower
	"Computes the power of the player compared to the strongest player.
	Returns a value indicating the players power in [0; 30] where 30 is the strongest player."

	| value mostSectors mostConnectedSectors mostDices 
		ownSectors ownConnectedSectors ownDices |
	mostSectors := mostConnectedSectors := mostDices := 0.

	self getGame playersDo: [:aPlayer |
		aPlayer == self getPlayer
			ifTrue: [
				ownSectors := aPlayer getNumberOfSectors.
				ownConnectedSectors := aPlayer getNumberOfConnectedSectors.
				ownDices := aPlayer getNumberOfDices]
			ifFalse: [
				(value := aPlayer getNumberOfSectors)  > mostSectors 
					ifTrue: [
						mostSectors := value].
				(value := aPlayer getNumberOfConnectedSectors)  > mostConnectedSectors 
					ifTrue: [
						mostConnectedSectors := value].
				(value := aPlayer getNumberOfDices)  > mostDices
					ifTrue: [
						mostDices := value]]].

	^ (		(ownSectors >= mostSectors
				ifTrue: [1]
				ifFalse: [ownSectors / mostSectors]) 
		+ 	(ownConnectedSectors >= mostConnectedSectors
				ifTrue: [1]
				ifFalse: [ownConnectedSectors / mostConnectedSectors]) 
		+ 	(ownDices >= mostDices
			ifTrue: [1]
			ifFalse: [ownDices / mostDices])) *10! !

!DWPlayerAI methodsFor: 'private' stamp: 'DH 1/30/2007 16:37'!
computeRecursionDepth
	
	| possibilities |
	possibilities := 0.

	self allPromisingMovesDo: [:base :target |
		possibilities := possibilities + 1].

	self setDepth: (self class recursionDepthFor: possibilities)! !

!DWPlayerAI methodsFor: 'private' stamp: 'DH 2/1/2007 22:32'!
computeSectorEndangering
	"Counts for all own sectors the number of other players sectors
	which endanger them. Returns the total amount of endangerments.
	A lower number indicates a good situation."

	| endangeredSectors count |
	count := 0.

	self getGame sectorsDo: [:sector |
		sector getOwner ~=  self getPlayer
			ifTrue: [
				endangeredSectors := self getAllEndangeredSectorsBy: sector.
				count := count + (endangeredSectors size)]].
	^ count! !

!DWPlayerAI methodsFor: 'private' stamp: 'DH 1/21/2007 20:06'!
evalMoveFrom: aBaseSector to: aTargetSector atDepth: anInt withOdds: aFloat
	"Simulates the move and possible following moves; returns
	the evaluation for the best situation which can be reached that way."
	
	| move evaluation odds |
	move := DWMove from: aBaseSector to: aTargetSector.
	move makeSuccessful. "we want the move to succeed"
	odds := aFloat * (self oddsForMoveFrom: aBaseSector to: aTargetSector).

	self getGame
		simulate: move
		during: [
			evaluation := self 
				findBestSubsequentSituationAtDepth: anInt
				withOdds: odds].

	^ evaluation! !

!DWPlayerAI methodsFor: 'private' stamp: 'DH 2/1/2007 22:42'!
evaluateCurrentSituation

	| evaluation |
	evaluation := 
		-1 * (self computeSectorEndangering)
		+ (self getPlayer getNumberOfSectors) *0.5
		+ (self getPlayer getNumberOfConnectedSectors) *2
		+ (self computeOwnPower).

	^ evaluation! !

!DWPlayerAI methodsFor: 'private' stamp: 'DH 2/1/2007 22:42'!
findBestSubsequentSituationAtDepth: anInt withOdds: aFloat
	"Evaluates the improvability of the current situation. 
	Returns the evaluation of the best possible subsequent situation
	(limited by the recursion depth).
	If no approvement can by achieved the evaluation of the current 
	situation is being returned."
	
	| evaluation bestMoveEval |
	bestMoveEval := aFloat * (self evaluateCurrentSituation).
	
	anInt >= (self getDepth)
		ifTrue: [
			^ bestMoveEval].

	self allPromisingMovesDo: [:base :target |
		evaluation := self 
			evalMoveFrom: base 
			to: target
			atDepth: (anInt + 1)
			withOdds: aFloat.
		evaluation > bestMoveEval
			ifTrue: [
				bestMoveEval := evaluation]].
			
	^ bestMoveEval! !

!DWPlayerAI methodsFor: 'private' stamp: 'DH 1/30/2007 17:27'!
getAggressivenessFactor
	"This function computes a factor for the aggressiveness in [0; 1]
	which needs to be adjusted to the current situation "

	| factor |

	"Always attack if all dices will be filled up"
	(self getPlayer getBuffer + self getPlayer getNumberOfConnectedSectors)
			>= (self getPlayer getFreeDiceSlots)
				ifTrue: [
					^ 0].	

	factor := self class aggressiveness.
	factor := factor 
		* (0.4 / (self getGame class maxPlayers))
		* (self getGame getNumberOfActivePlayers) 
		+ 0.6.

	self assert: factor <= 1.
	self assert: factor >= 0.

	^ factor! !

!DWPlayerAI methodsFor: 'private' stamp: 'DH 12/26/2006 21:39'!
getAllEndangeredSectorsBy: aSector
	"Computes a set of sectors owned by the player which are directly 
	or indirectly endangered by the given other players sector."

	| sectors |
	sectors := Set new.

	self 
		getAllSectorsInRangeOf: aSector 
		from: (aSector getOwner) 
		with: (aSector getNumberOfDices)
		notIn: sectors.

	^ sectors reject: [:sector |
		sector getOwner ~= self getPlayer] 
	! !

!DWPlayerAI methodsFor: 'private' stamp: 'DH 1/27/2007 18:39'!
getAllSectorsInRangeOf: aSector from: aPlayer with: anInt notIn: someSectors
	"Returns all sectors which are in range of a given sector if that sector
	would be owned by a special player with a given amount of dices.
	Note that also other players sectors will be returned."

	someSectors add: aSector.

	(anInt = 1) ifTrue: [^ self].
	
	aSector neighborsDo: [:neighbor |
		((someSectors includes: neighbor) not 	"sector already done"
			and: [
				neighbor getOwner ~= aPlayer		"can't move on own sectors"
					and: [
						neighbor getNumberOfDices < anInt]])	"assumption: sector must have less dices"
							ifTrue: [
								self 
									getAllSectorsInRangeOf: neighbor 
									from: aPlayer 
									with: (anInt - 1) 
									notIn: someSectors]].
			! !

!DWPlayerAI methodsFor: 'private' stamp: 'DH 1/27/2007 18:39'!
oddsForMoveFrom: aBaseSector to: aTargetSector
	"Returns, in percent, how likely it is that a move will succeed"
	
	^ self class
		oddsFor: (aBaseSector getNumberOfDices)
		vs: (aTargetSector getNumberOfDices)! !

!DWPlayerAI methodsFor: 'interface' stamp: 'DH 1/30/2007 17:16'!
findBestMoveDoing: aBlock
	"Finds the move which can most likely improve the current situation
	the most."

	| currentEvaluation evaluation bestMoveBase bestMoveTarget bestMoveEval |
	currentEvaluation := self evaluateCurrentSituation.
	bestMoveEval := currentEvaluation
		* (self getAggressivenessFactor).
	
	self computeRecursionDepth.

	self allPromisingMovesDo: [:base :target |
		evaluation := self 
			evalMoveFrom: base 
			to: target 
			atDepth: 0
			withOdds: 1.
		(evaluation >= bestMoveEval) ifTrue: [
			bestMoveEval := evaluation.
			bestMoveBase := base.
			bestMoveTarget := target]].
		
	(bestMoveBase) ifNil: [^ false ].
	aBlock value: bestMoveBase value: bestMoveTarget.
	^ true! !

!DWPlayerAI methodsFor: 'accessing' stamp: 'DH 1/3/2007 11:33'!
getDepth
	^ depth! !

!DWPlayerAI methodsFor: 'accessing' stamp: 'DH 12/23/2006 14:42'!
getGame
	^ game! !

!DWPlayerAI methodsFor: 'accessing' stamp: 'DH 12/23/2006 14:42'!
getPlayer
	^ player! !

!DWPlayerAI methodsFor: 'accessing' stamp: 'DH 1/3/2007 11:32'!
setDepth: anInt
	depth := anInt! !

!DWPlayerAI methodsFor: 'accessing' stamp: 'DH 12/23/2006 14:42'!
setGame: aGame
	game := aGame! !

!DWPlayerAI methodsFor: 'accessing' stamp: 'DH 12/23/2006 14:41'!
setPlayer: aPlayer
	player := aPlayer! !


!DWPlayerAI class methodsFor: 'instance creation' stamp: 'DH 1/21/2007 20:20'!
game: aGame player: aPlayer
	^ self new
		setGame: aGame;
		setPlayer: aPlayer;
		yourself! !

!DWPlayerAI class methodsFor: 'constants' stamp: 'DH 1/30/2007 16:46'!
aggressiveness
	"The base aggressiveness of all computer players. Must be a number in [0; 1], where
	0 means the computer will always attack while 1 means it will almost never attack.
	Default is 0.55"

	^ 0.55! !

!DWPlayerAI class methodsFor: 'constants' stamp: 'DH 1/9/2007 13:02'!
oddsFor: anInt vs: anotherInt
	"Taken from: http://joerg.ludwig.hvf-bs.net/dicewars.html"
	^ ({{0.42. 0.09. 0.01. 0. 0. 0. 0. 0}.
		{0.84. 0.44. 0.15. 0.04. 0.01. 0. 0. 0}.
		{0.97. 0.78. 0.45. 0.19. 0.06. 0.01. 0. 0}.
		{1. 0.94. 0.74. 0.46. 0.22. 0.08. 0.03. 0.01}.
		{1. 0.99. 0.91. 0.72. 0.46. 0.24. 0.10. 0.04}.
		{1. 1. 0.98. 0.88. 0.70. 0.47. 0.26. 0.12}.
		{1. 1. 0.99. 0.96. 0.86. 0.69. 0.47. 0.27}.
		{1. 1. 1. 0.99. 0.95. 0.84. 0.67. 0.47}} at: anInt) at: anotherInt! !

!DWPlayerAI class methodsFor: 'constants' stamp: 'DH 1/30/2007 15:34'!
recursionDepthFor: anInt
	"Returns the recursion depth for a specific
	amount of move possibilities"
	
	anInt > 10			" > 10"
		ifTrue: [^ 1].
	anInt > 7				" 9 - 8"
		ifTrue: [^ 2].
	anInt > 4				" 7 - 5"
		ifTrue: [^ 3].
	anInt > 2				" 4 - 3"
		ifTrue: [^ 4].
	anInt = 2				" 2 "
		ifTrue: [^ 6].
	^ 8					" 1 "! !


!DWSector methodsFor: 'event handling' stamp: 'DH 11/27/2006 12:09'!
handlesMouseDown: evt
	^ true! !

!DWSector methodsFor: 'event handling' stamp: 'DF 12/27/2006 15:11'!
mouseDown: evt
	
	self getGame selectSector: self! !

!DWSector methodsFor: 'initialization' stamp: 'MP 1/25/2007 17:33'!
initialize

	super initialize.
	self setNumDices: 0.

	"Load style from the game"
	(game notNil) ifTrue: [
		self borderWidth: (DWGUI widthSectorBorder)]! !

!DWSector methodsFor: 'initialization' stamp: 'DH 1/4/2007 00:06'!
initWithShape: anArray game: aGame
	
	^ self 
		setGame: aGame;
		initialize;
		setVertices: anArray;
		yourself! !

!DWSector methodsFor: 'accessing' stamp: 'DF 12/27/2006 15:09'!
getCurrentOwner
	^currentOwner! !

!DWSector methodsFor: 'accessing' stamp: 'DF 12/27/2006 15:10'!
getDices
	^dices! !

!DWSector methodsFor: 'accessing' stamp: 'DF 12/27/2006 15:10'!
getGame
	^game! !

!DWSector methodsFor: 'accessing' stamp: 'DF 12/27/2006 15:09'!
getNeighbors
	^neighbors! !

!DWSector methodsFor: 'accessing' stamp: 'DF 12/27/2006 15:10'!
getNumDices
	^numDices! !

!DWSector methodsFor: 'accessing' stamp: 'DF 12/27/2006 15:45'!
setCurrentOwner: aPlayer
	currentOwner := aPlayer! !

!DWSector methodsFor: 'accessing' stamp: 'DF 12/27/2006 15:14'!
setDices: aCollection
	dices := aCollection! !

!DWSector methodsFor: 'accessing' stamp: 'DF 12/27/2006 15:27'!
setGame: aGame
	game := aGame! !

!DWSector methodsFor: 'accessing' stamp: 'DH 11/26/2006 20:51'!
setNeighbors: neighs
	neighbors := neighs! !

!DWSector methodsFor: 'accessing' stamp: 'DF 12/27/2006 15:12'!
setNumDices: anInt
	numDices := anInt! !

!DWSector methodsFor: 'visual' stamp: 'MP 1/25/2007 17:32'!
highlight
	"Highlightet den Sektor indem er schwarz gefärbt wird"
	
	self color: (DWGUI colorHighlightedSector)! !

!DWSector methodsFor: 'visual' stamp: 'DH 1/4/2007 15:17'!
redraw
	"set color"
	self unHighlight.
	
	(1 to: 8) do: [:index |
		(dices at: index)
			visible: (index <= self getNumDices);
			image: (self getCurrentOwner getDiceImage)]! !

!DWSector methodsFor: 'visual' stamp: 'MP 1/25/2007 17:33'!
unHighlight
	"Setzt wieder die ursprüngliche Farbe des Sektors"
	
	self 
		color: self getCurrentOwner getColor;
		borderColor: (DWGUI colorSectorBorder)! !

!DWSector methodsFor: 'dices' stamp: 'DH 1/4/2007 00:15'!
addDice

	(self getNumDices >= 8) ifTrue: [^ false].
	self setNumDices: (numDices + 1).
	^ true! !

!DWSector methodsFor: 'dices' stamp: 'DH 12/16/2006 01:20'!
getNumberOfDices
	"Liefert die Anzahl der in diesem Sektor stehenden Würfel"
	^ numDices! !

!DWSector methodsFor: 'dices' stamp: 'DH 1/3/2007 23:49'!
setNumberOfDices: anInt
	
	((anInt <= 8) & (anInt >= 1)) ifFalse: [^ false].
	self setNumDices: anInt! !

!DWSector methodsFor: 'owner' stamp: 'DF 12/27/2006 15:09'!
getOwner
	^currentOwner! !

!DWSector methodsFor: 'owner' stamp: 'DH 2/1/2007 22:15'!
setOwner: aPlayer
	"Setzt <aPlayer> als den neuen Besitzer des Sektors und färbt den Sektor mit der Farbe des Spielers"

	self getCurrentOwner ifNotNilDo: [:cOwner |
		cOwner removeSector: self].
	aPlayer addSector: self.
	
	self setCurrentOwner: aPlayer! !

!DWSector methodsFor: 'neighbors' stamp: 'DF 12/27/2006 15:21'!
isNeighborOf: aSector
	"Liefert true, falls der Sektor mit dem in <sector> übergeben Sektor benachbart ist, sonst false"

	^ self getNeighbors includes: aSector! !

!DWSector methodsFor: 'neighbors' stamp: 'DF 12/27/2006 15:22'!
isNotEncircledByOwnSectors
	"Liefert true, falls der Sektor nicht nur von eigenen Sectoren umgeben ist"

	self getNeighbors do: [ :sec |
		(self getOwner = sec getOwner) ifFalse: [ ^true ] ].
	^false! !

!DWSector methodsFor: 'neighbors' stamp: 'DF 12/27/2006 15:23'!
neighborsDo: aBlock

	self getNeighbors do: [:neighbor |
		aBlock value: neighbor]! !


!DWSector class methodsFor: 'instance creation' stamp: 'DH 1/4/2007 00:02'!
createFromShape: anArray game: aGame

	^ self basicNew initWithShape: anArray game: aGame! !


!DWSectorMaker methodsFor: 'growing' stamp: 'DH 1/2/2007 16:53'!
addField: aPoint
	"adds a field to this sector maker"

	mapMaker gridAt: aPoint set: self.	"register at grid"
	self getFields add: aPoint! !

!DWSectorMaker methodsFor: 'growing' stamp: 'DH 2/2/2007 00:06'!
growBy: anInt
	"Lets this sector maker grow by <anInt> fields."

	| neighborFields |
	neighborFields := self getEmptyNeighborFields.

	(neighborFields isEmpty) ifTrue: [
		self canGrowFalse.
		^ false].

	((self getMapMaker class sectorsGrowFieldsAtATime > (neighborFields size))	"figure out by how many fields this sector maker can grow"
		ifTrue: [neighborFields size] 	"too less neighbor fields"
		ifFalse: [self getMapMaker class sectorsGrowFieldsAtATime])		
			timesRepeat: [self addField: (neighborFields remove: neighborFields atRandom)].

	^ true! !

!DWSectorMaker methodsFor: 'neighbor related' stamp: 'DH 1/3/2007 15:09'!
canReach: someSectors withoutUsing: someOtherSectors
	"Returns true if it is possible for this sector to reach all sectors specified
	in <someSectors> without using all sectors specified in <someOtherSectors>."

	someSectors removeAllFoundIn: (self getNeighbors).	
	(someSectors isEmpty) 
		ifTrue: [ ^ true ]. 				"all target sectors reached"
	someOtherSectors add: self.

	self getNeighbors do: [:neighbor |
		(someOtherSectors includes: neighbor) ifFalse: [
			^ neighbor canReach: someSectors withoutUsing: someOtherSectors]].

	^ false! !

!DWSectorMaker methodsFor: 'neighbor related' stamp: 'DH 1/3/2007 16:04'!
computeNeighborSectors
	"Computes all neighbor sectors"

	self setNeighbors: Set new.

	(self getNeighborFields) do: [:neighborField |
		self getNeighbors add: (self getMapMaker gridAt: neighborField)]! !

!DWSectorMaker methodsFor: 'neighbor related' stamp: 'DH 1/3/2007 15:08'!
isBottleNeck
	"Tells if this sector is a bottleneck. The algorithm works as follows:
	If it is possible for a random neighbor sector to reach all other
	neighbor sectors without using this sector, then this sector is no bottleneck."
	| targetSectors baseSector |

	targetSectors := self getNeighbors copy.
	baseSector := targetSectors remove: (targetSectors anyOne).

	^ (baseSector 
			canReach: targetSectors 
			withoutUsing: ((Set new) add: self; yourself)) not! !

!DWSectorMaker methodsFor: 'neighbor related' stamp: 'DH 1/2/2007 17:08'!
removeNeighbor: aSector
	self getNeighbors remove: aSector! !

!DWSectorMaker methodsFor: 'neighbor related' stamp: 'DH 1/2/2007 17:16'!
unlinkSelf
	"Deletes all neighbor references to this sector"
	
	self getNeighbors do: [:neighbor |
		neighbor removeNeighbor: self]! !

!DWSectorMaker methodsFor: 'transformation' stamp: 'DH 2/9/2007 17:26'!
makeSector
	"Returns a complete sector."
	| shape mergeHex |

	shape := DWHexagon createAtField: origin.
	mergeHex := DWHexagon createAtField: origin.
	
	"merge all fields"
	fields do: [:field |
		mergeHex moveToPosition: field.
		"Since PolygonMorph>>merge: sometimes doesn't work, 
		here's a little workaround to fix this problem:
		We rotate the vertices of both Morphs until we can successfully merge them."
		(shape merge: mergeHex) ifNil:  [
			shape rotateVerticesBy: 2.
			mergeHex rotateVerticesBy: 2.
			shape merge: mergeHex]] without: origin.

	"create sector and add dices to it"
	^ self addDicesTo: 
		((DWSector createFromShape: (shape vertices) game: (mapMaker getGame))
			setNeighbors: neighbors;
			yourself)
! !

!DWSectorMaker methodsFor: 'private' stamp: 'MP 2/1/2007 23:33'!
addDicesTo: aSector
	"Adds dices to a sector"
	| dicePosition dices |

	dicePosition := (DWHexagon relativePositionOf: (self getOrigin)) - (0@24).
	dices := OrderedCollection new: 8.

	(1 to: 8) do: [:position |
		aSector addMorph: 
			(dices addLast: (
					((DWGUI diceImage: (DWGUI colorPlayer: 1)) asMorph)
						position: dicePosition 
							+ ((position < 5)
								ifTrue: [-8 @ (11*(4-position) - 2)]
								ifFalse: [8 @ (11*(8-position) + 2)]);
						openInWorld;
						visible: false;
						yourself))].

	^ aSector setDices: dices! !

!DWSectorMaker methodsFor: 'private' stamp: 'DH 1/3/2007 16:02'!
getEmptyNeighborFields
	
	| neighborFields |

	neighborFields := Set new.

	self getFields do: [:field |
		(self getMapMaker gridEmptyNeighborFieldsOf: field) do: [:neighborField |
			neighborFields add: neighborField]].

	^ neighborFields! !

!DWSectorMaker methodsFor: 'private' stamp: 'DH 1/3/2007 16:02'!
getNeighborFields
	
	| neighborFields |

	neighborFields := Set new.

	self getFields do: [:field |
		(self getMapMaker gridNeighborFieldsOf: field) do: [:neighborField |
			((mapMaker gridAt: neighborField) == self) ifFalse: [
				neighborFields add: neighborField]]].

	^ neighborFields! !

!DWSectorMaker methodsFor: 'private' stamp: 'DH 1/3/2007 16:02'!
setUp
	"Selects a random field as origin"

	self setFields: OrderedCollection new.
	self canGrowTrue.

	"Find a field with six empty neighbor fields"
	self setOrigin: 0 @ 0.
	[6 == (self getMapMaker gridEmptyNeighborFieldsOf: self getOrigin) size] whileFalse:
			[self setOrigin: (mapMaker getSize x atRandom) @ (mapMaker getSize y atRandom)].

	"Add fields to the sector maker"
	self addField: self getOrigin.
	(self getMapMaker gridNeighborFieldsOf: self getOrigin) do: [:field |
		self addField: field]

	! !

!DWSectorMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 16:39'!
canGrow
	"Tells if this sector maker can grow any more fields.
	That is, if there are empty fields in the neighborhood."

	^ canGrow! !

!DWSectorMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 16:49'!
canGrowFalse
	canGrow := false! !

!DWSectorMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 16:49'!
canGrowTrue
	canGrow := true! !

!DWSectorMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 16:51'!
getFields
	^ fields! !

!DWSectorMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 16:48'!
getMapMaker
	^ mapMaker! !

!DWSectorMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 16:51'!
getNeighbors
	^ neighbors! !

!DWSectorMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 16:50'!
getOrigin
	^ origin! !

!DWSectorMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 16:50'!
setFields: aSet
	fields := aSet! !

!DWSectorMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 16:48'!
setMapMaker: aMapMaker
	mapMaker := aMapMaker! !

!DWSectorMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 16:51'!
setNeighbors: aSet
	neighbors := aSet! !

!DWSectorMaker methodsFor: 'accessing' stamp: 'DH 1/2/2007 16:50'!
setOrigin: aPoint
	origin := aPoint! !


!DWSectorMaker class methodsFor: 'instance creation' stamp: 'DH 1/27/2007 19:21'!
new: aMapMaker
	^ self new
		setMapMaker: aMapMaker;
		setUp;
		yourself! !

